<?php
/**
 * CadbancoForm Form
 * @author  <your name here>
 */
class CadbancoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadbanco');
        $this->form->setFormTitle('Cadbanco');
        

        // create the form fields
        $id = new TEntry('id');
        $banco = new TEntry('banco');
        $nrbanco = new TEntry('nrbanco');
        $ativo = new TCheckGroup('ativo');

        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items);
        
        // add the fields
        $this->form->addFields( [ new TLabel('Código') ], [ $id,$ativo ] );
        $this->form->addFields( [ new TLabel('Banco') ], [ $banco ] );
        $this->form->addFields( [ new TLabel('Nr. Banco') ], [ $nrbanco ] );

        $banco->addValidation('Banco', new TRequiredValidator);
        $nrbanco->addValidation('Nr. Banco', new TRequiredValidator);


        // set sizes
        $id->setSize('20%');
        $banco->setSize('50%');
        $nrbanco->setSize('50%');
        $ativo->setSize('50%');



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addAction(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadbancoList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
         $container->add(new TXMLBreadCrumb('menu.xml', 'CadbancoList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Cadbanco;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $ativo = $data->ativo;
            if ( !empty($ativo))
            {
                $object->ativo = 'S';
            }
            else { $object->ativo = 'N'; }            
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadbanco($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                $obj = new StdClass;
                $obj->ativo = $object->ativo;
                TForm::sendData('form_Cadbanco', $obj);                  
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
