<?php
/**
 * CadcaixaForm Form
 * @author  <your name here>
 */
class CadcaixaForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadcaixa');
        $this->form->setFormTitle('Caixa');
        
        TTransactionSession::open();

        // create the form fields
        $id = new TEntry('id');
        $caixa = new TEntry('caixa');
        //$cadempresa_id = new TDBUniqueSearch('cadempresa_id', 'goldnotas', 'Cadempresa', 'id', 'empresa');
        $cadempresa_id = new THidden('cadempresa_id');
        $ativo = new TCheckGroup('ativo');
        $cadcentrocusto_id = new TDBUniqueSearch('cadcentrocusto_id', 'goldnotas', 'Cadcentrocusto', 'id', 'centrocusto');
        $cadplanoconta_id = new TDBUniqueSearch('cadplanoconta_id', 'goldnotas', 'Cadplanoconta', 'id', 'planoconta');
        //$ativo->setSize('100%');
        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items);

        // add the fields
        $this->form->addFields( [ new TLabel('Código') ], [ $id,$ativo] );
        $this->form->addFields( [ new TLabel('Caixa') ], [ $caixa] );
        $this->form->addFields( [ $cadempresa_id ] );
        //$this->form->addFields( [ $tipo ] );
        
        $this->form->addFields( [ new TLabel('Centro de Custo') ], [ $cadcentrocusto_id ] );
        $this->form->addFields( [ new TLabel('Plano de Contas') ], [ $cadplanoconta_id ] );
        $caixa->addValidation('Caixa', new TRequiredValidator);
        //userunitid
        $userunitid = TSession::getValue('userunitid');
        $cadempresa_id->setValue($userunitid);
        // set sizes
        $id->setSize('20%');
        $caixa->setSize('50%');

        $ativo->setSize('100%');        
        $cadcentrocusto_id->setSize('50%');
        $cadcentrocusto_id->setMask('{id} - {centrocusto}');
        $cadplanoconta_id->setSize('50%');
        $cadplanoconta_id->setMask('{id} - {planoconta}');



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addAction(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadcaixaList','onReload')), 'fa:table blue');
               
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadcaixaList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Cadcaixa;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data    
            
            $ativo = $data->ativo;
            if ( !empty($ativo))
            {
                $object->ativo = 'S';
            }
            else { $object->ativo = 'N'; }
                                
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadcaixa($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                $obj = new StdClass;
                $obj->ativo = $object->ativo;
                TForm::sendData('form_Cadcaixa', $obj);                   
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
                $obj = new StdClass;
                $obj->ativo = 'S';
                TForm::sendData('form_Cadcaixa', $obj);                 
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
