<?php
/**
 * CadcaixacontacorrenteForm Form
 * @author  <your name here>
 */
class CadcaixacontacorrenteForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadcaixacontacorrente');
        $this->form->setFormTitle('Caixa / Conta Banco');
        
        TTransaction::open('goldnotas');
        $idcaixacontacorrente = $param['id']??'';
        if ( !empty($idcaixacontacorrente))
        {            
            $objeto = new Cadcaixacontacorrente($idcaixacontacorrente);
            $caixabanco = $objeto->tipocaixabanco;
        }
        else
        {
            $caixabanco = $param['tipocaixabanco']??'C';        
        }
        TTransaction::close();
        // create the form fields
        $id = new TEntry('id');
        $pessoa = new TEntry('pessoa');
        //$cadempresa_id = new TDBUniqueSearch('cadempresa_id', 'goldnotas', 'Cadempresa', 'id', 'empresa');
        $cadempresa_id = new THidden('cadempresa_id');
        $tipo = new THidden('tipo');
        if ($caixabanco == 'B')
        {
            $nrcontacorrente = new TEntry('nrcontacorrente');
            $nragencia = new TEntry('nragencia');           
            $cadbanco_id = new TDBUniqueSearch('cadbanco_id', 'goldnotas', 'Cadbanco', 'id', 'banco');
        }
        $ativo = new TCheckGroup('ativo');
        $cc_cadcentrocusto_id = new TDBUniqueSearch('cc_cadcentrocusto_id', 'goldnotas', 'Cadcentrocusto', 'id', 'centrocusto');
        $cc_cadplanoconta_id = new TDBUniqueSearch('cc_cadplanoconta_id', 'goldnotas', 'Cadplanoconta', 'id', 'planoconta');
        
        $tipocaixabanco = new THidden('tipocaixabanco');
        $ecaixacontacorrente = new THidden('ecaixacontacorrente');
        
        $tipocaixabanco->setValue($caixabanco);
        $ecaixacontacorrente->setValue('S');
        
        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items);

        // add the fields
        $this->form->addFields( [$tipocaixabanco], [$ecaixacontacorrente]);
        
        $this->form->addFields( [ new TLabel('Código') ], [ $id,$ativo] );
        $this->form->addFields( [ new TLabel('Caixa / Conta Banco') ], [ $pessoa ] );
        $this->form->addFields( [ $cadempresa_id ] );
        //$this->form->addFields( [ $tipo ] );
        if ($caixabanco == 'B')
        {              
            $this->form->addFields( [ new TLabel('Nr. Conta Corrente') ], [ $nrcontacorrente ] );
            $this->form->addFields( [ new TLabel('Nr. Agencia') ], [ $nragencia ] );
            //$this->form->addFields( [ new TLabel('Nome Agencia') ], [ $nomeagencia ] );        
            $this->form->addFields( [ new TLabel('Cadbanco Id') ], [ $cadbanco_id ] );
        }
        $this->form->addFields( [ new TLabel('Centro de Custo') ], [ $cc_cadcentrocusto_id ] );
        $this->form->addFields( [ new TLabel('Plano de Contas') ], [ $cc_cadplanoconta_id ] );
        $pessoa->addValidation('Caixa / Conta corrente não informado', new TRequiredValidator);
        //userunitid
        $userunitid = TSession::getValue('userunitid');
        $cadempresa_id->setValue($userunitid);
        // set sizes
        $id->setSize('20%');
        if ($caixabanco == 'B')
        {   
            $nrcontacorrente->setSize('50%');
            $nragencia->setSize('50%');
            $cadbanco_id->setSize('50%');
            $cadbanco_id->setMask('{id} - {banco}');
        }
        $ativo->setSize('100%'); 
        $pessoa->setSize('50%');       
        $cc_cadcentrocusto_id->setSize('50%');
        $cc_cadcentrocusto_id->setMask('{id} - {centrocusto}');
        $cc_cadplanoconta_id->setSize('50%');
        $cc_cadplanoconta_id->setMask('{id} - {planoconta}');



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addAction(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadcaixacontacorrenteList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadcaixacontacorrenteList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Cadcaixacontacorrente;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data    
            
            $ativo = $data->ativo;
            if ( !empty($ativo))
            {
                $object->ativo = 'S';
            }
            else { $object->ativo = 'N'; }
            
            
                                
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadcaixacontacorrente($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                $obj = new StdClass;
                $obj->ativo = $object->ativo;
                TForm::sendData('form_Cadcaixacontacorrente', $obj);                   
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
