<?php
/**
 * CadcidadeList Listing
 * @author  <your name here>
 */
class CadcidadeList extends TStandardList
{
    protected $form;     // registration form
    protected $datagrid; // listing
    protected $pageNavigation;
    protected $formgrid;
    protected $deleteButton;
    protected $transformCallback;
    protected $arrayuf;
    
    /**
     * Page constructor
     */
    public function __construct()
    {
        parent::__construct();
        
        parent::setDatabase('goldnotas');            // defines the database
        parent::setActiveRecord('Cadcidade');   // defines the active record
        parent::setDefaultOrder('id', 'asc');         // defines the default order
        // parent::setCriteria($criteria) // define a standard filter

        parent::addFilterField('cidade', 'like', 'cidade'); // filterField, operator, formField
        parent::addFilterField('uf', 'like', 'uf'); // filterField, operator, formField
        
        // creates the form
        $this->form = new TQuickForm('form_search_Cadcidade');
        $this->form->class = 'tform'; // change CSS class
        $this->form = new BootstrapFormWrapper($this->form);
        $this->form->style = 'display: table;width:100%'; // change style
        $this->form->setFormTitle('Cadcidade');
        //$this->arrayuf = (array) s7sdiversos::listaufnome();
        //$this->arrayuf = s7sdiversos::listaufnome();

        // create the form fields
        $cidade = new TEntry('cidade');
        //$uf = new TEntry('uf');
        $uf = new TCombo('uf');
        
        //atributos
        $uf->addItems(s7sdiversos::listaufnome());

        // add the fields
        $this->form->addQuickField('Cidade', $cidade,  200 );
        $this->form->addQuickField('Estado', $uf,  200 );

        
        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue('Cadcidade_filter_data') );
        
        // add the search form actions
        $this->form->addQuickAction(_t('Find'), new TAction(array($this, 'onSearch')), 'fa:search');
        $this->form->addQuickAction(_t('New'),  new TAction(array('CadcidadeForm', 'onEdit')), 'bs:plus-sign green');
        
        // creates a DataGrid
        $this->datagrid = new TDataGrid;
        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_id = new TDataGridColumn('id', 'Id', 'right');
        $column_cidade = new TDataGridColumn('cidade', 'Cidade', 'left');
        $column_codibge = new TDataGridColumn('codibge', 'IBGE', 'left');
        $column_uf = new TDataGridColumn('nomeuf', 'Estado', 'left');
        $column_ativo = new TDataGridColumn('ativo', 'Ativo', 'left');


        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_id);
        $this->datagrid->addColumn($column_cidade);
        $this->datagrid->addColumn($column_codibge);
        $this->datagrid->addColumn($column_uf);
        $this->datagrid->addColumn($column_ativo);
        /**
        $column_uf->setTransformer( function($value, $object, $row) {
            //$class = ($value=='N') ? 'danger' : 'success';
            $label = $this->arrayuf[$value];
            $div = new TElement('span');
            //$div->class="label label-{$class}";
            //$div->style="text-shadow:none; font-size:12px; font-weight:lighter";
            $div->add($label);
            return $div;
        });        
        **/  
        $column_ativo->setTransformer( function($value, $object, $row) {
            $class = ($value=='N') ? 'danger' : 'success';
            $label = ($value=='N') ? _t('No') : _t('Yes');
            $div = new TElement('span');
            $div->class="label label-{$class}";
            $div->style="text-shadow:none; font-size:12px; font-weight:lighter";
            $div->add($label);
            return $div;
        });        

        
        // create EDIT action
        $action_edit = new TDataGridAction(array('CadcidadeForm', 'onEdit'));
        $action_edit->setUseButton(TRUE);
        $action_edit->setButtonClass('btn btn-default');
        //$action_edit->setLabel(_t('Edit'));                                 
        $action_edit->setImage('far:edit blue fa-lg');
        $action_edit->setField('id');
        $this->datagrid->addAction($action_edit);
        
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onDelete'));
        $action_del->setUseButton(TRUE);
        $action_del->setButtonClass('btn btn-default');
        //$action_del->setLabel(_t('Delete')); 
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('id');
        $this->datagrid->addAction($action_del);
        
        // create the datagrid model
        $this->datagrid->createModel();
        
        // create the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->setAction(new TAction(array($this, 'onReload')));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());
        


        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add(TPanelGroup::pack('Listagem de Cidade', $this->form));
        $container->add($this->datagrid);
        $container->add($this->pageNavigation);
        
        parent::add($container);
    }
    

}
