<?php
/**
 * CadempresaForm Form
 * @author  <your name here>
 */
class CadempresaForm extends TPage
{
    protected $form; // form   
    private   $frame;
    /**
     * Class constructor
     * Creates the page and the registration form
     */
    function __construct()
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadempresa');
        $this->form->setFormTitle('Empresa');
        
        // create the form fields
        $id = new TEntry('id');           
        $empresa = new TEntry('empresa');
        $fantasia = new TEntry('fantasia');
        $endereco = new TEntry('endereco');
        $numero = new TEntry('numero');
        $cep = new TEntry('cep');
        $bairro = new TEntry('bairro');
        $complemento = new TEntry('complemento');        
        $cadcidade_id = new TSeekButton('cadcidade_id');
        
        $obj = new SeekCidadeEmpresaCadastro;
        $action = new TAction(array($obj, 'onReload'));
        $cadcidade_id->setAction($action);        
        $cidade_uf_cadcidade = new TEntry('cidade_uf_cadcidade');        
        
        $telefone1 = new TEntry('telefone1');
        $telefone2 = new TEntry('telefone2');
        $cnae = new TEntry('cnae');
        $dtabertura = new TDate('dtabertura');
        $cnpj = new TEntry('cnpj');
        $inscricaoestadual = new TEntry('inscricaoestadual');
        $inscricaomunicipal = new TEntry('inscricaomunicipal');
        $atividademunicipal = new TEntry('atividademunicipal');
        $email = new TEntry('email');
        $website = new TEntry('website');
        $responsavel = new TEntry('responsavel');
        $eslogan = new TEntry('eslogan');
        $crt = new TCombo('crt');
        $aliquota_ipi = new TEntry('aliquota_ipi');
        $aliquota_iss = new TEntry('aliquota_iss');
        $aliquota_pis = new TEntry('aliquota_pis');
        $aliquota_cofins = new TEntry('aliquota_cofins');
        $ativo = new TCombo('ativo');
        $logo = new TFile('logo');
        $contador_cadpessoa_id = new TEntry('contador_cadpessoa_id');  

        
        //atributos
        
        
        // complete upload action
        $logo->setCompleteAction(new TAction(array($this, 'onComplete')));
        $logo->setAllowedExtensions( ['gif', 'png', 'jpg', 'jpeg'] );        
 
        // define the sizes
        $id->setEditable(false);
        
        $id->setSize('10%');  
        $empresa->setSize('100%');
        $fantasia->setSize('100%');
        $cnpj->setSize('100%');
        $cnpj->SetMask('99.999.999/9999-99');
        $inscricaoestadual->setSize('100%');       
        $crt->setSize('100%'); 
        $crt->addItems(s7sdiversos::listcrt());
        $cnae->setSize('100%');
        $inscricaomunicipal->setSize('100%');
        $atividademunicipal->setSize('100%');
        
        $telefone1->setSize('100%');
        $telefone1->setMask('(99)9999-99999');
        $telefone2->setSize('100%');
        $telefone2->setMask('(99)9999-99999');
        $email->setSize('100%');
        $website->setSize('100%');
        $responsavel->setSize('100%');
        $eslogan->setSize('100%');
           
        
        $endereco->setSize('100%');
        $numero->setSize('100%');
        $cep->setSize('100%');
        $cep->setMask('99.999-999');       
        $complemento->setSize('100%');
        $bairro->setSize('100%'); 
        
        $cadcidade_id->setSize('90');
              
        $cidade_uf_cadcidade->setSize('calc(100% - 90px)');
        $cidade_uf_cadcidade->setEditable(false);
        
        $ativo->additems(s7sdiversos::listsimnao());
        $ativo->setSize('20%');  
        $ativo->setValue('S');
                 
        $this->form->addFields( [new TLabel('ID')], [$id]);        
        $this->form->addFields( [new TLabel('Empresa')], [$empresa]);
        $this->form->addFields( [new TLabel('Fantasia')], [$fantasia]);
        $this->form->addFields( [new TLabel('CNPJ')], [$cnpj], [new TLabel('Inscrição Estadual')],[$inscricaoestadual]);
        $this->form->addFields( [new TLabel('CRT')], [$crt], [new TLabel('CNAE')],[$cnae]);
        
        $this->form->addFields( [new TLabel('Inscrição Municipal')],[$inscricaomunicipal],[new TLabel('Código Ativ. Munic.')],[$atividademunicipal]);

        $label1 = new TLabel('Contatos', '#7D78B6', 12, 'b');
        $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';                       
        $this->form->addContent( [$label1] );        
        $this->form->addFields( [new TLabel('Telefone 1')],[$telefone1],[new TLabel('Telefone 2')],[$telefone2]);
        $this->form->addFields( [new TLabel('E-mail')],[$email],[new TLabel('Web Site')],[$website]);
        $this->form->addFields( [new TLabel('Responsável')],[$responsavel],[new TLabel('Eslogan')],[$eslogan]);
        
        
        $label1 = new TLabel('Endereço', '#7D78B6', 12, 'b');
        $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';                       
        $this->form->addContent( [$label1] );
        $this->form->addFields([new TLabel('Endereco')],[$endereco]);
        $this->form->addFields([new TLabel('Numero')],[$numero],[new TLabel('Cep')],[$cep]);
        $this->form->addFields([new TLabel('Complemento')],[$complemento],[new TLabel('Bairro')],[$bairro]);                
        $this->form->addFields([new TLabel('Cidade')],[$cadcidade_id,$cidade_uf_cadcidade]);
       
        $this->form->addFields( [new TLabel('Ativo')], [$ativo]);

        $this->form->addFields([new TLabel('Logo Marca')],[$logo]);
        
        $this->frame = new TElement('div');
        $this->frame->id = 'logo_frame';
        $this->frame->style = 'width:400px;height:auto;min-height:200px;border:1px solid gray;padding:4px;';   
        $this->form->addFields([new TLabel(' ')],[$this->frame]);     
        
        $this->form->addAction( _t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        $this->form->addAction( _t('New'), new TAction(array($this, 'onEdit')), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadempresaList','onReload')), 'fa:table blue');        
                
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadempresaList'));
        $container->add($this->form);
        //venda 35 produto 205
        // add the container to the page
        parent::add($container);
        
    }
    
    /**
     * On complete upload
     */
    public static function onComplete($param)
    {        
        if(!empty($param['logo']))
        {            
            if(file_exists('tmp/' . $param['logo']))
            {                                                                    
                //$key = TSession::getValue('idpessoa'); 
                $ext = pathinfo('tmp/'.$param['logo'], PATHINFO_EXTENSION);
                $nomeimg = 'imagestmp/' . 'img_' . mt_rand() . '.' . $ext ;                                                                                       
                if(file_exists($nomeimg))
                {                                                                    
                    unlink($nomeimg);                                            
                }
                rename('tmp/' . $param['logo'], $nomeimg);
                TSession::setValue('imglogo',$nomeimg);                                            
            }
        }    
        TScript::create("$('#logo_frame').html('')");
        TScript::create("$('#logo_frame').append(\"<img style='width:100%' src='{$nomeimg}'>\");");  
        
    }    
    
    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            
            $object = new Cadempresa;  // create an empty object
            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data
            
            
            //validacao da imagem selecionada
            $imglog = TSession::getValue('imglogo');
            $nomeimg = pathinfo($imglog, PATHINFO_FILENAME);
            $extimg = pathinfo($imglog, PATHINFO_EXTENSION);
            $nomeimg = 'images/' .  $nomeimg.'.'.$extimg;
                         
            $source_file   = $imglog;
            $target_file   = $nomeimg;            
            $finfo         = new finfo(FILEINFO_MIME_TYPE);            
            // if the user uploaded a source file
            if (file_exists($source_file) AND ($finfo->file($source_file) == 'image/png' OR $finfo->file($source_file) == 'image/jpeg'))
            {
                // move to the target directory
                rename($source_file, $target_file);
                $object->logo = $target_file;                                
            }
            $image = new TImage($object->logo);
            $image->style = 'width: 100%';
            $this->frame->add( $image );            
            //
                        
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
        $obj = new StdClass;
        $obj->ativo = 'S';       
        TForm::sendData('form_Cadempresa', $obj);  
        TCombo::reload('form_Cadempresa','tipopessoa',s7sdiversos::listtipopessoa(),'J');    
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadempresa($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                if (isset($object->logo))
                {
                    $image = new TImage($object->logo);
                    $image->style = 'width: 100%';
                    $this->frame->add( $image );
                }                                 
                TTransaction::close(); // close the transaction               
            }
            else
            {
                $this->form->clear(TRUE);
                $obj = new StdClass;
                $obj->ativo = 'S';       
                TForm::sendData('form_Cadempresa', $obj);                 
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }    
}            