<?php
/**
 * CadformapgtoForm Form
 * @author  <your name here>
 */
class CadformapgtoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadformapgto');
        $this->form->setFormTitle('Cadastro de Forma Pagamento');
        

        // create the form fields
        $id = new TEntry('id');
        $ativo = new TCombo('ativo');
        $descricao = new TEntry('descricao');
        $tipo = new TCombo('tipo');
        $rec_dados_cheque = new TCombo('rec_dados_cheque');
        $ver_limite = new TCombo('ver_limite');
        $ver_debitos = new TCombo('ver_debitos');
        $ver_cadastro = new TCombo('ver_cadastro');
         $filtro = new TCriteria;                     
        $filtro->add(new TFilter('id_nivel', '=', '3'));         
        $cadplanoconta_id = new TDBCombo('cadplanoconta_id', 'goldnotas', 'Cadplanoconta', 'id', '{id_planoconta} - {planoconta}',null,$filtro);
        $cadcentrocusto_id = new TDBCombo('cadcentrocusto_id', 'goldnotas', 'Cadcentrocusto', 'id', '{id} - {centrocusto}');
        $adm_catao_cadpessoa_id = new TDBCombo('adm_catao_cadpessoa_id', 'goldnotas', 'Cadpessoa', 'id', '{id} - {pessoa}');
        $lancar_liquido = new TCombo('lancar_liquido');
        $taxaadm = new TEntry('taxaadm');
        $tipocartao = new TCombo('tipocartao');
        $dias_vencimento = new TEntry('dias_vencimento');
        /*
        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items);
        */
        $ativo->addItems(s7sdiversos::listsimnao());
        $tipo->addItems(s7sdiversos::listformapgto());
        $rec_dados_cheque->addItems(s7sdiversos::listsimnao());
        $ver_cadastro->addItems(s7sdiversos::listsimnao());
        $ver_debitos->addItems(s7sdiversos::listsimnao());
        $ver_limite->addItems(s7sdiversos::listsimnao());
        $lancar_liquido->addItems(s7sdiversos::listsimnao());
        
        $taxaadm->setNumericMask(2, ',', '.', true);
        
        $itens = array();
        $itens['1'] = 'Crédito';
        $itens['2'] = 'Débito';
        $tipocartao->addItems($itens);
        
        $labelprincipal = new TLabel('Principal', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );        
        
        $descricao->addValidation('Descrição', new TRequiredValidator );        
        $tipo->addValidation('Tipo não informado', new TRequiredValidator );
        $tipo->setChangeAction( new TAction( array($this, 'onChangetipo')) );        
        
        
        // add the fields
        $row = $this->form->addFields( [ new TLabel('Código') , $id], [new TLabel('Ativo') ,$ativo ] );
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label'];                                       
        $row = $this->form->addFields( [ new TLabel('Descrição') , $descricao ],
                                       [ new TLabel('Tipo') , $tipo ] );
        $row->layout = ['col-sm-6 control-label',
                        'col-sm-2 control-label'];                                       
        $row = $this->form->addFields( [ new TLabel('Ver Limite'), $ver_limite ],
                                       [ new TLabel('Ver Débitos'), $ver_debitos ],
                                       [ new TLabel('Ver Cadastro'), $ver_cadastro ] );
                                       
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];   
                                       
        $labelprincipal = new TLabel('Cheque', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );                                       
                                                            
        $row = $this->form->addFields( [ new TLabel('Dados Cheque'), $rec_dados_cheque ],
                                       [ new TLabel('Plano de Contas'), $cadplanoconta_id ],
                                       [ new TLabel('Centro de Custo') ,  $cadcentrocusto_id ] );
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-3 control-label',
                        'col-sm-3 control-label'];

        
        $labelprincipal = new TLabel('Cartão', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );        
        
        $row = $this->form->addFields( [ new TLabel('Pessoa Cartão'), $adm_catao_cadpessoa_id ] );
        $row->layout = ['col-sm-8 control-label'];
        $row = $this->form->addFields( [ new TLabel('Lancar Liquido'), $lancar_liquido ],
                                       [ new TLabel('Taxa Adm'), $taxaadm ],
                                       [ new TLabel('Tipo Cartão'), $tipocartao ],
                                       [ new TLabel('Dias Vencimento') , $dias_vencimento ] );
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];                                          



        // set sizes
        $id->setSize('100%');
        $ativo->setSize('100%');
        $descricao->setSize('100%');
        $tipo->setSize('100%');
        $rec_dados_cheque->setSize('100%');
        $ver_limite->setSize('100%');
        $ver_debitos->setSize('100%');
        $ver_cadastro->setSize('100%');
        $cadplanoconta_id->setSize('100%');
        $cadcentrocusto_id->setSize('100%');
        $adm_catao_cadpessoa_id->setSize('100%');
        $lancar_liquido->setSize('100%');
        $taxaadm->setSize('100%');
        $tipocartao->setSize('100%');
        $dias_vencimento->setSize('100%');



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'fa:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addActionLink(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadformapgtoList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadformapgtoList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Cadformapgto;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            
            self::onChangetipo( array('tipo'=>$object->tipo));
            
            TTransaction::close(); // close the transaction
            
            new TMessage('info', AdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadformapgto($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                self::onChangetipo( array('tipo'=>$object->tipo));
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    public static function onChangetipo($param)
    {
        if ($param['tipo'] == '02')
        {
            TCombo::enableField('form_Cadformapgto', 'rec_dados_cheque');  
            TDBCombo::enableField('form_Cadformapgto', 'cadplanoconta_id');
            TDBCombo::enableField('form_Cadformapgto', 'cadcentrocusto_id');               
        }
        else
        {
            TCombo::disableField('form_Cadformapgto', 'rec_dados_cheque');
            TDBCombo::disableField('form_Cadformapgto', 'cadplanoconta_id');
            TDBCombo::disableField('form_Cadformapgto', 'cadcentrocusto_id');         
        }
        if ($param['tipo'] == '03')
        {
            TEntry::enableField('form_Cadformapgto','dias_vencimento');
            TEntry::enableField('form_Cadformapgto','taxaadm');
            TCombo::enableField('form_Cadformapgto', 'lancar_liquido');
            TCombo::enableField('form_Cadformapgto', 'tipocartao');
            TDBCombo::enableField('form_Cadformapgto','adm_catao_cadpessoa_id');
        }
        else
        {
            TEntry::disableField('form_Cadformapgto','dias_vencimento');
            TEntry::disableField('form_Cadformapgto','taxaadm');
            TCombo::disableField('form_Cadformapgto', 'lancar_liquido');
            TCombo::disableField('form_Cadformapgto', 'tipocartao');
            TDBCombo::disableField('form_Cadformapgto','adm_catao_cadpessoa_id');            
        }

        if (($param['tipo'] == '02') or ($param['tipo'] == '04') or ($param['tipo'] == '05'))
        {
            TCombo::enableField('form_Cadformapgto', 'ver_limite');
            TCombo::enableField('form_Cadformapgto', 'ver_debitos');
            TCombo::enableField('form_Cadformapgto', 'ver_cadastro');        
        }
        else
        {
            TCombo::disableField('form_Cadformapgto', 'ver_limite');
            TCombo::disableField('form_Cadformapgto', 'ver_debitos');
            TCombo::disableField('form_Cadformapgto', 'ver_cadastro');            
        }        
                    
    }
}
