<?php
/**
 * CadpessoaForm Form
 * @author  <your name here>
 */
class CadpessoaCadimagemForm extends TPage
{
    protected $form; // form
    protected $gridimagens;
    //protected $tipocadastro;
    //public $labelcpfcnpj;
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();   
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
        $this->adianti_target_container = 'CadpessoaCadimagem_area';
        $this->form = new BootstrapFormBuilder('form_CadpessoaCadimagem');
        
        $imgpessoa_image_add = new TButton('PessoaImagemAdd');
        $imgpessoa_image_action = new TAction(array($this, 'onPessoaImagemAdd'));
        $imgpessoa_image_add->setAction($imgpessoa_image_action, 'Adcionar Imagem');
        $imgpessoa_image_add->setImage('bs:plus-sign green');        
                                         
        // creates a Datagrid
        $this->gridimagens = new BootstrapDatagridWrapper(new TDataGrid);
        //$this->gridimagens->enablePopover('Imagem', "<img src='{imagem}'>");        
        $this->gridimagens->style = 'width: 100%';
        $this->gridimagens->datatable = 'true';
        //$gridimagens = new BootstrapDatagridWrapper(new TDataGrid);
        
        // create the datagrid columns
        //$this->idimg = new TDataGridColumn('imagem_id',    'Código',    'center', '10%');
        
        $idimg        = $this->gridimagens->addColumn( new TDataGridColumn('image_id' , 'Código',  'left',   '10%'));
        $imagem       = $this->gridimagens->addColumn( new TDataGridColumn('imagem',  'Imagem', 'left',   '50%'));   
        $descricao    = $this->gridimagens->addColumn( new TDataGridColumn('descricao', 'Descrição', 'left',   '40%'));
        
        // define the transformer method over image
        
        $imagem->setTransformer( 
            function($image) 
            {
                $img = new TImage($image);
                $img->style = 'max-width: 140px';
                return $img;
            }    
        );        
        
        $idimg->title = 'Código';
        $imagem->title = 'Imagem';
        
        //editar
        $actioneditadimagem = new TDataGridAction([$this, 'onPessoaImagemEdi'], ['register_state' => 'false', 'key' => '{image_id}']);               
        $this->gridimagens->addAction($actioneditadimagem, 'Editar', 'fa:edit blue fa-lg');
       
        //excluir
        $actiondelimagem = new TDataGridAction([$this, 'onPessoaImagemDel'], ['register_state' => 'false', 'key' => '{image_id}']);                                                          
        $this->gridimagens->addAction($actiondelimagem, 'Excluir', 'far:trash-alt red');

        // creates the datagrid model
        $this->gridimagens->createModel();
        $this->form->addFields([$imgpessoa_image_add]);        
        $this->form->addContent([$this->gridimagens]);
        
        // vertical box container
        $container = new TVBox('imagens');
        $container->style = 'width: 100%';        
        $container->add($this->form);  
        parent::add($container);      
        
    }
    
    public function onEdit( $param )
    {
        try
        {
            TSession::delValue('pessoa_images');
            TSession::delValue('pessoa_images_loaded');
            TSession::delValue('pessoa_images_max_ordem');
            TSession::delValue('pessoa_images_count');
            $key = TSession::getValue('idpessoa');            
            if (!empty($key))
            {
                //echo 'edit id ' . $key . "</br>";
                $this->loadPessoaImages($key);                 
                $this->onReload();                                                                              
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }    
    
    public function onReload()
    {
        try
        {    
            if (!empty(TSession::getValue('pessoa_images_loaded')))
            {    
                $data = $this->form->getData(); // get form data as array                                   
                $pessoa_images = TSession::getValue('pessoa_images');                         
                $this->gridimagens->clear();            
    
                if ($pessoa_images)
                {                                                                  
                    foreach ($pessoa_images as $pessoa_image_id => $pessoa_image)
                    {   // add the object inside the datagrid
                        if ($pessoa_image['del'] == 'N')
                        {
                            $item = new StdClass;
                            $item->image_id     = $pessoa_image['image_id'];
                            //$item->imagem       = "<img width=\"500\" height=\"250\" style=\"border: 0;\" alt=\"\" src=\"{$pessoa_image['imagem']}\">";
                            $item->imagem       = $pessoa_image['imagem'];
                            $item->descricao    = $pessoa_image['descricao'];  
                            $this->gridimagens->addItem($item);
                            //echo $pessoa_image['imagem'] . "<br />";
                        }                     
                    }
                }   
                //$this->form->setData($data);          
                //$this->loaded = TRUE; 
            }          
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
        }
    } 
    /*
    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded )
        {
            $this->onReload();
        }
        parent::show();
    }       
    */    
    public static function onComplete($param)
    {            
        //$data = $this->form->getData();
        if(!empty($param['imgpessoa']))
        {            
            if(file_exists('tmp/' . $param['imgpessoa']))
            {                                                                    
                $key = TSession::getValue('idpessoa'); 
                $ext = pathinfo('tmp/'.$param['imgpessoa'], PATHINFO_EXTENSION);
                $nomeimg = 'imagestmp/' . 'img_' . mt_rand() . '_' . $key . '.' . $ext ;                                                                                       
                if(file_exists($nomeimg))
                {                                                                    
                    unlink($nomeimg);                                            
                }
                rename('tmp/' . $param['imgpessoa'], $nomeimg);
                TSession::setValue('imgpessoa',$nomeimg);                                            
            }
        }   
        //$image = new TImage($param['imgpessoa']);
        //$image->style = 'width: 100%';               
        // refresh logo_frame
        TScript::create("$('#imgpessoa_frame').html('')");
        TScript::create("$('#imgpessoa_frame').append(\"<img style='width:100%' src='{$nomeimg}'>\");");  
        //$this->form->setData($data);          
        //new TMessage('info', 'Upload completo: '.$nomeimg);
        //onPessoaImagemEdi                                     
    }

    public function onPessoaImagemAdd($param)
    {               
        try 
        {                           
            $data = $this->form->getData();   
            TSession::delValue('image_id');                                 
            TApplication::loadPage('CadpessoaCadimagemEditarForm','onClear', ['register_state'=>'false']);
            $this->onReload();              
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }

    public function onPessoaImagemEdi($param)
    {               
        try 
        {                           
            $data = $this->form->getData();
            $key=$param['key'];           
            TSession::setValue('image_id',$key);                                      
            TApplication::loadPage('CadpessoaCadimagemEditarForm','onEdit', ['register_state'=>'false']);             
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }

    public function onPessoaImagemDel($param)
    {               
        try 
        {                     
            //$data = $this->form->getData();       
            $key=$param['key']; // get the parameter $key
            //new TMessage('info', "The name is : $key");        
            $pessoa_images = TSession::getValue('pessoa_images');
            $pessoa_images[$param['key']]['del'] = 'S';
            /*
            $pessoaimage_id = $pessoa_images[$param['key']]['id'];
            $pessoaimage_path = $pessoa_images[$param['key']]['imagem'];
            //echo ' Id : delete ' . $key . ' image_id ' . $pessoaimage_id . ' path ' . $pessoaimage_path . "</br>";
            if(!empty($pessoaimage_id))
            {
                TTransaction::open('goldnotas'); 
                $pessoa_image_obj = new CadpessoaCadimagem($pessoaimage_id);
                if(file_exists($pessoaimage_path))
                {
                    unlink($pessoaimage_path);
                }              
                $pessoa_image_obj->delete();   
                TTransaction::close();  
            }
            else
            {
               if(file_exists($pessoaimage_path))
               {                                                                    
                   unlink($pessoaimage_path);                                            
               } 
            }                    
            // delete the item from session
            unset($pessoa_images[ (int) $param['image_id']] );
            */
            TSession::setValue('pessoa_images', $pessoa_images);            
            $this->onReload();           
        }
        catch (Exception $e)
        {
            TTransaction::rollback(); 
            new TMessage('error', $e->getMessage());
        }                          
    }
        
    function loadPessoaImages($cadpessoa_id)
    {
        if(is_numeric($cadpessoa_id))
        {
            try
            {           
                if(!TSession::getValue('pessoa_images_loaded')) 
                {
                    $pessoa_images = TSession::delValue('pessoa_images'); 
                    TTransaction::open('goldnotas'); 
                    $pessoa_images_criteria_param['order'] = 'ordem';
                    $pessoa_images_criteria_param['direction'] = 'asc';                                        
                    $pessoa_images_criteria = new TCriteria;                     
                    $pessoa_images_criteria->add(new TFilter('cadpessoa_id', '=', $cadpessoa_id));
                    $pessoa_images_criteria->setProperties($pessoa_images_criteria_param); 
                    $repository = new TRepository('CadpessoaCadimagem');                     
                    $pessoa_images_repo = $repository->load($pessoa_images_criteria);
                    $pessoa_images_max_ordem = 0;
                    $pessoa_images_count = 0 ;
                    foreach ($pessoa_images_repo as $pessoa_image_obj) 
                    { 
                        $pessoa_images_count++;                       
                        $pessoa_images[$pessoa_images_count] = array(
                                                  'id' => $pessoa_image_obj->id,
                                                  'image_id' => $pessoa_images_count,
                                                  'imagem' => $pessoa_image_obj->imagem,
                                                  'descricao' => $pessoa_image_obj->descricao,
                                                  'ordem' => $pessoa_image_obj->ordem,
                                                  'del' => 'N');                        
                        if($pessoa_image_obj->ordem > $pessoa_images_max_ordem)
                        {
                            $pessoa_images_max_ordem = $pessoa_image_obj->ordem;
                        }
                    }
 
                    TSession::setValue('pessoa_images_max_ordem', $pessoa_images_max_ordem);
                    TSession::setValue('pessoa_images_count', $pessoa_images_count);
                    TSession::setValue('pessoa_images_loaded', true); 
                    TTransaction::close();
                    TSession::setValue('pessoa_images', $pessoa_images); 
                }
            }
            catch (Exception $e)
            {
                TTransaction::rollback(); 
                new TMessage('error', $e->getMessage());
            }
        }
        return true;  
    }           
}        
