<?php
/**
 * CadpessoaCadplgList Listing
 * @author  <your name here>
 */
class CadpessoaCadplgForm extends TPage
{
    private $form; // form
    private $datagrid; // listing    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();        
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');         
        // creates the form
        $this->adianti_target_container = 'CadpessoaCadplg_area';        
        $this->form = new BootstrapFormBuilder('form_CadpessoaCadplg');
        
        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_plg_id = new TDataGridColumn('plg_id', 'Código', 'right');
        $column_numeroplg = new TDataGridColumn('numeroplg', 'Número PLG', 'left');
        $column_vencimentoplg = new TDataGridColumn('vencimentoplg', 'Vencimento PLG', 'left');
        $column_processodnpm = new TDataGridColumn('processodnpm', 'Processo DNPM', 'left');
        $column_localidadeaurifera = new TDataGridColumn('localidadeaurifera', 'Localidade Aurifera', 'left');
        $column_regiaoaurifera = new TDataGridColumn('regiaoaurifera', 'Região Aurifera', 'left');


        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_plg_id);
        $this->datagrid->addColumn($column_numeroplg);
        $this->datagrid->addColumn($column_vencimentoplg);
        $this->datagrid->addColumn($column_processodnpm);
        $this->datagrid->addColumn($column_localidadeaurifera);
        $this->datagrid->addColumn($column_regiaoaurifera);

        
        // create EDIT action
        $action_edit = new TDataGridAction(array('CadpessoaCadplgForm', 'onPessoaPlgEdi'));
        //$action_edit->setUseButton(TRUE);
        //$action_edit->setButtonClass('btn btn-default');
        $action_edit->setLabel(_t('Edit'));
        $action_edit->setImage('far:edit blue fa-lg');
        $action_edit->setField('plg_id');
        //$this->datagrid->addAction($action_edit);
        
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onPessoaPlgDel'));
        //$action_del->setUseButton(TRUE);
        //$action_del->setButtonClass('btn btn-default');
        $action_del->setLabel(_t('Delete'));
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('plg_id');
        //$this->datagrid->addAction($action_del);

        $action_group = new TDataGridActionGroup('Ações', 'bs:th');        
        $action_group->addHeader('Cadastro');
        $action_group->addAction($action_edit);
        $action_group->addAction($action_del);       
        // add the actions to the datagrid
        $this->datagrid->addActionGroup($action_group);        
        
        
        $pessoa_plg_add = new TButton('PessoaPlgAdd');
        $pessoa_plg_action = new TAction(array($this, 'onPessoaPlgAdd'));
        $pessoa_plg_add->setAction($pessoa_plg_action, 'Adcionar PLG');
        $pessoa_plg_add->setImage('bs:plus-sign green');                 
        $this->form->addFields([$pessoa_plg_add]);        
        
        // create the datagrid model
        $this->datagrid->createModel();
        $this->form->addContent([$this->datagrid]);    
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        //$container->add(TPanelGroup::pack('', $this->datagrid, $this->pageNavigation));        
        parent::add($container);
    }

    public function onEdit( $param )
    {
        try
        {
            TSession::delValue('pessoa_plgs');
            TSession::delValue('pessoa_plgs_loaded');            
            TSession::delValue('pessoa_plgs_count');
            $key = TSession::getValue('idpessoa');            
            if (!empty($key))
            {                
                $this->loadPessoaPlgs($key);                 
                $this->onReload($param);                                                                              
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    public function onClear( $param )
    {
        $this->form->clear(TRUE);                        
    }    
    
    /**
     * Load the datagrid with data
     */
    public function onReload()
    {
        try
        {               
            if (!empty(TSession::getValue('pessoa_plgs_loaded')))            
            {    
                //$data = $this->form->getData(); // get form data as array                                   
                $pessoa_plgs = TSession::getValue('pessoa_plgs');                         
                $this->datagrid->clear();            
                if ($pessoa_plgs)
                {                                                                  
                    TTransaction::open('goldnotas'); // open a transaction                
                    foreach ($pessoa_plgs as $pessoa_plg_id => $pessoa_plg)
                    {   // add the object inside the datagrid
                        if ($pessoa_plg['del'] == 'N')
                        {
                            //$pessoa = printf("[%10s]\n", $pessoa_contrato['contrato_cadpessoa_id']) . ' - ' . $pessoa_contrato['contrato_pessoa'];
                            //$objpessoa = new Cadpessoa($pessoa_contrato['cadpessoa_id']);
                            //$pessoa = $pessoa_contrato['contrato_cadpessoa_id'] . ' - ' . $objpessoa->pessoa;
                            $item = new StdClass;
                            $item->plg_id  = $pessoa_plg['plg_id'];
                            $item->vencimentoplg = $pessoa_plg['vencimentoplg'];                           
                            $item->numeroplg = $pessoa_plg['numeroplg'];
                            $item->processodnpm = $pessoa_plg['processodnpm'];
                            $item->localidadeaurifera = $pessoa_plg['localidadeaurifera'];
                            $item->regiaoaurifera = $pessoa_plg['regiaoaurifera']; 
                            $this->datagrid->addItem($item);
                        }                        
                    }
                    TTransaction::close();                    
                }   
                //$this->form->setData($data);          
                //$this->loaded = TRUE; 
            }          
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
        }
    }

    public function onPessoaPlgAdd($param)
    {               
        try 
        {                           
            $data = $this->form->getData();   
            TSession::delValue('plg_id');                                 
            TApplication::loadPage('CadpessoaCadplgEditarForm','onClear', ['register_state'=>'false']);
            $this->onReload();              
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }
    
    public function onPessoaPlgEdi($param)
    {               
        try 
        {                           
            $data = $this->form->getData();
            $key=$param['key'];           
            TSession::setValue('plg_id',$key);                                      
            TApplication::loadPage('CadpessoaCadplgEditarForm','onEdit', ['register_state'=>'false']);             
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }

    public function onPessoaPlgDel($param)
    {
        try
        {
            $key=$param['key']; // get the parameter $key
            $pessoa_plgs = TSession::getValue('pessoa_plgs');
            $pessoa_plgs[$param['key']]['del'] = 'S';
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    function loadPessoaPlgs($cadpessoa_id)
    {
        if(is_numeric($cadpessoa_id))
        {
            try
            {           
                if(!TSession::getValue('pessoa_plgs_loaded')) 
                {
                    $pessoa_plgs = TSession::delValue('pessoa_plgs'); 
                    TTransaction::open('goldnotas');                    
                    $pessoa_plgs_criteria = new TCriteria;                     
                    $pessoa_plgs_criteria->add(new TFilter('cadpessoa_id', '=', $cadpessoa_id));
                     
                    $repository = new TRepository('CadpessoaCadplg'); 
                    $pessoa_plgs_repo = $repository->load($pessoa_plgs_criteria);
                    $pessoa_plgs_max_ordem = 0;
                    $pessoa_plgs_count = 0 ;                    
                    foreach ($pessoa_plgs_repo as $pessoa_plg_obj) 
                    {                                             
                        $pessoa_plgs_count++;                                                                       
                        $pessoa_plgs[$pessoa_plgs_count] = array(
                                                  'id' => $pessoa_plg_obj->id,
                                                  'plg_id' => $pessoa_plgs_count,
                                                  'vencimentoplg' => TDate::date2br($pessoa_plg_obj->vencimentoplg),
                                                  'numeroplg' => $pessoa_plg_obj->numeroplg,
                                                  'processodnpm' => $pessoa_plg_obj->processodnpm,
                                                  'localidadeaurifera' => $pessoa_plg_obj->localidadeaurifera,
                                                  'cadpessoa_id' => $pessoa_plg_obj->cadpessoa_id,
                                                  'regiaoaurifera' => $pessoa_plg_obj->regiaoaurifera,
                                                  'del' => 'N');  
                                                                        
                    }
 
                    TSession::setValue('pessoa_plgs_count', $pessoa_plgs_count);                    
                    TSession::setValue('pessoa_plgs_loaded', true); 
                    TTransaction::close();
                    TSession::setValue('pessoa_plgs', $pessoa_plgs); 
                }//joao vitor ex goleiro
            }
            catch (Exception $e)
            {
                TTransaction::rollback(); 
                new TMessage('error', $e->getMessage());
            }
        }
        return true;  
    } 

}
