<?php
/**
 * CadpessoaList Listing
 * @author  <your name here>
 */
class CadpessoaList extends TStandardList
{
    protected $form;     // registration form
    protected $datagrid; // listing
    protected $pageNavigation;
    protected $formgrid;
    protected $deleteButton;
    protected $transformCallback;
    
    /**
     * Page constructor
     */
    public function __construct()
    {
        parent::__construct();
        
        parent::setDatabase('goldnotas');            // defines the database
        parent::setActiveRecord('Cadpessoa');   // defines the active record
        parent::setDefaultOrder('id', 'asc');         // defines the default order
        // parent::setCriteria($criteria) // define a standard filter

        parent::addFilterField('pessoa', 'like', 'pessoa'); // filterField, operator, formField
        parent::addFilterField('fantasia', 'like', 'fantasia'); // filterField, operator, formField
        parent::addFilterField('cpfcnpj', 'like', 'cpfcnpj'); // filterField, operator, formField
        
        // creates the form
        $this->form = new TQuickForm('form_search_Cadpessoa');
        $this->form->class = 'tform'; // change CSS class
        $this->form = new BootstrapFormWrapper($this->form);
        $this->form->style = 'display: table;width:100%'; // change style
        $this->form->setFormTitle('Cadpessoa');
        

        // create the form fields
        
        $pessoa = new TEntry('pessoa');
        $fantasia = new TEntry('fantasia');
        $cpfcnpj = new TEntry('cpfcnpj');

        // add the fields
        $this->form->addQuickField('Nome/Razão Social', $pessoa,  200 );
        $this->form->addQuickField('Apelido/Fantasia', $fantasia,  200 );
        $this->form->addQuickField('CPF/CNPJ', $cpfcnpj,  200 );

        
        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue('Cadpessoa_filter_data') );
        
        // add the search form actions
        $this->form->addQuickAction(_t('Find'), new TAction(array($this, 'onSearch')), 'fa:search');
        $this->form->addQuickAction('Pessoa Física',  new TAction(array('CadpessoaForm', 'onEdit'),['tipocadastro'=>'F']), 'fa:plus green');
        $this->form->addQuickAction('Pessoa Jurídica',  new TAction(array('CadpessoaForm', 'onEdit'),['tipocadastro'=>'J']), 'fa:plus green');
        
        // creates a DataGrid
        $this->datagrid = new TDataGrid;
        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_pessoa = new TDataGridColumn('pessoa', 'Nome/Razão Social', 'left');
        $column_fantasia = new TDataGridColumn('fantasia', 'Apelido/Fantasia', 'left');
        $column_cpfcnpj = new TDataGridColumn('cpfcnpj', 'CPF/CNPJ', 'left');

        /*
        $column_action_edit = new TDataGridColumn('id', 'Editar', 'left', '5%');
        $column_action_edit->setTransformer(function($value, $object) {
            $link = '<a href="index.php?class=CadpessoaForm&method=onEdit&id='.$value.'&key='.$value.'&tipo='.trim($object->tipopessoa).'" class="btn btn-primary">
                    <i class="fas fa-pencil-alt" aria-hidden="true"></i>
            </a>';
            return $link;
        });
        
        $column_action_excluir = new TDataGridColumn('id', 'Excluir', 'left', '5%');
        $column_action_excluir->setTransformer(function($value, $object) {
            $link = '<a href="index.php?class=CadPessoaList&method=onDelete&id='.$value.'">
                    <i class="fas fa-trash-alt" aria-hidden="true"></i>
            </a>';
            return $link;
        });
        */
        // add the columns to the DataGrid
        //$this->datagrid->addColumn($column_action_edit);
        //$this->datagrid->addColumn($column_action_excluir);
        $this->datagrid->addColumn($column_pessoa);
        $this->datagrid->addColumn($column_fantasia);
        $this->datagrid->addColumn($column_cpfcnpj);


        // creates the datagrid column actions
        $order_pessoa = new TAction(array($this, 'onReload'));
        $order_pessoa->setParameter('order', 'pessoa');
        $column_pessoa->setAction($order_pessoa);
        
        $order_fantasia = new TAction(array($this, 'onReload'));
        $order_fantasia->setParameter('order', 'fantasia');
        $column_fantasia->setAction($order_fantasia);
        
        $order_cpfcnpj = new TAction(array($this, 'onReload'));
        $order_cpfcnpj->setParameter('order', 'cpfcnpj');
        $column_cpfcnpj->setAction($order_cpfcnpj);
              
        // create EDIT action

        $action_edit = new TDataGridAction(array('CadpessoaForm', 'onEdit'));
        $action_edit->setUseButton(TRUE);
        $action_edit->setButtonClass('btn btn-default');
        $action_edit->setLabel('Editar');
        $action_edit->setImage('fa:edit blue fa-lg');
        $action_edit->setField('id');        
        //$this->datagrid->addAction($action_edit);

        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onDelete'));
        $action_del->setUseButton(TRUE);
        $action_del->setButtonClass('btn btn-default');
        $action_del->setLabel('Excluir');
        $action_del->setImage('fas:trash-alt-alt red fa-lg');
        $action_del->setField('id');
        //$this->datagrid->addAction($action_del);
        
        $action_contratos = new TDataGridAction(array('CadpessoaCadcontratoplgForm', 'onEdit'));
        $action_contratos->setUseButton(TRUE);
        $action_contratos->setButtonClass('btn btn-default');
        $action_contratos->setLabel('Contratos');
        $action_contratos->setImage('fas:trash-alt-alt red fa-lg');
        $action_contratos->setField('id');        
        
        $action_group = new TDataGridActionGroup('Ações', 'bs:th');        
        $action_group->addHeader('Cadastro');
        $action_group->addAction($action_edit);
        $action_group->addAction($action_del);
        //$action_group->addSeparator();
        //$action_group->addHeader('Funções');
        //$action_group->addAction($action_contratos);
        
        // add the actions to the datagrid
        $this->datagrid->addActionGroup($action_group);        
        
        // create the datagrid model
        $this->datagrid->createModel();
        
        // create the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->setAction(new TAction(array($this, 'onReload')));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());        

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add(TPanelGroup::pack('Pessquisa de Pessoas', $this->form));
        $container->add($this->datagrid);
        $container->add($this->pageNavigation);
        
        parent::add($container);
    }
    

}
