<?php
/**
 * CadtabelaprecoForm Form
 * @author  <your name here>
 */
class CadtabelaprecoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new TQuickForm('form_Cadtabelapreco');
        $this->form->class = 'tform'; // change CSS class
        $this->form = new BootstrapFormWrapper($this->form);
        $this->form->style = 'display: table;width:100%'; // change style
        
        // define the form title
        $this->form->setFormTitle('Cadtabelapreco');
        


        // create the form fields
        $id = new TEntry('id');
        $tabelapreco = new TEntry('tabelapreco');
        $percentual = new TEntry('percentual');
        $descontomaximo = new TEntry('descontomaximo');
        $entradaminima = new TEntry('entradaminima');
        $verificadebito = new TRadioGroup('verificadebito');
        $verificalimite = new TRadioGroup ('verificalimite');
        $verificacadastro = new TRadioGroup('verificacadastro');
        $ativo = new TCombo('ativo');

        $verificadebito->addItems(s7sdiversos::listsimnao());
        $verificadebito->setLayout('horizontal');
        $verificalimite->addItems(s7sdiversos::listsimnao());
        $verificalimite->setLayout('horizontal');
        $verificacadastro->addItems(s7sdiversos::listsimnao());
        $verificacadastro->setLayout('horizontal');
        $ativo->additems(s7sdiversos::listsimnao());
        $ativo->setValue('S');
        
        
        // add the fields
        $this->form->addQuickField('Id', $id,  100 );
        $this->form->addQuickField('Tabela', $tabelapreco,  200 , new TRequiredValidator);
        $this->form->addQuickField('Desconto/Acréscimo', $percentual,  100 );
        $this->form->addQuickField('Desconto Máximo', $descontomaximo,  100 );
        $this->form->addQuickField('Entrada Mínima', $entradaminima,  100 );
        $this->form->addQuickField('Verifica Débito', $verificadebito,  200 );
        $this->form->addQuickField('Verifica Limite', $verificalimite,  200 );
        $this->form->addQuickField('Verifica Cadastro', $verificacadastro,  200 );
        $this->form->addQuickField('Ativo', $ativo,  200 );




        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $this->form->addQuickFields('Date', array($date1, new TLabel('to'), $date2)); // side by side fields
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( 100, 40 ); // set size
         **/
         
        // create the form actions
        $this->form->addQuickAction(_t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        $this->form->addQuickAction(_t('New'),  new TAction(array($this, 'onClear')), 'bs:plus-sign green');
        $this->form->addQuickAction( _t('Back to the listing'), new TAction(array('CadtabelaprecoList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadtabelaprecoList'));
        $container->add(TPanelGroup::pack('Manutenção', $this->form));
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('sample'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            
            $object = new Cadtabelapreco;  // create an empty object
            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    private function onSetDefaults()
    {
        $obj = new StdClass;
        $obj->ativo            = 'S';
        $obj->verificadebito   = 'S';
        $obj->verificalimite   = 'S';
        $obj->verificacadastro = 'S';       
        TForm::sendData('form_Cadtabelapreco', $obj);         
    }
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
        $this->onSetDefaults();
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('sample'); // open a transaction
                $object = new Cadtabelapreco($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
                $this->onSetDefaults();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
