<?php
/**
 * CfgempresaForm Form
 * @author  <your name here>
 */
class CfgempresaForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cfgempresa');
        $this->form->setFormTitle('Cfgempresa');
        

        // create the form fields
        $id = new TEntry('id');
        $cadempresa_id = new TDBCombo('cadempresa_id', 'goldnotas', 'Cadempresa', 'id', 'empresa');
        $ramoatividade = new TEntry('ramoatividade');
        $fin_mascaraplanocontas = new TEntry('fin_mascaraplanocontas');
        $cadalmoxarifado_id = new TDBCombo('cadalmoxarifado_id', 'goldnotas', 'Cadalmoxarifado', 'id', 'cadempresa_id');
        $cadcaixacontacorrente_id = new TDBCombo('cadcaixacontacorrente_id', 'goldnotas', 'Cadcaixacontacorrente', 'id', 'caixacontacorrente');


        // add the fields
        $this->form->addFields( [ new TLabel('Id') ], [ $id ] );
        $this->form->addFields( [ new TLabel('Cadempresa Id') ], [ $cadempresa_id ] );
        $this->form->addFields( [ new TLabel('Ramoatividade') ], [ $ramoatividade ] );
        $this->form->addFields( [ new TLabel('Fin Mascaraplanocontas') ], [ $fin_mascaraplanocontas ] );
        $this->form->addFields( [ new TLabel('Cadalmoxarifado Id') ], [ $cadalmoxarifado_id ] );
        $this->form->addFields( [ new TLabel('Cadcaixacontacorrente Id') ], [ $cadcaixacontacorrente_id ] );



        // set sizes
        $id->setSize('100%');
        $cadempresa_id->setSize('100%');
        $ramoatividade->setSize('100%');
        $fin_mascaraplanocontas->setSize('100%');
        $cadalmoxarifado_id->setSize('100%');
        $cadcaixacontacorrente_id->setSize('100%');



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addAction(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CfgempresaList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CfgempresaList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Cfgempresa;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cfgempresa($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
