<?php
/**
 * MovcaixacontacorrenteForm Form
 * @author  <your name here>
 */
class MovcaixacontacorrenteTransfForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Movcaixacontacorrente');
        $this->form->setFormTitle('Lançamento Transferência Caixa / Conta Banco');
        

        // create the form fields
        $id = new TEntry('id');
        $cre_cadcaixacontacorrente_id = new TDBUniqueSearch('cre_cadcaixacontacorrente_id', 'goldnotas', 'Cadcaixacontacorrente', 'id', 'caixacontacorrente');
        $deb_cadcaixacontacorrente_id = new TDBUniqueSearch('deb_cadcaixacontacorrente_id', 'goldnotas', 'Cadcaixacontacorrente', 'id', 'caixacontacorrente');
        //$tipo = new TCombo('tipo');
        $historico = new TEntry('historico');
        $valor = new TEntry('valor');
        $datalancamento = new TDate('datalancamento');
        $cadempresa_id = new THidden('cadempresa_id');
        $system_user_id = new THidden('system_user_id');       
                
        $userunitid = TSession::getValue('userunitid');
        $cadempresa_id->setValue($userunitid);        
        $userid = TSession::getValue('userid');
        $system_user_id->setValue($userid);               

        // add the fields
        $this->form->addFields( [ new TLabel('Código') ], [ $id ] );
        $this->form->addFields( [ new TLabel('Crédito') ], [ $cre_cadcaixacontacorrente_id ]);
        $this->form->addFields( [ new TLabel('Débito') ], [ $deb_cadcaixacontacorrente_id ]);        
        $this->form->addFields( [ new TLabel('Valor') ], [ $valor ]); 
        $this->form->addFields( [ new TLabel('Datalancamento') ] , [ $datalancamento ] ); 
              
        $this->form->addFields( [ new TLabel('Historico') ], [ $historico ] );        
        $this->form->addFields( [ $cadempresa_id,$system_user_id ] );       

        // set sizes
        $id->setSize('20%');
        $cre_cadcaixacontacorrente_id->setSize('40%');
        $deb_cadcaixacontacorrente_id->setSize('40%');
        $historico->setSize('40%');
        $valor->setSize('40%');
        $valor->setNumericMask(2, ',', '.', True);
        $datalancamento->setSize('40%');
        $datalancamento->setMask('dd/mm/yyyy');
        $datalancamento->setDatabaseMask('yyyy-mm-dd');        
        $cadempresa_id->setSize('100%');
        $system_user_id->setSize('100%');

        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addAction(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('MovcaixacontacorrenteTransfList','onReload')), 'fa:table blue'); 
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'MovcaixacontacorrenteList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
   
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            //echo 'User = ' . $data->system_user_id . '</br>';
            //echo 'Unit = ' . $data->cadempresa_id . '</br>';
            
            $object = new MovcaixacontacorrenteTransf;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object

            $criteria = new TCriteria; 
            $criteria->add(new TFilter('movcaixacontacorrente_transf_id', '=', $object->id));             
            $repository = new TRepository('Movplanoconta'); 
            $repository->delete($criteria); 
            
            $criteria = new TCriteria; 
            $criteria->add(new TFilter('movcaixacontacorrente_transf_id', '=', $object->id));             
            $repository = new TRepository('Movcaixacontacorrente'); 
            $repository->delete($criteria);  
            
            $objcaixacc = new Cadcaixacontacorrente($object->cre_cadcaixacontacorrente_id);
            $cre_cadplanoconta_id = $objcaixacc->cadplanoconta_id;
            $cre_cadcentrocusto_id = $objcaixacc->cadcentrocusto_id;

            $objcaixacc = new Cadcaixacontacorrente($object->deb_cadcaixacontacorrente_id);
            $deb_cadplanoconta_id = $objcaixacc->cadplanoconta_id;
            $deb_cadcentrocusto_id = $objcaixacc->cadcentrocusto_id;
            
            $Movcaixacontacorrente = new Movcaixacontacorrente;
            $Movcaixacontacorrente->cadempresa_id = $object->cadempresa_id;           
            
            //lancamento de credito caixa conta corrente
            $Movcaixacontacorrente = new Movcaixacontacorrente;
            $Movcaixacontacorrente->cadcaixacontacorrente_id = $object->cre_cadcaixacontacorrente_id;
            $Movcaixacontacorrente->cadempresa_id = $object->cadempresa_id;
            $Movcaixacontacorrente->cadcaixacontacorrenteorigem_id = 2;
            $Movcaixacontacorrente->datalancamento = $object->datalancamento;
            $Movcaixacontacorrente->system_user_id = $object->system_user_id;
            $Movcaixacontacorrente->movcaixacontacorrente_transf_id = $object->id;
            $Movcaixacontacorrente->valor = $object->valor;
            $Movcaixacontacorrente->tipo = 'C';
            $Movcaixacontacorrente->historico = $object->historico;
            $Movcaixacontacorrente->cadcaixacontacorrentetipopagamento_id = 1;
            $Movcaixacontacorrente->store();
            //lancamento credito plano conta
            $Movplanoconta = new Movplanoconta;
            $Movplanoconta->movcaixacontacorrente_transf_id = $Movcaixacontacorrente->movcaixacontacorrente_transf_id = $object->id;
            $Movplanoconta->cadcentrocusto_id = $cre_cadcentrocusto_id;
            $Movplanoconta->cadempresa_id = $object->cadempresa_id;
            $Movplanoconta->cadplanoconta_id = $cre_cadplanoconta_id;
            $Movplanoconta->datalancamento = $object->datalancamento;
            $Movplanoconta->valor = $object->valor;
            //$Movplanoconta->datacompensado = $object->datacompensado;
            $Movplanoconta->movcaixacontacorrente_id = $Movcaixacontacorrente->id;
            $Movplanoconta->historico = $object->historico;
            //$Movplanoconta->compensado = $object->compensado;
            $Movplanoconta->system_user_id = $object->system_user_id;
            $Movplanoconta->tipo = 'C';            
            $Movplanoconta->store();           
            
            //lancamento de debito caixa conta corrente
            $Movcaixacontacorrente = new Movcaixacontacorrente;
            $Movcaixacontacorrente->cadcaixacontacorrente_id = $object->deb_cadcaixacontacorrente_id;
            $Movcaixacontacorrente->cadempresa_id = $object->cadempresa_id;
            $Movcaixacontacorrente->cadcaixacontacorrenteorigem_id = 2;
            $Movcaixacontacorrente->datalancamento = $object->datalancamento;
            $Movcaixacontacorrente->system_user_id = $object->system_user_id;
            $Movcaixacontacorrente->movcaixacontacorrente_transf_id = $object->id;
            $Movcaixacontacorrente->valor = $object->valor * (-1);
            $Movcaixacontacorrente->tipo = 'D';
            $Movcaixacontacorrente->historico = $object->historico;
            $Movcaixacontacorrente->cadcaixacontacorrentetipopagamento_id = 1;
            $Movcaixacontacorrente->store();
            
            //lancamento debito plano conta
            $Movplanoconta = new Movplanoconta;
            $Movplanoconta->movcaixacontacorrente_transf_id = $Movcaixacontacorrente->movcaixacontacorrente_transf_id = $object->id;
            $Movplanoconta->cadcentrocusto_id = $deb_cadcentrocusto_id;
            $Movplanoconta->cadempresa_id = $object->cadempresa_id;
            $Movplanoconta->cadplanoconta_id = $deb_cadplanoconta_id;
            $Movplanoconta->datalancamento = $object->datalancamento;
            $Movplanoconta->valor = $object->valor * (-1);
            //$Movplanoconta->datacompensado = $object->datacompensado;
            $Movplanoconta->movcaixacontacorrente_id = $Movcaixacontacorrente->id;
            $Movplanoconta->historico = $object->historico;
            //$Movplanoconta->compensado = $object->compensado;
            $Movplanoconta->system_user_id = $object->system_user_id;
            $Movplanoconta->tipo = 'D';            
            $Movplanoconta->store();            
            
            // get the generated id
            //$data->id = $object->id;
            
            //$this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            $this->form->clear();
            
            //new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new MovcaixacontacorrenteTransf($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form                                   
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
