<?php
/**
 * MovcaixacontacorrenteForm Form
 * @author  <your name here>
 */
class MovcontacorrenteForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Movcontacorrente');
        $this->form->setFormTitle('Lançamento Conta Banco');
        

        // create the form fields
        $id = new TEntry('id');
        $cadcontacorrente_id = new TDBUniqueSearch('cadcontacorrente_id', 'goldnotas', 'Cadcontacorrente', 'id', 'contacorrente');
        $tipo = new TCombo('tipo');
        $historico = new TEntry('historico');
        $valor = new TEntry('valor');
        $datalancamento = new TDate('datalancamento');
        $cadcontacorrenteorigem_id = new THidden('cadcontacorrenteorigem_id');
        $cadempresa_id = new THidden('cadempresa_id');
        $system_user_id = new THidden('system_user_id');
        $datacompensado = new THidden('datacompensado');
        $compensado = new THidden('compensado');
        $cadcentrocusto_id = new TDBUniqueSearch('cadcentrocusto_id', 'goldnotas', 'Cadcentrocusto', 'id', 'centrocusto');
        $cadplanoconta_id = new TDBUniqueSearch('cadplanoconta_id', 'goldnotas', 'Cadplanoconta', 'id', 'planoconta');        

        $itenstipo = array();
        $itenstipo['D'] = 'Débito';
        $itenstipo['C'] = 'Crédito';
        $tipo->addItems($itenstipo);
        
        $cadcontacorrenteorigem_id->setValue('1');
        $userunitid = TSession::getValue('userunitid');
        $cadempresa_id->setValue($userunitid);        
        $userid = TSession::getValue('userid');
        $system_user_id->setValue($userid);                       
        // add the fields
        $this->form->addFields( [ new TLabel('Código') ], [ $id ] );
        $this->form->addFields( [ new TLabel('Conta Banco') ], [ $cadcontacorrente_id ]);
        $this->form->addFields( [ new TLabel('Tipo') ], [ $tipo ] );
        $this->form->addFields( [ new TLabel('Histórico') ], [ $historico ] );
        $this->form->addFields( [ new TLabel('Valor') ], [ $valor ] );
        $this->form->addFields( [ new TLabel('Data') ], [ $datalancamento ] ); 
        $this->form->addFields( [ new TLabel('Centro de Custo') ], [ $cadcentrocusto_id ] );
        $this->form->addFields( [ new TLabel('Plano de Conta') ], [ $cadplanoconta_id ] );       
        $this->form->addFields( [ $cadempresa_id,$system_user_id,$cadcontacorrenteorigem_id,
                                  $datacompensado,$compensado] );       

        // set sizes
        $id->setSize('20%');
        $cadcontacorrente_id->setSize('40%');
        $tipo->setSize('40%');
        $historico->setSize('40%');
        $valor->setSize('40%');
        $valor->setNumericMask(2, ',', '.', True);
        $datalancamento->setSize('40%');
        $datalancamento->setMask('dd/mm/yyyy');
        $datalancamento->setDatabaseMask('yyyy-mm-dd');        
        $cadempresa_id->setSize('100%');
        $system_user_id->setSize('100%');
        $cadcentrocusto_id->setSize('40%');
        $cadplanoconta_id->setSize('40%');

        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addAction(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('MovcontacorrenteList','onReload')), 'fa:table blue'); 
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'MovcontacorrenteList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            //echo 'User = ' . $data->system_user_id . '</br>';
            //echo 'Unit = ' . $data->cadempresa_id . '</br>';
            
            $object = new Movcontacorrente;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            if ($object->tipo == 'D') 
            {
                $object->valor = $object->valor * (-1);                            
            }            
            $object->store(); // save the object

            $criteria = new TCriteria; 
            $criteria->add(new TFilter('movcontacorrente_id', '=', $object->id));             
            $repository = new TRepository('Movplanoconta'); 
            $repository->delete($criteria); 
            
            $Movplanoconta = new Movplanoconta;
            $Movplanoconta->cadcentrocusto_id = $data->cadcentrocusto_id;
            $Movplanoconta->cadempresa_id = $data->cadempresa_id;
            $Movplanoconta->cadplanoconta_id = $data->cadplanoconta_id;
            $Movplanoconta->datalancamento = $object->datalancamento;
            $Movplanoconta->valor = $object->valor;
            $Movplanoconta->datacompensado = $object->datacompensado;
            $Movplanoconta->movcontacorrente_id = $object->id;
            $Movplanoconta->historico = $object->historico;
            $Movplanoconta->compensado = $object->compensado;
            $Movplanoconta->system_user_id = $object->system_user_id;
            $Movplanoconta->tipo = $object->tipo;            
            $Movplanoconta->store();           
            
            $objcaixaconta = new Cadcontacorrente($object->cadcontacorrente_id);
            
            $Movplanoconta = new Movplanoconta;            
            $Movplanoconta->cadcentrocusto_id = $objcaixaconta->cadcentrocusto_id;
            $Movplanoconta->cadplanoconta_id = $objcaixaconta->cadplanoconta_id;
                        
            $Movplanoconta->cadempresa_id = $object->cadempresa_id;
            $Movplanoconta->datalancamento = $object->datalancamento;
            if ($object->tipo == 'C')
            {
                $Movplanoconta->tipo = 'D';
                $Movplanoconta->valor = $object->valor * (-1);
            }
            else
            {
                $Movplanoconta->tipo = 'C';
                $Movplanoconta->valor = $object->valor * (-1);                
            }
            $Movplanoconta->datacompensado = $object->datacompensado;
            $Movplanoconta->movcontacorrente_id = $object->id;
            $Movplanoconta->historico = $object->historico;
            $Movplanoconta->compensado = $object->compensado;
            $Movplanoconta->system_user_id = $object->system_user_id;                        
            $Movplanoconta->store();            
            
            // get the generated id
            //$data->id = $object->id;
            
            //$this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            $this->form->clear();
            
            //new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Movcontacorrente($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                
                $criteria = new TCriteria; 
                $criteria->add(new TFilter('movcontacorrente_id', '=', $object->id));             
                $repository = new TRepository('Movplanoconta'); 
                $repo_objeto = $repository->load($criteria);
                foreach ($repo_objeto as $Movplanoconta)
                {
                    $obj = new StdClass;
                    $obj->cadcentrocusto_id = $Movplanoconta->cadcentrocusto_id;
                    $obj->cadplanoconta_id = $Movplanoconta->cadplanoconta_id;                            
                    TForm::sendData('form_Movcontacorrente', $obj);                
                }                                     
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
