<?php
/**
 * SeekCidade Listing
 * @author  <your name here>
 */
class SeekCidade extends TWindow
{
    private $form; // form
    private $datagrid; // listing
    private $pageNavigation;
    private $formgrid;
    private $loaded;
    private $deleteButton;
    public $arrayuf;
    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();
        parent::setSize( 600, 800 );
        // creates the form
        $this->form = new TQuickForm('form_search_Cadcidade');
        $this->form->class = 'tform'; // change CSS class
        $this->form = new BootstrapFormWrapper($this->form);                     
        $this->form->style = 'display: table;width:100%'; // change style
        $this->form->setFormTitle('Cadcidade');
        

        // create the form fields        
        $cidade = new TEntry('cidade');        
        $uf = new TCombo('uf');       
        
        $uf->addItems(s7sdiversos::listaufnome());


        // add the fields        
        $this->form->addQuickField('Cidade', $cidade,  200 );        
        $this->form->addQuickField('UF', $uf,  200 );

        
        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue('Cadcidade_filter_data') );
        
        // add the search form actions
        $this->form->addQuickAction(_t('Find'), new TAction(array($this, 'onSearch')), 'fa:search');

        
        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_id = new TDataGridColumn('id', 'Id', 'right');
        $column_cidade = new TDataGridColumn('cidade', 'Cidade', 'left');
        $column_codibge = new TDataGridColumn('codibge', 'Codibge', 'left');
        $column_uf = new TDataGridColumn('nomeuf', 'Estado', 'left');        


        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_id);
        $this->datagrid->addColumn($column_cidade);
        $this->datagrid->addColumn($column_codibge);
        $this->datagrid->addColumn($column_uf);        

        $action1 = new TDataGridAction(array($this, 'onSelect'));
        $action1->setLabel('Select');
        // $action1->setUseButton(TRUE);
        $action1->setImage('far:check-circle green fa-lg');
        $action1->setField('id');
        $this->datagrid->addAction($action1);         

        

        
        // create the datagrid model
        $this->datagrid->createModel();
        
        // creates the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->setAction(new TAction(array($this, 'onReload')));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());
        


        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 99%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        $container->add($this->datagrid);
        $container->add($this->pageNavigation);
        
        parent::add($container);
    }
    

    
    /**
     * Register the filter in the session
     */
    public function onSearch()
    {
        // get the search form data
        $data = $this->form->getData();
        
        // clear session filters
        TSession::setValue('SeekCidade_filter_id',   NULL);
        TSession::setValue('SeekCidade_filter_cidade',   NULL);
        TSession::setValue('SeekCidade_filter_codibge',   NULL);
        TSession::setValue('SeekCidade_filter_uf',   NULL);
        TSession::setValue('SeekCidade_filter_ativo',   NULL);

        if (isset($data->id) AND ($data->id)) {
            $filter = new TFilter('id', 'like', "%{$data->id}%"); // create the filter
            TSession::setValue('SeekCidade_filter_id',   $filter); // stores the filter in the session
        }


        if (isset($data->cidade) AND ($data->cidade)) {
            $filter = new TFilter('cidade', 'like', "%{$data->cidade}%"); // create the filter
            TSession::setValue('SeekCidade_filter_cidade',   $filter); // stores the filter in the session
        }


        if (isset($data->codibge) AND ($data->codibge)) {
            $filter = new TFilter('codibge', 'like', "%{$data->codibge}%"); // create the filter
            TSession::setValue('SeekCidade_filter_codibge',   $filter); // stores the filter in the session
        }


        if (isset($data->uf) AND ($data->uf)) {
            $filter = new TFilter('uf', 'like', "%{$data->uf}%"); // create the filter
            TSession::setValue('SeekCidade_filter_uf',   $filter); // stores the filter in the session
        }


        if (isset($data->ativo) AND ($data->ativo)) {
            $filter = new TFilter('ativo', 'like', "%{$data->ativo}%"); // create the filter
            TSession::setValue('SeekCidade_filter_ativo',   $filter); // stores the filter in the session
        }

        
        // fill the form with data again
        $this->form->setData($data);
        
        // keep the search data in the session
        TSession::setValue('Cadcidade_filter_data', $data);
        
        $param=array();
        $param['offset']    =0;
        $param['first_page']=1;
        $this->onReload($param);
    }
    
    /**
     * Load the datagrid with data
     */
    public function onReload($param = NULL)
    {
        try
        {
            // open a transaction with database 'sample'
            TTransaction::open('sample');
            
            // creates a repository for Cadcidade
            $repository = new TRepository('Cadcidade');
            $limit = 10;
            // creates a criteria
            $criteria = new TCriteria;
            
            // default order
            if (empty($param['order']))
            {
                $param['order'] = 'id';
                $param['direction'] = 'asc';
            }
            $criteria->setProperties($param); // order, offset
            $criteria->setProperty('limit', $limit);
            

            if (TSession::getValue('SeekCidade_filter_id')) {
                $criteria->add(TSession::getValue('SeekCidade_filter_id')); // add the session filter
            }


            if (TSession::getValue('SeekCidade_filter_cidade')) {
                $criteria->add(TSession::getValue('SeekCidade_filter_cidade')); // add the session filter
            }


            if (TSession::getValue('SeekCidade_filter_codibge')) {
                $criteria->add(TSession::getValue('SeekCidade_filter_codibge')); // add the session filter
            }


            if (TSession::getValue('SeekCidade_filter_uf')) {
                $criteria->add(TSession::getValue('SeekCidade_filter_uf')); // add the session filter
            }


            if (TSession::getValue('SeekCidade_filter_ativo')) {
                $criteria->add(TSession::getValue('SeekCidade_filter_ativo')); // add the session filter
            }

            
            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);
            
            if (is_callable($this->transformCallback))
            {
                call_user_func($this->transformCallback, $objects, $param);
            }
            
            $this->datagrid->clear();
            if ($objects)
            {
                // iterate the collection of active records
                foreach ($objects as $object)
                {
                    // add the object inside the datagrid
                    $this->datagrid->addItem($object);
                }
            }
            
            // reset the criteria for record count
            $criteria->resetProperties();
            $count= $repository->count($criteria);
            
            $this->pageNavigation->setCount($count); // count of records
            $this->pageNavigation->setProperties($param); // order, page
            $this->pageNavigation->setLimit($limit); // limit
            
            // close the transaction
            TTransaction::close();
            $this->loaded = true;
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }
    

    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded AND (!isset($_GET['method']) OR !(in_array($_GET['method'],  array('onReload', 'onSearch')))) )
        {
            if (func_num_args() > 0)
            {
                $this->onReload( func_get_arg(0) );
            }
            else
            {
                $this->onReload();
            }
        }
        parent::show();
    }
}
