<?php
/**
 * CadpessoaCadcontratoplgList Listing
 * @author  <your name here>
 */
class SystemUserPadraoEmpresaForm extends TPage
{
    private $form; // form
    private $datagrid; // listing
    //include_once('vendor/autoload.php');
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();            
        // creates the form
        parent::__construct();   
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
     
        $this->form = new BootstrapFormBuilder('form_SystemUserPadraoEmpresa');           
        
        $id = new THidden('id');
        $system_user_id = new THidden('system_user_id');
        $system_user_id->setValue(TSession::getValue('systemuserpadraoempresa_system_user_id'));
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            $key= TSession::getValue('systemuserpadraoempresa_system_user_id');                                                  
            $object = new SystemUser($key); // instantiates the Active Record
            $loginusuario = 'Usuário: '. $object->id . ' - ' . $object->login;                              
            TTransaction::close();
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            
            // undo all pending operations
            TTransaction::rollback();
        }
        
        $usuario = new TLabel($loginusuario, '#7D78B6', 12, 'b');
        $usuario->setId = 'idusuario';
        $usuario->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $usuario->setSize('100%');                             
        
        $criteria_empresa = new TCriteria;
        //$criteria_empresa->add(new TFilter())
        $cadempresa_id    = new TDBCombo('cadempresa_id', 'goldnotas', 'SystemUnit', 'id', 'name','name',$criteria_empresa);              
        
        $cadempresa_id->enableSearch();
        $cadempresa_id->setSize('50%');
        
        $cadempresa_id->setChangeAction( new TAction( array($this, 'onChangeCadempresa_id')) );
        
        $cadalmoxarifado_id = new TCombo('cadalmoxarifado_id');  
        $cadalmoxarifado_id->enableSearch();
        $cadalmoxarifado_id->setSize('50%'); 
        
        $cadcaixa_id = new TCombo('cadcaixa_id');
        $cadcaixa_id->enableSearch();
        $cadcaixa_id->setSize('50%');             
        
        $this->form->addFields([$id]);
        $this->form->addFields([$system_user_id]);
        $this->form->addContent( [$usuario] );
        $this->form->addFields([new TLabel('Empresa')],[$cadempresa_id]);
        $this->form->addFields([new TLabel('Almoxarifado')],[$cadalmoxarifado_id]);
        $this->form->addFields([new TLabel('Caixa')],[$cadcaixa_id]);
        
        $btn = $this->form->addAction( _t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addAction( _t('New'), new TAction(array($this, 'onEdit')), 'fa:eraser red');        
        $this->form->addAction( _t('Back to the listing'), new TAction(array('SystemUserList','onReload')), 'fa:table blue');        
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'SystemUserList'));
        $container->add($this->form);        
        parent::add($container);
    }
    


    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            
            $object = new SystemUserCadempresa;  // create an empty object
            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            //$this->form->setData($data); // fill form data
            $this->form->clear();//limpa formulario
            TTransaction::close(); // close the transaction
                        
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * method onEdit()
     * Executed whenever the user clicks at the edit button da datagrid
     */
    function onEdit($param)
    {                
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            if (isset($param['key']))
            {
               HDebug::debug($param,'cadempresas'); 
               $key=$param['key'];            
               TSession::delValue('systemuserpadraoempresa_system_user_id');
               TSession::setValue('systemuserpadraoempresa_system_user_id',$key);                                        
               /*            
                // get the parameter $key
                $key=$param['key'];
                
                // open a transaction with database 'permission'
                TTransaction::open('permission');
                
                //TTransaction::setLogger(new TLoggerSTD());
                // instantiates object System_user
                $object = new SystemUser($key);                
                $units  = array();
                if( $units_db = $object->getSystemUserUnits() )
                {
                    foreach( $units_db as $unit )
                    {
                        $units[] = $unit->id;
                    }
                }                
                //$unitslist = implode(',', $units); 
                //echo 'Empresas ' . $unitslist . "</br>";  
                if (!empty($units))
                {              
                    $filtro_param['order'] = 'name';
                    $filtro_param['direction'] = 'asc';                                        
                    $filtro = new TCriteria;                     
                    $filtro->add(new TFilter('id', 'IN', $units));
                    //$filtro->add(new TFilter('ativo', '=', 'S'));                
                    $filtro->setProperties($filtro_param); 
                    //echo $filtro->dump();
                    $repository = new TRepository('SystemUnit');                     
                    $unit_repo = $repository->load($filtro);
                    $items = array();
                    foreach ($unit_repo as $objectemp)
                    {            
                        $items[$objectemp->id] = $objectemp->name;
                        //echo $objectemp->id . $objectemp->empresa . "</br>";
                    }                  
                    //TCombo::reload('form_SystemUserPadraoEmpresa', 'cadempresa_id', $items);                
                }
                // fill the form with the active record data
                //$this->form->setData($object);                
                // close the transaction*/                                               
            }
            else
            {
                $this->form->clear();
                TSession::setValue('systemuserpadraoempresa_system_user_login', 'Usuário: Não informado');
            }
            TTransaction::close();
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            
            // undo all pending operations
            TTransaction::rollback();
        }
    }   
    public static function onChangeCadempresa_id( $param )
    {
        /*echo 'Empresa' . $param['cadempresa_id'] . "</br>";
        HDebug::debug($param,'cadempresas');
        echo 'var_dump' . var_dump($param) .  "</br>";*/
        try
        {        
        
            TTransaction::open('goldnotas'); 
            $key = TSession::getValue('systemuserpadraoempresa_system_user_id');
            $filtro_param['order'] = 'almoxarifado';
            $filtro_param['direction'] = 'asc';                                        
            $filtro = new TCriteria;                     
            $filtro->add(new TFilter('cadempresa_id', '=', "{$param['cadempresa_id']}"));                       
            $filtro->setProperties($filtro_param); 
            $repository = new TRepository('Cadalmoxarifado');                     
            $almoxarifado_repo = $repository->load($filtro);
            $items = array();
            foreach ($almoxarifado_repo as $object)
            {            
                $items[$object->id] = $object->almoxarifado;
            }               
            TCombo::reload('form_SystemUserPadraoEmpresa', 'cadalmoxarifado_id', $items);
            
            $filtro_param['order'] = 'caixa';
            $filtro_param['direction'] = 'asc';                                        
            $filtro = new TCriteria;                     
            $filtro->add(new TFilter('cadempresa_id', '=', "{$param['cadempresa_id']}"));                       
            $filtro->setProperties($filtro_param); 
            $repository = new TRepository('Cadcaixa');                     
            $almoxarifado_repo = $repository->load($filtro);
            $items = array();
            foreach ($almoxarifado_repo as $object)
            {            
                $items[$object->id] = $object->caixa;
            }               
            TCombo::reload('form_SystemUserPadraoEmpresa', 'cadcaixa_id', $items); 
            
            $filtro = new TCriteria;   //$param['key']                  
            $filtro->add(new TFilter('system_user_id', '=', "{$key}"));
            $filtro->add(new TFilter('cadempresa_id', '=', "{$param['cadempresa_id']}"));                                   
            $repository = new TRepository('SystemUserCadempresa');                     
            $SystemUserCadempresa_repo = $repository->load($filtro);            
            
            //$object = new SystemUserCadempresa($param['cadempresa_id']);   
            foreach ($SystemUserCadempresa_repo as $object)
            {                                
                $obj = new StdClass;
                $obj->id = $object->id;
                $obj->system_user_id = $key;
                $obj->cadalmoxarifado_id = $object->cadalmoxarifado_id;
                $obj->cadcaixa_id = $object->cadcaixa_id;     
                TForm::sendData('form_SystemUserPadraoEmpresa', $obj);
            }            
              
            TTransaction::close();
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            
            // undo all pending operations
            TTransaction::rollback();
        }        
                   
    }
}