<?php
/**
 * CadalmoxarifadoForm Form
 * @author  <your name here>
 */
class CadalmoxarifadoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();       
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadalmoxarifado');                                    
        
        // define the form title
        $this->form->setFormTitle('Almoxarifado');
      
        // create the form fields
        $id = new TEntry('id');
        $almoxarifado = new TEntry('almoxarifado');                
        $idalmoxarifado = $param['id']??'';
        if ( !empty($idalmoxarifado))
        {
            $cadempresa_id = new THidden('cadempresa_id');
            $empresa = new TEntry('empresa');
        }
        else
        {
            $cadempresa_id = new TDBCombo('cadempresa_id','sample','Cadempresa','id','empresa');
        }        
        
        $ativo = new TCheckGroup('ativo');
        
        //atributos
        $id->setEditable(False);
        $id->setSize('10%');
        $almoxarifado->setSize('30%');
        $almoxarifado->addValidation('Almoxarifado', new TRequiredValidator);
        $cadempresa_id->setSize('30%');
        $cadempresa_id->addValidation('Empresa', new TRequiredValidator);
                
        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items); 
        
        
                                     
        // add the fields
        $this->form->addFields([new TLabel('Código')],[$id,$ativo]);
        $this->form->addFields([new TLabel('Almoxarifado')], [$almoxarifado]);
        if ( !empty($idalmoxarifado))
        {
            $empresa->setSize('30%');
            $empresa->setEditable(False);
            $this->form->addFields([$cadempresa_id]);
            $this->form->addFields([new TLabel('Empresa')],[$empresa]);            
        }
        else
        {
            $cadempresa_id->enableSearch;
            $this->form->addFields([new TLabel('Empresa')], [$cadempresa_id]);
        }                        
        
        /** samples
         $this->form->addQuickFields('Date', array($date1, new TLabel('to'), $date2)); // side by side fields
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( 100, 40 ); // set size
         **/
                 
        // create the form actions
        $this->form->addAction( _t('Save'), new TAction(array($this, 'onSave')), 'far:save');               
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadalmoxarifadoList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadalmoxarifadoList'));
        //$container->add(TPanelGroup::pack('Title', $this->form));
        $container->add($this->form);        
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('sample'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            
            $object = new Cadalmoxarifado;  // create an empty object
            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data
            $ativo = $data->ativo;
            if ( !empty($ativo))
            {
                $object->ativo = 'S';
            }
            else { $object->ativo = 'N'; }
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
        $obj = new StdClass;
        $obj->ativo = 'S';       
        TForm::sendData('form_Cadalmoxarifado', $obj);          
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('sample'); // open a transaction
                $object = new Cadalmoxarifado($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                $cadempresa = new Cadempresa($object->cadempresa_id);                
                $obj = new StdClass;                
                if ($object->ativo == 'S')
                {
                    $obj->ativo = 'S';
                }                 
                $obj->empresa = $cadempresa->id . ' - '. $cadempresa->empresa;
                TForm::sendData('form_Cadalmoxarifado', $obj);                
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
                $obj = new StdClass;
                $obj->ativo = 'S';                
                TForm::sendData('form_Cadalmoxarifado', $obj);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
