<?php
/**
 * CadcidadeForm Form
 * @author  <your name here>
 */
class CadcidadeForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new TQuickForm('form_Cadcidade');
        $this->form->class = 'tform'; // change CSS class
        $this->form = new BootstrapFormWrapper($this->form);
        $this->form->style = 'display: table;width:100%'; // change style
        
        // define the form title
        $this->form->setFormTitle('Cadastro de Cidade');
        


        // create the form fields
        $id = new TEntry('id');
        $cidade = new TEntry('cidade');
        $codibge = new TEntry('codibge');
        //$uf = new TEntry('uf');
        $uf = new TCombo('uf');
        //$ativo = new TEntry('ativo');
        $ativo = new TCombo('ativo');             
        
        //atributos
        $uf->addItems(s7sdiversos::listaufnome());
        $ativo->additems(s7sdiversos::listsimnao());
        //$ativo->setSize(60);  
        $ativo->setValue('S');        


        // add the fields
        $this->form->addQuickField('Id', $id,  100 );
        $this->form->addQuickField('Cidade', $cidade,  200 );
        $this->form->addQuickField('IBGE', $codibge,  200 );
        $this->form->addQuickField('Estado', $uf,  200 );                      
        $this->form->addQuickField('Ativo', $ativo,  200 );

        $cidade->addValidation('Cidade', new TRequiredValidator);
        $codibge->addValidation('IBGE', new TRequiredValidator);
        $uf->addValidation('Estado', new TRequiredValidator);
        $ativo->addValidation('Ativo', new TRequiredValidator);


        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $this->form->addQuickFields('Date', array($date1, new TLabel('to'), $date2)); // side by side fields
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( 100, 40 ); // set size
         **/
         
        // create the form actions
        $this->form->addQuickAction(_t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        $this->form->addQuickAction(_t('New'),  new TAction(array($this, 'onClear')), 'bs:plus-sign green');
        $this->form->addQuickAction( _t('Back to the listing'), new TAction(array('CadcidadeList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadcidadeList'));
        $container->add(TPanelGroup::pack('Cadastro de Cidade', $this->form));
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            
            $object = new Cadcidade;  // create an empty object
            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
        $obj = new StdClass;
        $obj->ativo = 'S';       
        TForm::sendData('form_Cadcidade', $obj);        
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('sample'); // open a transaction
                $object = new Cadcidade($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
                $obj = new StdClass;
                $obj->ativo = 'S';       
                TForm::sendData('form_Cadcidade', $obj);                 
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
