<?php
/**
 * CadcondpgtoForm Form
 * @author  <your name here>
 */
class CadcondpgtoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadcondpgto');
        $this->form->setFormTitle('Cadastro de Condições de Pagamento');
        

        // create the form fields
        $id = new TEntry('id');
        $descricao = new TEntry('descricao');
        $avista = new TCombo('avista');
        $qtd_parcs = new TEntry('qtd_parcs');
        $dias_primparc = new TEntry('dias_primparc');
        $dias_entreparc = new TEntry('dias_entreparc');
        $dias_alterapac = new TEntry('dias_alterapac');
        $perc_entrada = new TEntry('perc_entrada');
        $percentual = new TEntry('percentual');
        $desconto_maximo = new TEntry('desconto_maximo');
        $liberada_consumidor = new TCombo('liberada_consumidor');
        $ativo = new TCombo('ativo');
        $disp_compras = new TCombo('disp_compras');
        $disp_vendas = new TCombo('disp_vendas');
        $avista_cadformapgto_id = new TDBCombo('avista_cadformapgto_id', 'goldnotas', 'Cadformapgto', 'id', 'descricao');
        $aprazo_cadformapgto_id = new TDBCombo('aprazo_cadformapgto_id', 'goldnotas', 'Cadformapgto', 'id', 'descricao');

        $avista->addItems(s7sdiversos::listsimnao());
        $ativo->addItems(s7sdiversos::listsimnao());
        $liberada_consumidor->addItems(s7sdiversos::listsimnao());
        $disp_compras->addItems(s7sdiversos::listsimnao());
        $disp_vendas->addItems(s7sdiversos::listsimnao());   
        
        $qtd_parcs->setNumericMask(0, ',', '.', true);
        $dias_primparc->setNumericMask(0, ',', '.', true);
        $dias_entreparc->setNumericMask(0, ',', '.', true);
        $dias_alterapac->setNumericMask(0, ',', '.', true);        
        
        $percentual->setNumericMask(2, ',', '.', true);     
        $perc_entrada->setNumericMask(2, ',', '.', true);
        $desconto_maximo->setNumericMask(2, ',', '.', true);
        
        // add the fields
        $row = $this->form->addFields( [ new TLabel('Código') , $id ], 
                                       [ new TLabel('Ativo') ,  $ativo ]);
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label'];
        $row = $this->form->addFields( [ new TLabel('Descrição') , $descricao ], 
                                       [ new TLabel('A Vista') , $avista ] );
        $row->layout = ['col-sm-6 control-label',
                        'col-sm-2 control-label'];                               
        $row = $this->form->addFields( [ new TLabel('Parcelas') , $qtd_parcs ] ,
                                       [ new TLabel('Dias 1º Parcela') , $dias_primparc ],
                                       [ new TLabel('Dias Entre Parcelas') , $dias_entreparc ],
                                       [ new TLabel('% Entrada') , $perc_entrada ]);
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];                                       
        $row = $this->form->addFields( [ new TLabel('Dias Alterar Parcelas') , $dias_alterapac ],
                                       [ new TLabel('Acrescimo/Desconto') , $percentual ],
                                       [ new TLabel('Desconto Máximo') , $desconto_maximo ] );
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];                                       
        $row = $this->form->addFields( [ new TLabel('Liberada Consumidor') , $liberada_consumidor ],        
                                       [ new TLabel('Disp. Compras') , $disp_compras ],
                                       [ new TLabel('Disp. Vendas') , $disp_vendas ]);
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];
                                                               
        $row = $this->form->addFields( [ new TLabel('Forma de Pagamento A Vista') , $avista_cadformapgto_id ],
                                       [ new TLabel('Forma de Pagamento A Prazo') , $aprazo_cadformapgto_id ] );
        $row->layout = ['col-sm-4 control-label',
                        'col-sm-4 control-label'];
                        
        $descricao->addValidation('Descrição', new TRequiredValidator);
        $qtd_parcs->addValidation('Parcelas', new TRequiredValidator);
        $ativo->addValidation('Ativo', new TRequiredValidator);
        $avista->addValidation('A Vista', new TRequiredValidator);


        // set sizes
        $id->setSize('100%');
        $descricao->setSize('100%');
        $avista->setSize('100%');
        $qtd_parcs->setSize('100%');
        $dias_primparc->setSize('100%');
        $dias_entreparc->setSize('100%');
        $dias_alterapac->setSize('100%');
        $perc_entrada->setSize('100%');
        $percentual->setSize('100%');
        $desconto_maximo->setSize('100%');
        $liberada_consumidor->setSize('100%');
        $ativo->setSize('100%');
        $disp_compras->setSize('100%');
        $disp_vendas->setSize('100%');
        $avista_cadformapgto_id->setSize('100%');
        $aprazo_cadformapgto_id->setSize('100%');



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'fa:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addActionLink(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadcondpgtoList','onReload')), 'fa:table blue');        
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadcondpgtoList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Cadcondpgto;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data            
            TTransaction::close(); // close the transaction
            
            new TMessage('info', AdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadcondpgto($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
