<?php
/**
 * CadcontratoForm Form
 * @author  <your name here>
 */
class CadcontratoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new TQuickForm('form_Cadcontrato');
        $this->form->class = 'tform'; // change CSS class
        $this->form = new BootstrapFormWrapper($this->form);
        $this->form->style = 'display: table;width:100%'; // change style
        
        // define the form title               
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadcontrato');
        $this->form->setFormTitle('Contratos');         
        


        // create the form fields
        $id = new TEntry('id');
        $contrato = new TEntry('contrato');
        $modelo = new THtmlEditor('modelo');         
        $ativo = new TCheckGroup('ativo');               
        
        $id->setEditable(FALSE);
        $id->setSize('20%'); 
        $contrato->setSize('100%');       
        $modelo->setSize( '100%', '842px');
        
        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items);        


        // add the fields
        $this->form->addFields([new TLabel('Id')],[$id,$ativo]);
        $this->form->addFields([new TLabel('Contrato')],[$contrato]);
        $this->form->addFields([new TLabel('Modelo')],[$modelo]);
        
        /** samples
         $this->form->addQuickFields('Date', array($date1, new TLabel('to'), $date2)); // side by side fields
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( 100, 40 ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction( _t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadcontratoList','onReload')), 'fa:table blue');
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            
            $object = new Cadcontrato;  // create an empty object
            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data
            
            $ativo = $data->ativo;
            if ( !empty($ativo))
            {
                $object->ativo = 'S';
            }
            else { $object->ativo = 'N'; }            
            
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadcontrato($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                $obj = new StdClass;
                $obj->ativo = $object->ativo;
                TForm::sendData('form_Cadcontrato', $obj);                                
                TTransaction::close(); // close the transaction
                
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
