<?php
/**
 * CadnaturezaoperacaoForm Form
 * @author  <your name here>
 */
class CadnaturezaoperacaoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadnaturezaoperacao');
        $this->form->setFormTitle('Natureza de Operação');
        
        TTransaction::open('goldnotas');
        //TTransaction::dump();
        $idempresa = TSession::getValue('userunitid');        
        $cadempresa = new Cadempresa($idempresa);        
        
        $crt = $cadempresa->crt;
        $uf = $cadempresa->cadcidade->uf;
        TTransaction::close();        
        $idnatureza = $param['id']??'';
        // create the form fields
        $id = new TEntry('id');
        $id_natureza = new TEntry('id_natureza');
        $id_agrupador = new THidden('id_agrupador');
        $id_sequencia = new THidden('id_sequencia');
        $natureza = new TEntry('natureza');
        $origemdestino = new TCombo('origemdestino');
        $tiponatureza = new TCombo('tiponatureza');
        //$cst_icms = new TCombo('cst_icms');
        //$csosn = new TCombo('csosn');
        if ($crt = '3') 
        {            
            $cstcsons = new TCombo('cst_icms');
            $cstcsons->addItems(diversosdfe::listcsticms());
            $cstcsosnlabel = 'CST';
        }
        else
        {                
            $cstcsons = new TCombo('csosn');
            $cstcsons->addItems(diversosdfe::listcsosn());
            $cstcsosnlabel = 'CSOSN';
        }    
        $cst_ipi = new TCombo('cst_ipi');
        $cst_pis = new TCombo('cst_pis');
        $cst_cofins = new TCombo('cst_cofins');
        $icms_aliquota = new TEntry('icms_aliquota');
        $icms_reducao = new TEntry('icms_reducao');
        $icmsst_mva = new TEntry('icmsst_mva');
        $icmsst_aliquota = new TEntry('icmsst_aliquota');
        $icmsst_reducao = new TEntry('icmsst_reducao');
        $ipi_aliquota = new TEntry('ipi_aliquota');
        $pis_aliquota = new TEntry('pis_aliquota');
        $cofins_aliquota = new TEntry('cofins_aliquota');

        $filter = new TCriteria; 
        $filter->add(new TFilter('uf', '=', $uf));        
        
        $ncm_lista   = new TDBMultiSearch('ncm_lista', 'goldnotas', 'Cadncm', 'ncm', 'ncm', NULL, $filter);
        $uf_lista = new TMultiSearch('uf_lista');
        
        $id_natureza->addValidation('CFOP ', new TRequiredValidator);
        $natureza->addValidation('Natureza ', new TRequiredValidator);
        
        $tiponatureza->addItems(diversosdfe::listtiponatureza());
        $origemdestino->addItems(diversosdfe::listorigemdestino());
        $cst_ipi->addItems(diversosdfe::listcstipi());
        $cst_pis->addItems(diversosdfe::listcstpiscofins());
        $cst_cofins->addItems(diversosdfe::listcstpiscofins());
        
        $uf_lista->addItems(s7sdiversos::listaufnome());
        
        if (!empty($id))
        {
            $id->setEditable(FALSE);            
        }
        
        if ($idnatureza == '') 
        {        
            $id_natureza->setEditable(True);
        }
        else 
        {        
            $id_natureza->setEditable(False);            
        };        

        $labelprincipal = new TLabel('Principal', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );
         
        // add the fields
        $this->form->addFields([ $id_agrupador ], [ $id_sequencia ] );        
        $row = $this->form->addFields( [ new TLabel('Código') , $id ], [ new TLabel('CFOP') , $id_natureza ], [ new TLabel('Natureza') , $natureza ] );
        $row->layout = ['col-sm-1 control-label', 
                        'col-sm-1 control-label',
                        'col-sm-8 control-label'];
        $row = $this->form->addFields( [ new TLabel('Dentro/Fora') , $origemdestino ] , [ new TLabel('Entrada/Saída') ,  $tiponatureza ] );
        $row->layout = ['col-sm-5 control-label', 
                        'col-sm-5 control-label'];
        
        $labelprincipal = new TLabel('ICMS', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );
        /*                                 
        $row = $this->form->addFields( [ new TLabel('Cst Icms') , $cst_icms ] );
        $row->layout = ['col-sm-8 control-label'];
        $row = $this->form->addFields( [ new TLabel('Csosn') , $csosn ] );
        $row->layout = ['col-sm-8 control-label'];
        */
        $row = $this->form->addFields( [ new TLabel($cstcsosnlabel), $cstcsons],
                                       [ new TLabel('Aliquota') , $icms_aliquota ],
                                       [ new TLabel('Reducao') , $icms_reducao ], 
                                       [ new TLabel('ST Mva') , $icmsst_mva ],
                                       [ new TLabel('ST Aliquota') , $icmsst_aliquota ],
                                       [ new TLabel('ST Reducao') , $icmsst_reducao ] );
        $row->layout = ['col-sm-5 control-label',
                        'col-sm-1 control-label', 
                        'col-sm-1 control-label', 
                        'col-sm-1 control-label',
                        'col-sm-1 control-label',
                        'col-sm-1 control-label'];
        
        $labelprincipal = new TLabel('IPI', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );        
        
        $row = $this->form->addFields( [ new TLabel('Cst') , $cst_ipi ] , 
                                       [ new TLabel('Aliquota') , $ipi_aliquota ]);
        $row->layout = ['col-sm-5 control-label',
                        'col-sm-1 control-label']; 
                        
        $labelprincipal = new TLabel('PIS/COFINS', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );                                                      
                        
        $row = $this->form->addFields([ new TLabel('Cst Pis') , $cst_pis ], 
                                      [ new TLabel('Aliq. Pis') , $pis_aliquota ] );                        
        $row->layout = ['col-sm-5 control-label',
                        'col-sm-1 control-label'];
                        
        $row = $this->form->addFields( [ new TLabel('Cst Cofins') , $cst_cofins ],
                                       [ new TLabel('Aliq. Cofins') , $cofins_aliquota ] );       
        $row->layout = ['col-sm-5 control-label',
                        'col-sm-1 control-label']; 
                        
        $labelprincipal = new TLabel('Amarrações', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );
        
        $row = $this->form->addFields( [ new TLabel('Lista Estados') , $uf_lista ]);       
        $row->layout = ['col-sm-10 control-label'];        
          
        $row = $this->form->addFields( [ new TLabel('Lista NCM') , $ncm_lista ]);       
        $row->layout = ['col-sm-10 control-label'];                                    

        // set sizes
        $id->setSize('100%');
        $id_natureza->setSize('100%');
        $id_agrupador->setSize('100%');
        $id_sequencia->setSize('100%');
        $natureza->setSize('100%');
        $origemdestino->setSize('100%');
        $tiponatureza->setSize('100%');
        //$cst_icms->setSize('100%');
        //$csosn->setSize('100%');
        $cstcsons->setSize('100%');
        $cst_ipi->setSize('100%');
        $cst_pis->setSize('100%');
        $cst_cofins->setSize('100%');
        $icms_aliquota->setSize('100%');
        $icms_aliquota->setNumericMask(2, ',', '.', true);
        $icms_reducao->setSize('100%');
        $icms_reducao->setNumericMask(2, ',', '.', true);
        $icmsst_mva->setSize('100%');
        $icmsst_mva->setNumericMask(2, ',', '.', true);
        $icmsst_aliquota->setSize('100%');
        $icmsst_aliquota->setNumericMask(2, ',', '.', true);
        $icmsst_reducao->setSize('100%');
        $icmsst_reducao->setNumericMask(2, ',', '.', true);
        $ipi_aliquota->setSize('100%');
        $ipi_aliquota->setNumericMask(2, ',', '.', true);
        $pis_aliquota->setSize('100%');
        $pis_aliquota->setNumericMask(2, ',', '.', true);
        $cofins_aliquota->setSize('100%');
        $cofins_aliquota->setNumericMask(2, ',', '.', true);        
        $ncm_lista->setSize('100%');
        $uf_lista->setSize('100%');
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'fa:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addActionLink(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadnaturezaoperacaoList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadnaturezaoperacaoList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /*
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            */
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Cadnaturezaoperacao;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            
            if (count($data->uf_lista) > 1)
            {
                echo var_dump($data->uf_lista) . '<br \>';
                echo 'contador = ' . count($data->uf_lista) . '<br \>';
                $uflista = '';           
                foreach ($data->uf_lista as $key => $item) {
                    $uflista = $uflista . $item . ',';                                         
                }      
                $object->uf_lista = $uflista;                                           
            }
            else {
                $object->uf_lista = '';         
            }
            if (count($data->ncm_lista) > 1)
            {                               
                $ncmlista = '';                                                                                          
                foreach($data->ncm_lista as $key => $item) {
                    $ncmlista = $ncmlista . $item . ',';
                }            
                $object->ncm_lista = $ncmlista;
            }
            else {
                $object->ncm_lista = '';                     
            }              
            
            if ((empty($object->id)) and (empty($object->id_agrupador)))
            {                
                $object->id_agrupador = $object->id_natureza;
                $filtro = new TCriteria;                                    
                $filtro->add(new TFilter('id_agrupador', '=', $object->id_natureza));                
                $repos = new HRepository('Cadnaturezaoperacao');                     
                $count = $repos->count($filtro);  
                if ($count > 0)
                {  
                    $filtro = new TCriteria;                                    
                    $filtro->add(new TFilter('id_agrupador', '=', $object->id_natureza));                
                    $repos = new HRepository('Cadnaturezaoperacao');                     
                    $max = $repos->max('id_sequencia',$filtro);                  
                    $max++;           
                    //echo 'Max: ' . $max . "</br>"; 
                    $idnatureza = str_pad($max , 2, "0", STR_PAD_LEFT);
                    $idnatureza = $object->id_natureza . '.' . $idnatureza;
                    echo $idnatureza . '<br/>';
                    $object->id_natureza = $idnatureza;
                    $object->id_sequencia = $max;
                    $novo = 'S';
                }  
                
            }            
            
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            //new TMessage('info', AdiantiCoreTranslator::translate('Record saved'));
            if (isset($novo))
            {
                //echo 'LoadPage' . "</br>";
                AdiantiCoreApplication::loadPage('CadnaturezaoperacaoForm', 'onEdit', ['key'=>$object->id,'id'=>$object->id,'register_state'=>'false']);
            }              
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadnaturezaoperacao($key); // instantiates the Active Record
                $object->ncm_lista = explode(",",$object->ncm_lista);                
                $uflista = explode(",",$object->uf_lista);                
                $object->uf_lista = $uflista;
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
