<?php
/**
 * CadpessoaCadcontratoplgEditarForm Form
 * @author  <your name here>
 */
class CadpessoaCadcontratoplgEditarForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        //parent::setSize( 850, 600 );
        // creates the form 
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
        // creates the form
        $this->adianti_target_container = 'CadpessoaCadcontratoplg_area';
        $this->form = new BootstrapFormBuilder('form_CadpessoaCadcontratoplgeditar');  
        //$this->form->style = 'display: table;width:100%'; // change style
        //$this->form->setFormTitle('Cadastrar Contrato');             

        // create the form fields
        $id = new TEntry('id');
        $ativo = new TCheckGroup('ativo');
        $dtcadastro = new TDate('dtcadastro');       
        $contrato_cadpessoa_id = new TDBUniqueSearch('contrato_cadpessoa_id', 'goldnotas', 'Cadpessoa', 'id', 'pessoa', 'pessoa');
        $cadcontrato_id = new TDBUniqueSearch('cadcontrato_id', 'goldnotas', 'Cadcontrato', 'id', 'contrato', 'contrato');
        $dtemissao = new TDate('dtemissao');
        $dtvencimento = new TDate('dtvencimento');
        $numero = new TEntry('numero');
        $observacoes = new TText('observacoes');
        $contrato_id = new THidden('contrato_id');

        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items);
        
        $id->setSize('50%');
        
        $dtcadastro->setSize('50%');
        $dtcadastro->setMask('dd/mm/yyyy');
        $dtcadastro->setDatabaseMask('yyyy-mm-dd');
        
        $dtcadastro->setEditable(False);
        
        $contrato_cadpessoa_id->setSize('50%');
        $cadcontrato_id->setSize('50%');
        
        $dtvencimento->setSize('50%');
        $dtvencimento->setMask('dd/mm/yyyy');
        $dtvencimento->setDatabaseMask('yyyy-mm-dd');
        
        $dtemissao->setSize('50%');
        $dtemissao->setMask('dd/mm/yyyy');
        $dtemissao->setDatabaseMask('yyyy-mm-dd');
        
        $numero->setSize('50%');

        // add the fields
        $this->form->addFields([new TLabel('Código')],[$id],[$ativo]);
        //$this->form->addFields([$ativo]);
        $this->form->addFields([new TLabel('Cadastro')],[$dtcadastro]);
        $this->form->addFields([new TLabel('Fornecedor PLG')],[$contrato_cadpessoa_id]);
        $this->form->addFields([new TLabel('Modelo de contrato')],[$cadcontrato_id]);
        $this->form->addFields([new TLabel('Emissão')],[$dtemissao]);
        $this->form->addFields([new TLabel('Contrato')],[$numero]);
        $this->form->addFields([new TLabel('Vencimento')],[$dtvencimento]);
        $this->form->addFields([new TLabel('Observações')],[$observacoes]);
        $this->form->addFields([$contrato_id]);
        
        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        // create the form actions
        //$this->form->addAction( _t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        //$this->form->addAction('Voltar', new TAction(array($this,'onCancel')), 'fa:table blue');

        $pessoa_contrato_sav = new TButton('PessoacontratoSav');
        $pessoa_contrato_sav_action = new TAction(array($this, 'onSave'));
        $pessoa_contrato_sav->setAction($pessoa_contrato_sav_action, 'Salvar');
        $pessoa_contrato_sav->setImage('far:save');        

        $pessoa_contrato_can = new TButton('PessoacontratoCan');
        $pessoa_contrato_can_action = new TAction(array($this, 'onCancel'));
        $pessoa_contrato_can->setAction($pessoa_contrato_can_action, 'Voltar');
        $pessoa_contrato_can->setImage('far:save');  
        
        $this->form->addFields([],[$pessoa_contrato_sav,$pessoa_contrato_can]);          
        
        // vertical box container
        $container = new TVBox('contratos');
        $container->style = 'width: 100%';

        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            $data = $this->form->getData();
            $this->form->validate();
            $pessoa_contratos = TSession::getValue('pessoa_contratos');  
            $contrato_id = TSession::getValue('contrato_id');
            if (empty($contrato_id))
            {                      
                $pessoa_contratos_count = TSession::getValue('pessoa_contratos_count');
                $pessoa_contratos_count++;            
                TSession::setValue('pessoa_contratos_count', $pessoa_contratos_count);
            } 
            else
            {                
                $pessoa_contratos_count = $contrato_id;      
            }                      
            $pessoa_contratos[$pessoa_contratos_count] = array(
                                                        'id' => $param['id'],
                                                        'contrato_id' => $pessoa_contratos_count,
                                                        'dtemissao' => $param['dtemissao'],
                                                        'dtvencimento' => $param['dtvencimento'],
                                                        'dtcadastro' => $param['dtcadastro'],
                                                        'numero' => $param['numero'],
                                                        'observacoes' => $param['observacoes'],
                                                        'contrato_cadpessoa_id' => $param['contrato_cadpessoa_id'],
                                                        'cadcontrato_id' => $param['cadcontrato_id'],
                                                        'ativo' => $param['ativo'],
                                                        'del' => 'N');                                                                   
            TSession::setValue('pessoa_contratos', $pessoa_contratos);
            TSession::delValue('contrato_id');
            AdiantiCoreApplication::loadPage('CadpessoaCadcontratoplgForm', 'onReload', ['register_state'=>'false']);
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
        $date = date('d/m/Y');
        $obj = new StdClass;
        $obj->dtcadastro = $date;//TDate::date2br();
        $obj->ativo = 'S';
        TForm::sendData('form_CadpessoaCadcontratoplgeditar', $obj);         
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            $data = $this->form->getData();             
            $this->form->clear(TRUE);            
            $contrato_id = TSession::getValue('contrato_id');
            $pessoa_contratos = TSession::getValue('pessoa_contratos');
            $id = $pessoa_contratos[$contrato_id]['id'];
            $contrato_cadpessoa_id = $pessoa_contratos[$contrato_id]['contrato_cadpessoa_id'];
            $cadcontrato_id = $pessoa_contratos[$contrato_id]['cadcontrato_id'];
            $dtcadastro = $pessoa_contratos[$contrato_id]['dtcadastro']; 
            $dtemissao = $pessoa_contratos[$contrato_id]['dtemissao'];
            $numero = $pessoa_contratos[$contrato_id]['numero'];
            $dtvencimento = $pessoa_contratos[$contrato_id]['dtvencimento'];
            $observacoes = $pessoa_contratos[$contrato_id]['observacoes'];
            $data->contrato_cadpessoa_id = $contrato_cadpessoa_id;
            $data->cadcontrato_id = $cadcontrato_id;
            $data->numero = $numero;
            $data->observacoes = $observacoes;
            $this->form->setData($data);                     
            $obj = new StdClass;
            $obj->id = $id;
            $obj->contrato_id = $contrato_id;
            $obj->dtcadastro = $dtcadastro;
            $obj->dtemissao = $dtemissao;
            $obj->dtvencimento = $dtvencimento;
            $obj->contrato_cadpessoa_id = $contrato_cadpessoa_id;
            $obj->ativo = 'S';
            TForm::sendData('form_CadpessoaCadcontratoplgeditar', $obj);                        
            
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    }
    public function onCancel( $param )
    {
        try
        {
            AdiantiCoreApplication::loadPage('CadpessoaCadcontratoplgForm', 'onReload', ['register_state'=>'false']);
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    }     
}
