<?php
/**
 * CadpessoaCadcontratoplgList Listing
 * @author  <your name here>
 */
class CadpessoaCadcontratoplgForm extends TPage
{
    private $form; // form
    private $datagrid; // listing
    //include_once('vendor/autoload.php');
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();
        
        // creates the form
        parent::__construct();   
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
        // creates the form
        $this->adianti_target_container = 'CadpessoaCadcontratoplg_area';
        $this->form = new BootstrapFormBuilder('form_CadpessoaCadcontratoplg');        
        
        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_contrato_id = new TDataGridColumn('contrato_id', 'Código', 'right', '5%');
        $column_dtcadastro = new TDataGridColumn('dtcadastro', 'Dt.Cadastro', 'left', '10%');
        $column_contrato_pessoa = new TDataGridColumn('contrato_pessoa', 'Pessoa', 'left', '35%');
        $column_contrato_modelo = new TDataGridColumn('contrato_modelo', 'Modelo Contrato', 'left', '35%');
        $column_dtemissao = new TDataGridColumn('dtemissao', 'Dt.Emissão', 'left', '10%');
        $column_numero = new TDataGridColumn('numero', 'Número', 'left', '10%');
        $column_dtvencimento = new TDataGridColumn('dtvencimento', 'Dt.Vencimento', 'left', '10%');


        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_contrato_id);
        $this->datagrid->addColumn($column_dtcadastro);
        $this->datagrid->addColumn($column_contrato_pessoa);
        $this->datagrid->addColumn($column_contrato_modelo);
        $this->datagrid->addColumn($column_dtemissao);
        $this->datagrid->addColumn($column_numero);
        $this->datagrid->addColumn($column_dtvencimento);

        
        // create EDIT action
        $action_edit = new TDataGridAction(array('CadpessoaCadcontratoplgForm', 'onPessoaContratoEdi'));
        //$action_edit->setUseButton(TRUE);
        //$action_edit->setButtonClass('btn btn-default');
        $action_edit->setLabel('Editar');
        $action_edit->setImage('far:edit blue fa-lg');
        $action_edit->setField('contrato_id');
        //$this->datagrid->addAction($action_edit);
        
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onPessoaContratoDel'));
        //$action_del->setUseButton(TRUE);
        //$action_del->setButtonClass('btn btn-default');
        $action_del->setLabel('Excluir');
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('contrato_id');
        //$this->datagrid->addAction($action_del);
        
        // create PRINT action
        $action_imp = new TDataGridAction(array($this, 'onPessoaContratoImp'));
        //$action_imp->setUseButton(TRUE);
        //$action_imp->setButtonClass('btn btn-default');
        $action_imp->setLabel('Imprimir');
        $action_imp->setImage('far:trash-alt red fa-lg');
        $action_imp->setField('contrato_id');
        //$this->datagrid->addAction($action_imp);        
        
        $action_group = new TDataGridActionGroup('Ações', 'bs:th');        
        $action_group->addHeader('Cadastro');
        $action_group->addAction($action_edit);
        $action_group->addAction($action_del);
        $action_group->addSeparator();
        //$action_group->addHeader('Funções');
        $action_group->addAction($action_imp);
        
        // add the actions to the datagrid
        $this->datagrid->addActionGroup($action_group);        
        
        // create the datagrid model
        $this->datagrid->createModel();
        
        $pessoa_contrato_add = new TButton('PessoaContratoAdd');
        $pessoa_contrato_action = new TAction(array($this, 'onPessoaContratoAdd'));
        $pessoa_contrato_add->setAction($pessoa_contrato_action, 'Adcionar Contrato');
        $pessoa_contrato_add->setImage('bs:plus-sign green');         
        
        $this->form->addFields([$pessoa_contrato_add]);
        
        $this->form->addContent([$this->datagrid]);        

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);        
        parent::add($container);
    }
    
    public function onEdit( $param )
    {
        try
        {
            TSession::delValue('pessoa_contratos');
            TSession::delValue('pessoa_contratos_loaded');            
            TSession::delValue('pessoa_contratos_count');
            $key = TSession::getValue('idpessoa');            
            if (!empty($key))
            {                
                $this->loadPessoaContratos($key);                 
                $this->onReload($param);                                                                              
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    public function onClear( $param )
    {
        $this->form->clear(TRUE);                        
    }    
    
    /**
     * Load the datagrid with data
     */
    public function onReload()
    {
        try
        {    
            //if ((!empty(TSession::getValue('pessoa_contratos_loaded'))) && (TSession::getValue('pessoa_contratos_count') > 0))
            if (!empty(TSession::getValue('pessoa_contratos_loaded')))            
            {    
                //$data = $this->form->getData(); // get form data as array                                   
                $pessoa_contratos = TSession::getValue('pessoa_contratos');                         
                $this->datagrid->clear();            
                if ($pessoa_contratos)
                {                                                                  
                    TTransaction::open('goldnotas'); // open a transaction                
                    foreach ($pessoa_contratos as $pessoa_contrato_id => $pessoa_contrato)
                    {   // add the object inside the datagrid
                        if ($pessoa_contrato['del'] == 'N')
                        {
                            //$pessoa = printf("[%10s]\n", $pessoa_contrato['contrato_cadpessoa_id']) . ' - ' . $pessoa_contrato['contrato_pessoa'];
                            $objpessoa = new Cadpessoa($pessoa_contrato['contrato_cadpessoa_id']);
                            $pessoa = $pessoa_contrato['contrato_cadpessoa_id'] . ' - ' . $objpessoa->pessoa;
                            $objcontrato = new Cadcontrato($pessoa_contrato['cadcontrato_id']);
                            $contrato = $pessoa_contrato['cadcontrato_id'] . ' - ' . $objcontrato->contrato;                            
                            $item = new StdClass;
                            $item->contrato_id  = $pessoa_contrato['contrato_id'];
                            $item->dtcadastro = $pessoa_contrato['dtcadastro'];
                            $item->contrato_pessoa  = $pessoa;
                            $item->contrato_modelo  = $contrato;
                            $item->dtemissao = $pessoa_contrato['dtemissao'];
                            $item->numero = $pessoa_contrato['numero'];
                            $item->dtvencimento = $pessoa_contrato['dtvencimento'];  
                            $this->datagrid->addItem($item);
                        }                        
                    }
                    TTransaction::close();                    
                }   
                //$this->form->setData($data);          
                //$this->loaded = TRUE; 
            }          
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
        }
    }

    public function onPessoaContratoAdd($param)
    {               
        try 
        {                           
            $data = $this->form->getData();   
            TSession::delValue('contrato_id');                                 
            TApplication::loadPage('CadpessoaCadcontratoplgEditarForm','onClear', ['register_state'=>'false']);
            $this->onReload();              
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }
    
    public function onPessoaContratoEdi($param)
    {               
        try 
        {                           
            $data = $this->form->getData();
            $key=$param['key'];           
            TSession::setValue('contrato_id',$key);                                      
            TApplication::loadPage('CadpessoaCadcontratoplgEditarForm','onEdit', ['register_state'=>'false']);             
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }

    public function onPessoaContratoDel($param)
    {
        try
        {
            $key=$param['key']; // get the parameter $key
            $pessoa_contratos = TSession::getValue('pessoa_contratos');
            $pessoa_contratos[$param['key']]['del'] = 'S';
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    public function onPessoaContratoImp($param)
    {
        try
        {
            TTransaction::open('goldnotas');
            $idpessoa = TSession::getValue('idpessoa');
            $contrato_id=$param['key']; // get the parameter $key
            $pessoa_contratos = TSession::getValue('pessoa_contratos');
            $contrato_cadpessoa_id = $pessoa_contratos[$contrato_id]['contrato_cadpessoa_id'];
            $cadcontrato_id = $pessoa_contratos[$contrato_id]['cadcontrato_id'];
            
            $objpessoaparceiro = new Cadpessoa($idpessoa);
            $objpessoatitular = new Cadpessoa($contrato_cadpessoa_id);
            $objcontrato = new Cadcontrato($cadcontrato_id);            
            
            $htmlcontrato = $objcontrato->modelo;
            
            $htmlcontrato = str_replace("{titularplg}", $objpessoatitular ->pessoa, $htmlcontrato);
            $htmlcontrato = str_replace("{garimpeiroparceiro}", $objpessoaparceiro->pessoa, $htmlcontrato);
            
            $filecontrato = 'contrato_' . $idpessoa . '_' .$objpessoatitular->id; 
            
            // converts the HTML template into PDF
            $dompdf = new \Dompdf\Dompdf();
            $dompdf->loadHtml($htmlcontrato);
            $dompdf->setPaper('A4', 'portrait');
            $dompdf->render();
            
            // write and open file
            file_put_contents('tmp/'.$filecontrato.'.pdf', $dompdf->output());
            parent::openFile('tmp/'.$filecontrato.'.pdf');            
            TTransaction::close();
            $this->onReload($param);
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }    

    function loadPessoaContratos($cadpessoa_id)
    {
        if(is_numeric($cadpessoa_id))
        {
            try
            {           
                if(!TSession::getValue('pessoa_contratos_loaded')) 
                {
                    $pessoa_contratos = TSession::delValue('pessoa_contratos'); 
                    TTransaction::open('goldnotas');                    
                    $pessoa_contratos_criteria = new TCriteria;                     
                    $pessoa_contratos_criteria->add(new TFilter('cadpessoa_id', '=', $cadpessoa_id));
                     
                    $repository = new TRepository('CadpessoaCadcontratoplg'); 
                    $pessoa_contratos_repo = $repository->load($pessoa_contratos_criteria);
                    $pessoa_contratos_max_ordem = 0;
                    $pessoa_contratos_count = 0 ;                    
                    foreach ($pessoa_contratos_repo as $pessoa_contrato_obj) 
                    {                                             
                        $pessoa_contratos_count++;                                                                       
                        $pessoa_contratos[$pessoa_contratos_count] = array(
                                                  'id' => $pessoa_contrato_obj->id,
                                                  'contrato_id' => $pessoa_contratos_count,
                                                  'dtemissao' => TDate::date2br($pessoa_contrato_obj->dtemissao),
                                                  'dtvencimento' => TDate::date2br($pessoa_contrato_obj->dtvencimento),
                                                  'dtcadastro' => TDate::date2br($pessoa_contrato_obj->dtcadastro),
                                                  'numero' => $pessoa_contrato_obj->numero,
                                                  'observacoes' => $pessoa_contrato_obj->observacoes,
                                                  'contrato_cadpessoa_id' => $pessoa_contrato_obj->contrato_cadpessoa_id,
                                                  'ativo' => $pessoa_contrato_obj->ativo,
                                                  'cadcontrato_id' => $pessoa_contrato_obj->cadcontrato_id,
                                                  'del' => 'N');  
                                                                        
                    }
 
                    TSession::setValue('pessoa_contratos_count', $pessoa_contratos_count);                    
                    TSession::setValue('pessoa_contratos_loaded', true); 
                    TTransaction::close();
                    TSession::setValue('pessoa_contratos', $pessoa_contratos); 
                }//joao vitor ex goleiro
            }
            catch (Exception $e)
            {
                TTransaction::rollback(); 
                new TMessage('error', $e->getMessage());
            }
        }
        return true;  
    } 
}
