<?php
/**
 * SeekCidade Listing
 * @author  <your name here>
 */
class CadpessoaCadimagemEditarForm extends TPage
{
    private $form; // form
    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
        // creates the form
        $this->adianti_target_container = 'CadpessoaCadimagem_area';
        $this->form = new BootstrapFormBuilder('form_CadpessoaCadimagemEditar');  
        //$this->form->style = 'display: table;width:100%'; // change style
        //$this->form->setFormTitle('Cadastrar Imagem');
        
        $imgpessoa = new TFile('imgpessoa');        
        $imgpessoa->addValidation('Arquivo de imagem não selecionado', new TRequiredValidator);
        
        // complete upload action
        $image_id = TSession::getValue('image_id');        
        if (empty($image_id))
        {
            $imgpessoa->setCompleteAction(new TAction(array($this, 'onComplete')));
            $imgpessoa->setAllowedExtensions( ['gif', 'png', 'jpg', 'jpeg'] );
        }     
        
        $descricaoimgpessoa = new TCombo('descricaoimgpessoa');        
        $itemsdescricaoimgpessoa = array();
        $itemsdescricaoimgpessoa['RG'] = 'RG';
        $itemsdescricaoimgpessoa['CPF'] = 'CPF'; 
        $itemsdescricaoimgpessoa['CNH'] = 'CNH';
        $itemsdescricaoimgpessoa['FICHA CADASTRAL'] = 'FICHA CADASTRAL'; 
        $itemsdescricaoimgpessoa['COMPROVANTE DE RESIDENCIA'] = 'COMPROVANTE DE RESIDENCIA'; 
        $itemsdescricaoimgpessoa['CARTEIRA DE GARIMPEIRO'] = 'CARTEIRA DE GARIMPEIRO';
        $itemsdescricaoimgpessoa['CONTRATO DE PARCERIA'] = 'CONTRATO DE PARCERIA'; 
        $itemsdescricaoimgpessoa['TITULO DE ELEITOR'] = 'TITULO DE ELEITOR';
        $itemsdescricaoimgpessoa['CARTEIRA DE TRABALHO'] = 'CARTEIRA DE TRABALHO';
        $itemsdescricaoimgpessoa['RESERVISTA'] = 'RESERVISTA';                      
        $descricaoimgpessoa->addItems($itemsdescricaoimgpessoa);
        
        $descricaoimgpessoa->addValidation( 'Descrição da imagem', new TRequiredValidator );
                           
        $this->imgpessoa_frame = new TElement('div');
        $this->imgpessoa_frame->id = 'imgpessoa_frame_Editar';
        $this->imgpessoa_frame->style = 'width:550px;height:auto;min-height:350px; frameborder="0";';       
        //border:1px solid gray;padding:4px;
        $this->form->addFields([new TLabel('Descrição')],[$descricaoimgpessoa],[]);
        if (empty($image_id))
        {        
            $this->form->addFields([new TLabel('Imagem')],[$imgpessoa],[]);
        }      
      
        $this->form->addFields([new TLabel(' ')],[$this->imgpessoa_frame],[]);

        
        //$btn = $this->form->addAction( _t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        //$btn->class = 'btn btn-sm btn-primary'; 
        //$this->form->addAction( _t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        //$this->form->addAction('Voltar', new TAction(array($this,'onCancel')), 'fa:table blue');
        
        $pessoa_image_sav = new TButton('PessoaImageSav');
        $pessoa_image_sav_action = new TAction(array($this, 'onSave'));
        $pessoa_image_sav->setAction($pessoa_image_sav_action, 'Salvar');
        $pessoa_image_sav->setImage('far:save');        

        $pessoa_image_can = new TButton('PessoaImageCan');
        $pessoa_image_can_action = new TAction(array($this, 'onCancel'));
        $pessoa_image_can->setAction($pessoa_image_can_action, 'Voltar');
        $pessoa_image_can->setImage('far:save');  
        
        $this->form->addFields([],[$pessoa_image_sav,$pessoa_image_can]);             
                
        // vertical box container
        $container = new TVBox('imagens');
        $container->style = 'width: 100%';        
        $container->add($this->form);  
        parent::add($container);       
    }
    
    public function onEdit()
    {
        $image_id = TSession::getValue('image_id');
        $pessoa_images = TSession::getValue('pessoa_images');
        $pessoaimage_id = $pessoa_images[$image_id]['id'];
        $pessoaimage_path = $pessoa_images[$image_id]['imagem'];
        $pessoaimage_descricao = $pessoa_images[$image_id]['descricao'];
        TScript::create("$('#imgpessoa_frame_Editar').html('')");
        TScript::create("$('#imgpessoa_frame_Editar').append(\"<img style='width:100%' src='{$pessoaimage_path}'>\");");  
        $obj = new StdClass;
        $obj->descricaoimgpessoa = $pessoaimage_descricao;
        TForm::sendData('form_CadpessoaCadimagemEditar', $obj);              
    }
    
    public function onClear( $param )
    {
        $this->form->clear(TRUE);                        
    }
    
    public static function onComplete($param)
    {            
        if(!empty($param['imgpessoa']))
        {            
            if(file_exists('tmp/' . $param['imgpessoa']))
            {                                                                    
                $key = TSession::getValue('idpessoa'); 
                $ext = pathinfo('tmp/'.$param['imgpessoa'], PATHINFO_EXTENSION);
                $nomeimg = 'imagestmp/' . 'img_' . mt_rand() . '_' . $key . '.' . $ext ;                                                                                       
                if(file_exists($nomeimg))
                {                                                                    
                    unlink($nomeimg);                                            
                }
                rename('tmp/' . $param['imgpessoa'], $nomeimg);
                TSession::setValue('imgpessoa',$nomeimg);                                            
            }
        }    
        TScript::create("$('#imgpessoa_frame_Editar').html('')");
        TScript::create("$('#imgpessoa_frame_Editar').append(\"<img style='width:100%' src='{$nomeimg}'>\");");                      
    }      
    
    public function onSave( $param )
    {
        try
        {
            $data = $this->form->getData();
            $this->form->validate();
            $pessoa_images = TSession::getValue('pessoa_images');  
            $image_id = TSession::getValue('image_id');
            if (empty($image_id))
            {          
                $pessoa_images_max_ordem = TSession::getValue('pessoa_images_max_ordem');
                $pessoa_images_max_ordem++;
                TSession::setValue('pessoa_images_max_ordem', $pessoa_images_max_ordem);             
                $pessoa_images_count = TSession::getValue('pessoa_images_count');
                $pessoa_images_count++;            
                TSession::setValue('pessoa_images_count', $pessoa_images_count);
                $pessoaimage_id = '';
                $imgpessoa = TSession::getValue('imgpessoa');
            } 
            else
            {                
                $pessoa_images_count = $image_id;  
                $pessoaimage_id = $pessoa_images[$image_id]['id'];
                $pessoa_images_max_ordem = $pessoa_images[$image_id]['ordem']; 
                $imgpessoa = $pessoa_images[$image_id]['imagem'];     
            }                      
            $pessoa_images[$pessoa_images_count] = array(
                                                        'id' => $pessoaimage_id,
                                                        'image_id' => $pessoa_images_count,
                                                        'descricao' => $param['descricaoimgpessoa'],
                                                        'imagem' => $imgpessoa,
                                                        'ordem' => $pessoa_images_max_ordem,
                                                        'del' => 'N');            
            TSession::setValue('pessoa_images', $pessoa_images);
            TSession::delValue('image_id');
            //parent::closeWindow();
            AdiantiCoreApplication::loadPage('CadpessoaCadimagemForm', 'onReload', ['register_state'=>'false']);
            //TApplication::loadPage('CadpessoaCadimagemEditarForm','onReload', ['register_state'=>'false']);
            //$this->form->setData($data);
            //$this->onReload( $param );
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    }  
    
    public function onCancel( $param )
    {
        try
        {
            AdiantiCoreApplication::loadPage('CadpessoaCadimagemForm', 'onReload', ['register_state'=>'false']);
            //TApplication::loadPage('CadpessoaCadimagemEditarForm','onReload', ['register_state'=>'false']);
            //$this->form->setData($data);
            //$this->onReload( $param );
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    }    
       
}
        