<?php
/**
 * CadpessoaCadplgEditarForm Form
 * @author  <your name here>
 */
class CadpessoaCadplgEditarForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        parent::__construct();   
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
        // creates the form
        $this->adianti_target_container = 'CadpessoaCadplg_area';
        $this->form = new BootstrapFormBuilder('form_CadpessoaCadplgEditar');        


        // create the form fields
        $id = new TEntry('id');
        $vencimentoplg = new TDate('vencimentoplg');
        $numeroplg = new TEntry('numeroplg');
        $processodnpm = new TEntry('processodnpm');
        $localidadeaurifera = new TEntry('localidadeaurifera');
        $regiaoaurifera = new TEntry('regiaoaurifera');
        $plg_id = new THidden('plg_id');

        $id->setEditable(FALSE);
        $id->setSize('50%');  
        
        $vencimentoplg->setSize('50%');
        $vencimentoplg->setMask('dd/mm/yyyy');
        $vencimentoplg->setDatabaseMask('yyyy-mm-dd');              
        
        $numeroplg->setSize('50%');
        $processodnpm->setSize('50%');
        $localidadeaurifera->setSize('50%');
        $regiaoaurifera->setSize('50%');
        
        $this->form->addFields([new TLabel('Código')],[$id]);
        $this->form->addFields([new TLabel('Vencimento')],[$vencimentoplg]);
        $this->form->addFields([new TLabel('N.PLG')],[$numeroplg]);
        $this->form->addFields([new TLabel('Processo DNPM')],[$processodnpm]);
        $this->form->addFields([new TLabel('Localidade Aurifera')],[$localidadeaurifera]);
        $this->form->addFields([new TLabel('Região Aurifera')],[$regiaoaurifera]);
        $this->form->addFields([$plg_id]);

         
        // create the form actions
        $pessoa_plg_sav = new TButton('PessoaplgSav');
        $pessoa_plg_sav_action = new TAction(array($this, 'onSave'));
        $pessoa_plg_sav->setAction($pessoa_plg_sav_action, 'Salvar');
        $pessoa_plg_sav->setImage('far:save');        

        $pessoa_plg_can = new TButton('PessoaplgCan');
        $pessoa_plg_can_action = new TAction(array($this, 'onCancel'));
        $pessoa_plg_can->setAction($pessoa_plg_can_action, 'Voltar');
        $pessoa_plg_can->setImage('far:save');  
        
        $this->form->addFields([],[$pessoa_plg_sav,$pessoa_plg_can]);  
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';        
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            $data = $this->form->getData();
            $this->form->validate();
            $pessoa_plgs = TSession::getValue('pessoa_plgs');  
            $plg_id = TSession::getValue('plg_id');
            if (empty($plg_id))
            {                      
                $pessoa_plgs_count = TSession::getValue('pessoa_plgs_count');
                $pessoa_plgs_count++;            
                TSession::setValue('pessoa_plgs_count', $pessoa_plgs_count);                               
            } 
            else
            {                
                $pessoa_plgs_count = $plg_id;                       
            }                      
            $pessoa_plgs[$pessoa_plgs_count] = array(
                                                        'id' => $param['id'],
                                                        'plg_id' => $pessoa_plgs_count,
                                                        'vencimentoplg' => $param['vencimentoplg'],
                                                        'numeroplg' => $param['numeroplg'],
                                                        'dtcadastro' => $param['dtcadastro'],
                                                        'numero' => $param['numero'],
                                                        'processodnpm' => $param['processodnpm'],
                                                        'localidadeaurifera' => $param['localidadeaurifera'],
                                                        'regiaoaurifera' => $param['regiaoaurifera'],
                                                        'del' => 'N');                                                                   
            TSession::setValue('pessoa_plgs', $pessoa_plgs);
            TSession::delValue('plg_id');
            AdiantiCoreApplication::loadPage('CadpessoaCadplgForm', 'onReload', ['register_state'=>'false']);
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);       
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            $data = $this->form->getData();             
            $this->form->clear(TRUE);            
            $plg_id = TSession::getValue('plg_id');
            $pessoa_plgs = TSession::getValue('pessoa_plgs');
            $id = $pessoa_plgs[$plg_id]['id'];            
            $vencimentoplg = $pessoa_plgs[$plg_id]['vencimentoplg']; 
            $numeroplg = $pessoa_plgs[$plg_id]['numeroplg'];
            $processodnpm = $pessoa_plgs[$plg_id]['processodnpm'];
            $localidadeaurifera = $pessoa_plgs[$plg_id]['localidadeaurifera'];
            $regiaoaurifera = $pessoa_plgs[$plg_id]['regiaoaurifera'];
                    
            $obj = new StdClass;
            $obj->id = $id;
            $obj->plg_id = $plg_id;
            $obj->vencimentoplg = $vencimentoplg;
            $obj->numeroplg = $numeroplg;
            $obj->processodnpm = $processodnpm;
            $obj->localidadeaurifera = $localidadeaurifera;
            $obj->regiaoaurifera = $regiaoaurifera;
            TForm::sendData('form_CadpessoaCadplgEditar', $obj);                                  
            
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    }
    public function onCancel( $param )
    {
        try
        {
            AdiantiCoreApplication::loadPage('CadpessoaCadplgForm', 'onReload', ['register_state'=>'false']);
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    } 
}
