<?php
/**
 * CadplanocontaForm Form
 * @author  <your name here>
 */
class CadplanocontaForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadplanoconta'); 
        //$this->form->style = 'display: table;width:100%'; // change style
        $this->form->setFormTitle('Plano de Contas');        

        $idpconta = $param['id']??'';
        // create the form fields
        $id = new TEntry('id');
        
        $id_planoconta = new TEntry('id_planoconta');
        //$id_agrupador = new TDBUniqueSearch('id_agrupador', 'goldnotas', 'Cadplanoconta', 'id', 'planoconta', 'planoconta');
        //$id_agrupador = new TDBSeekButton('id_agrupador', 'goldnotas', 'Cadplanoconta', 'id', 'planoconta', 'planoconta');
        if (empty($idpconta))
        {
            $id_agrupador = new TCombo('id_agrupador');
            $analiticosintetico = new TCombo('analiticosintetico');
            $debitocredito = new TCombo('debitocredito');            
        }
        else
        {
            $id_agrupador = new THidden('id_agrupador');
            $analiticosintetico = new THidden('analiticosintetico');
            $debitocredito = new THidden('debitocredito');
            $id_agrupadordesc = new TEntry('id_agrupadordesc');
            $analiticosinteticodesc = new TEntry('analiticosinteticodesc');
            $debitocreditodesc = new TEntry('debitocreditodesc');                                
        }
        $id_sequencia = new THidden('id_sequencia');
        $id_nivel = new THidden('id_nivel');
        $planoconta = new TEntry('planoconta');
        $classificacao = new TCombo('classificacao');
        $ativo = new TCheckGroup('ativo');

        $id->setEditable(FALSE);
        $id->setSize('20%');        
        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items);         
        $planoconta->setSize('50%');        

        if (empty($idpconta))
        {        
            $itensdebcred = array();
            $itensdebcred['D'] = 'Débito';
            $itensdebcred['C'] = 'Crédito';
            $debitocredito->addItems($itensdebcred);
            $debitocredito->setSize('20%'); 
            
            $debitocredito_action = new TAction(array($this, 'onChangeDebitoCredito'));
            $debitocredito->setChangeAction($debitocredito_action);                     
    
            $itensanasint = array();
            $itensanasint['A'] = 'Analítico';
            $itensanasint['S'] = 'Sintético';
            $analiticosintetico->addItems($itensanasint);
            $analiticosintetico->setSize('20%');
            $id_agrupador->setSize('50%');
        }
        else
        {
            $debitocreditodesc->setEditable(False);
            $debitocreditodesc->setSize('20%');
            $analiticosinteticodesc->setEditable(False);
            $analiticosinteticodesc->setSize('20%');            
            $id_agrupadordesc->setEditable(False);           
            $id_agrupadordesc->setSize('50%');
        }    
        $id_planoconta->setSize('20%');
        $id_planoconta->setEditable(False);
        $itensclassificacao = array();
        $itensclassificacao['A'] = 'Ativo';
        $itensclassificacao['P'] = 'Passivo';
        $itensclassificacao['C'] = 'Custos e Despesas';
        $itensclassificacao['R'] = 'Receitas';
        $itensclassificacao['O'] = 'Outros';
        $classificacao->addItems($itensclassificacao);
        $classificacao->setSize('20%');        

        // add the fields
        
        $this->form->addFields([new TLabel('Código')],[$id,$ativo]);
        $this->form->addFields([new TLabel('Descrição')],[$planoconta]);
        if (empty($idpconta))
        {        
            $this->form->addFields([new TLabel('Tipo')],[$analiticosintetico]);
            $this->form->addFields([new TLabel('Débito/Crédito')],[$debitocredito]);
        }
        else
        {
            $this->form->addFields([new TLabel('Tipo')],[$analiticosinteticodesc]);
            $this->form->addFields([new TLabel('Débito/Crédito')],[$debitocreditodesc]); 
            $this->form->addFields([$analiticosintetico]);
            $this->form->addFields([$debitocredito]);                                       
        }
        $this->form->addFields([new TLabel('Classificação')],[$classificacao]);
        $this->form->addFields([new TLabel('Estrutura')],[$id_planoconta]);
        if (empty($idpconta))
        {        
            $this->form->addFields([new TLabel('Conta Agrupadora')],[$id_agrupador]);
        }
        else
        {
            $this->form->addFields([new TLabel('Conta Agrupadora')],[$id_agrupadordesc]);
            $this->form->addFields([$id_agrupador]);        
        }            

        $id->setEditable(FALSE);
        
        /** samples
        $this->form->addQuickFields('Date', array($date1, new TLabel('to'), $date2)); // side by side fields
        $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
        $fieldX->setSize( 100, 40 ); // set size
        **/
         
        // create the form actions
        //$btn = $this->form->addQuickAction(_t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        //$btn->class = 'btn btn-sm btn-primary';
        //$this->form->addQuickAction(_t('New'),  new TAction(array($this, 'onClear')), 'bs:plus-sign green');
        // create the form actions
        $btn = $this->form->addAction( _t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addAction( _t('New'), new TAction(array($this, 'onEdit')), 'fa:eraser red');        
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadplanocontaList','onReload')), 'fa:table blue');        
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadplanocontaList'));
        //$container->add(TPanelGroup::pack('Plano de Contas', $this->form));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            
            $object = new Cadplanoconta;  // create an empty object
            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data
            if (empty($object->id))
            { 
                $data->ativo = 'S';
                $novo = 'S';
            }
            if ((empty($object->id)) and (empty($object->id_agrupador)))
            {
                $filtro = new TCriteria;                                    
                $filtro->add(new TFilter('id_agrupador', 'IS', NULL));                
                $repos = new HRepository('Cadplanoconta');                     
                $max = $repos->max('id_sequencia',$filtro);    
                $max++;           
                //echo 'Max: ' . $max . "</br>"; 
                $object->id_sequencia = $max;
                $object->id_planoconta = $max;
                $object->id_nivel = 1;                
            }
            else if ((empty($object->id)) and (!empty($object->id_agrupador)))
            {                        
                $filtro = new TCriteria;                                    
                $filtro->add(new TFilter('id_agrupador', '=', "{$object->id_agrupador}"));                
                $repos = new HRepository('Cadplanoconta');                     
                $max = $repos->max('id_sequencia',$filtro);    
                $max++;          
                $planocontapai = new Cadplanoconta($object->id_agrupador); 
                $idnivel = $planocontapai->id_nivel;
                $idnivel++;
                $object->id_nivel = $idnivel;
                $object->id_sequencia = $max;
                $idplanoconta = str_pad($max , $idnivel, "0", STR_PAD_LEFT);              
                $object->id_planoconta = $planocontapai->id_planoconta . '.' . $idplanoconta;
            }
            $ativo = $data->ativo;
            if ( !empty($ativo))
            {
                $object->ativo = 'S';
            }
            else { $object->ativo = 'N'; }
                                    
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            $this->form->setData($data); // fill form data                   
            TTransaction::close(); // close the transaction
            
            TCombo::disableField('form_Cadplanoconta', 'id_agrupador');
            TCombo::disableField('form_Cadplanoconta', 'debitocredito');
            TCombo::disableField('form_Cadplanoconta', 'analiticosintetico');
            $this->onChangeDebitoCredito($param);            
            $obj = new StdClass;
            $obj->id_agrupador = $object->id_agrupador; 
            $obj->debitocredito = $object->debitocredito;               
            TForm::sendData('form_Cadplanoconta', $obj);               
            
            //new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
            if (isset($novo))
            {
                //echo 'LoadPage' . "</br>";
                AdiantiCoreApplication::loadPage('CadplanocontaForm', 'onEdit', ['key'=>$object->id,'id'=>$object->id,'register_state'=>'false']);
            }    
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadplanoconta($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                $obj = new StdClass;                
                if ($object->debitocredito == 'D')
                {
                    $obj->debitocreditodesc = 'Débito';    
                }
                else
                {
                    $obj->debitocreditodesc = 'Crédito';
                }
                if ($object->analiticosintetico == 'A')
                {
                    $obj->analiticosinteticodesc = 'Analítico';    
                }
                else
                {
                    $obj->analiticosinteticodesc = 'Sintético';
                }                
                $planocontapai2 = new Cadplanoconta($object->id_agrupador);
                //echo 'Agrupador = ' . $planocontapai2->planoconta . "</br>";
                if (!empty($object->id_agrupador))
                {
                    $obj->id_agrupadordesc = $planocontapai2->id_planoconta . ' - ' . $planocontapai2->planoconta;
                }    
                $obj->ativo = $object->ativo;
                TForm::sendData('form_Cadplanoconta', $obj);
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public static function onChangeDebitoCredito( $param )
    {
        TTransaction::open('goldnotas'); 
        $filtro_param['order'] = 'planoconta';
        $filtro_param['direction'] = 'asc';                                        
        $filtro = new TCriteria;                     
        $filtro->add(new TFilter('debitocredito', '=', "{$param['debitocredito']}"));
        $filtro->add(new TFilter('analiticosintetico', '=', 'S'));                
        $filtro->setProperties($filtro_param); 
        $repository = new TRepository('Cadplanoconta');                     
        $planoconta_repo = $repository->load($filtro);
        $items = array();
        foreach ($planoconta_repo as $object)
        {            
            $items[$object->id] = $object->planoconta;
        }   
        TCombo::reload('form_Cadplanoconta', 'id_agrupador', $items);             
    }
}
