<?php
/**
 * CadtabelaprecoList Listing
 * @author  <your name here>
 */
class CadtabelaprecoList extends TPage
{
    private $form; // form
    private $datagrid; // listing
    private $pageNavigation;
    private $formgrid;
    private $loaded;
    private $deleteButton;
    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();
        
        // creates the form
        $this->form = new TQuickForm('form_search_Cadtabelapreco');
        $this->form->class = 'tform'; // change CSS class
        $this->form = new BootstrapFormWrapper($this->form);
        $this->form->style = 'display: table;width:100%'; // change style
        $this->form->setFormTitle('Cadtabelapreco');
        

        // create the form fields
        $id = new TEntry('id');
        $tabelapreco = new TEntry('tabelapreco');
        $ativo = new TCombo('ativo');

        $ativo->addItems(s7sdiversos::listsimnao());
        $ativo->setValue('S');
        // add the fields
        $this->form->addQuickField('Id', $id,  200 );
        $this->form->addQuickField('Tabela Preço', $tabelapreco,  200 );
        $this->form->addQuickField('Ativo', $ativo,  200 );

        
        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue('Cadtabelapreco_filter_data') );
        
        // add the search form actions
        $this->form->addQuickAction(_t('Find'), new TAction(array($this, 'onSearch')), 'fa:search');
        $this->form->addQuickAction(_t('New'),  new TAction(array('CadtabelaprecoForm', 'onEdit')), 'bs:plus-sign green');
        
        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_id = new TDataGridColumn('id', 'Id', 'right');
        $column_tabelapreco = new TDataGridColumn('tabelapreco', 'Tabela Preço', 'left');
        $column_percentual = new TDataGridColumn('percentual', 'Percentual', 'right');
        $column_descontomaximo = new TDataGridColumn('descontomaximo', 'Desconto máximo', 'right');
        $column_entradaminima = new TDataGridColumn('entradaminima', 'Entrada mínima', 'right');
        $column_verificadebito = new TDataGridColumn('verificadebito', 'Verificar débito', 'left');
        $column_verificalimite = new TDataGridColumn('verificalimite', 'Verificar limite', 'left');
        $column_verificacadastro = new TDataGridColumn('verificacadastro', 'Verificar cadastro', 'left');
        $column_ativo = new TDataGridColumn('ativo', 'Ativo', 'left');


        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_id);
        $this->datagrid->addColumn($column_tabelapreco);
        $this->datagrid->addColumn($column_percentual);
        $this->datagrid->addColumn($column_descontomaximo);
        $this->datagrid->addColumn($column_entradaminima);
        $this->datagrid->addColumn($column_verificadebito);
        $this->datagrid->addColumn($column_verificalimite);
        $this->datagrid->addColumn($column_verificacadastro);
        $this->datagrid->addColumn($column_ativo);


        // creates the datagrid column actions
        $order_id = new TAction(array($this, 'onReload'));
        $order_id->setParameter('order', 'id');
        $column_id->setAction($order_id);
        
        $order_tabelapreco = new TAction(array($this, 'onReload'));
        $order_tabelapreco->setParameter('order', 'tabelapreco');
        $column_tabelapreco->setAction($order_tabelapreco);
        
        $order_ativo = new TAction(array($this, 'onReload'));
        $order_ativo->setParameter('order', 'ativo');
        $column_ativo->setAction($order_ativo);
        
        $column_ativo->setTransformer( function($value, $object, $row) {
            $class = ($value=='N') ? 'danger' : 'success';
            $label = ($value=='N') ? _t('No') : _t('Yes');
            $div = new TElement('span');
            $div->class="label label-{$class}";
            $div->style="text-shadow:none; font-size:12px; font-weight:lighter";
            $div->add($label);
            return $div;
        }); 
        
        $column_verificadebito->setTransformer( function($value, $object, $row) {
            $class = ($value=='N') ? 'danger' : 'success';
            $label = ($value=='N') ? _t('No') : _t('Yes');
            $div = new TElement('span');
            $div->class="label label-{$class}";
            $div->style="text-shadow:none; font-size:12px; font-weight:lighter";
            $div->add($label);
            return $div;
        });         
        
        $column_verificacadastro->setTransformer( function($value, $object, $row) {
            $class = ($value=='N') ? 'danger' : 'success';
            $label = ($value=='N') ? _t('No') : _t('Yes');
            $div = new TElement('span');
            $div->class="label label-{$class}";
            $div->style="text-shadow:none; font-size:12px; font-weight:lighter";
            $div->add($label);
            return $div;
        });     
        
        $column_verificalimite->setTransformer( function($value, $object, $row) {
            $class = ($value=='N') ? 'danger' : 'success';
            $label = ($value=='N') ? _t('No') : _t('Yes');
            $div = new TElement('span');
            $div->class="label label-{$class}";
            $div->style="text-shadow:none; font-size:12px; font-weight:lighter";
            $div->add($label);
            return $div;
        });             
        
        // create EDIT action
        $action_edit = new TDataGridAction(array('CadtabelaprecoForm', 'onEdit'));
        $action_edit->setUseButton(TRUE);
        $action_edit->setButtonClass('btn btn-default');
        //$action_edit->setLabel(_t('Edit'));
        $action_edit->setImage('far:edit blue fa-lg');
        $action_edit->setField('id');
        $this->datagrid->addAction($action_edit);
        
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onDelete'));
        $action_del->setUseButton(TRUE);
        $action_del->setButtonClass('btn btn-default');
        //$action_del->setLabel(_t('Delete'));
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('id');
        $this->datagrid->addAction($action_del);
        
        // create the datagrid model
        $this->datagrid->createModel();
        
        // creates the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->setAction(new TAction(array($this, 'onReload')));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());
        


        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add(TPanelGroup::pack('Listagem', $this->form));
        $container->add($this->datagrid);
        $container->add($this->pageNavigation);
        
        parent::add($container);
    }
    
    /**
     * Inline record editing
     * @param $param Array containing:
     *              key: object ID value
     *              field name: object attribute to be updated
     *              value: new attribute content 
     */
    public function onInlineEdit($param)
    {
        try
        {
            // get the parameter $key
            $field = $param['field'];
            $key   = $param['key'];
            $value = $param['value'];
            
            TTransaction::open('sample'); // open a transaction with database
            $object = new Cadtabelapreco($key); // instantiates the Active Record
            $object->{$field} = $value;
            $object->store(); // update the object in the database
            TTransaction::close(); // close the transaction
            
            $this->onReload($param); // reload the listing
            new TMessage('info', "Record Updated");
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', '<b>Error</b> ' . $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Register the filter in the session
     */
    public function onSearch()
    {
        // get the search form data
        $data = $this->form->getData();
        
        // clear session filters
        TSession::setValue('CadtabelaprecoList_filter_id',   NULL);
        TSession::setValue('CadtabelaprecoList_filter_tabelapreco',   NULL);
        TSession::setValue('CadtabelaprecoList_filter_ativo',   NULL);

        if (isset($data->id) AND ($data->id)) {
            $filter = new TFilter('id', 'like', "%{$data->id}%"); // create the filter
            TSession::setValue('CadtabelaprecoList_filter_id',   $filter); // stores the filter in the session
        }


        if (isset($data->tabelapreco) AND ($data->tabelapreco)) {
            $filter = new TFilter('tabelapreco', 'like', "%{$data->tabelapreco}%"); // create the filter
            TSession::setValue('CadtabelaprecoList_filter_tabelapreco',   $filter); // stores the filter in the session
        }


        if (isset($data->ativo) AND ($data->ativo)) {
            $filter = new TFilter('ativo', 'like', "%{$data->ativo}%"); // create the filter
            TSession::setValue('CadtabelaprecoList_filter_ativo',   $filter); // stores the filter in the session
        }

        
        // fill the form with data again
        $this->form->setData($data);
        
        // keep the search data in the session
        TSession::setValue('Cadtabelapreco_filter_data', $data);
        
        $param=array();
        $param['offset']    =0;
        $param['first_page']=1;
        $this->onReload($param);
    }
    
    /**
     * Load the datagrid with data
     */
    public function onReload($param = NULL)
    {
        try
        {
            // open a transaction with database 'sample'
            TTransaction::open('sample');
            
            // creates a repository for Cadtabelapreco
            $repository = new TRepository('Cadtabelapreco');
            $limit = 10;
            // creates a criteria
            $criteria = new TCriteria;
            
            // default order
            if (empty($param['order']))
            {
                $param['order'] = 'id';
                $param['direction'] = 'asc';
            }
            $criteria->setProperties($param); // order, offset
            $criteria->setProperty('limit', $limit);
            

            if (TSession::getValue('CadtabelaprecoList_filter_id')) {
                $criteria->add(TSession::getValue('CadtabelaprecoList_filter_id')); // add the session filter
            }


            if (TSession::getValue('CadtabelaprecoList_filter_tabelapreco')) {
                $criteria->add(TSession::getValue('CadtabelaprecoList_filter_tabelapreco')); // add the session filter
            }


            if (TSession::getValue('CadtabelaprecoList_filter_ativo')) {
                $criteria->add(TSession::getValue('CadtabelaprecoList_filter_ativo')); // add the session filter
            }

            
            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);
            
            if (is_callable($this->transformCallback))
            {
                call_user_func($this->transformCallback, $objects, $param);
            }
            
            $this->datagrid->clear();
            if ($objects)
            {
                // iterate the collection of active records
                foreach ($objects as $object)
                {
                    // add the object inside the datagrid
                    $this->datagrid->addItem($object);
                }
            }
            
            // reset the criteria for record count
            $criteria->resetProperties();
            $count= $repository->count($criteria);
            
            $this->pageNavigation->setCount($count); // count of records
            $this->pageNavigation->setProperties($param); // order, page
            $this->pageNavigation->setLimit($limit); // limit
            
            // close the transaction
            TTransaction::close();
            $this->loaded = true;
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }
    
    /**
     * Ask before deletion
     */
    public function onDelete($param)
    {
        // define the delete action
        $action = new TAction(array($this, 'Delete'));
        $action->setParameters($param); // pass the key parameter ahead
        
        // shows a dialog to the user
        new TQuestion(AdiantiCoreTranslator::translate('Do you really want to delete ?'), $action);
    }
    
    /**
     * Delete a record
     */
    public function Delete($param)
    {
        try
        {
            $key=$param['key']; // get the parameter $key
            TTransaction::open('sample'); // open a transaction with database
            $object = new Cadtabelapreco($key, FALSE); // instantiates the Active Record
            $object->delete(); // deletes the object from the database
            TTransaction::close(); // close the transaction
            $this->onReload( $param ); // reload the listing
            new TMessage('info', AdiantiCoreTranslator::translate('Record deleted')); // success message
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    



    
    /**
     * method show()
     * Shows the page
     */
    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded AND (!isset($_GET['method']) OR !(in_array($_GET['method'],  array('onReload', 'onSearch')))) )
        {
            if (func_num_args() > 0)
            {
                $this->onReload( func_get_arg(0) );
            }
            else
            {
                $this->onReload();
            }
        }
        parent::show();
    }
}
