<?php
/**
 * cadfuncionarioForm Form
 * @author  <your name here>
 */
class cadfuncionarioForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new TQuickForm('form_cadfuncionario');
        $this->form->class = 'tform'; // change CSS class
        $this->form = new BootstrapFormWrapper($this->form);
        $this->form->style = 'display: table;width:100%'; // change style
        
        // define the form title
        $this->form->setFormTitle('cadfuncionario');
        


        // create the form fields
        $codigo = new TEntry('codigo');
        $nome = new TEntry('nome');
        $endereco = new TEntry('endereco');
        $bairro = new TEntry('bairro');
        $cidade = new TEntry('cidade');
        $uf = new TEntry('uf');
        $cep = new TEntry('cep');
        $telefone = new TEntry('telefone');
        $celular = new TEntry('celular');
        $email = new TEntry('email');
        $cpf = new TEntry('cpf');
        $rg = new TEntry('rg');
        $ctps = new TEntry('ctps');
        $funcao = new TEntry('funcao');
        $data_admissao = new TDate('data_admissao');
        $data_demissao = new TDate('data_demissao');
        $situacao = new TEntry('situacao');
        $salario = new TEntry('salario');
        $comissao = new TEntry('comissao');
        $comissao2 = new TEntry('comissao2');
        $obs1 = new TEntry('obs1');
        $obs2 = new TEntry('obs2');
        $obs3 = new TEntry('obs3');
        $nascimento = new TDate('nascimento');
        $f_caixa = new TEntry('f_caixa');
        $f_vendedor = new TEntry('f_vendedor');
        $f_tecnico = new TEntry('f_tecnico');
        $numero = new TEntry('numero');


        // add the fields
        $this->form->addQuickField('Codigo', $codigo,  '100%' );
        $this->form->addQuickField('Nome', $nome,  '100%' );
        $this->form->addQuickField('Endereco', $endereco,  '100%' );
        $this->form->addQuickField('Bairro', $bairro,  '100%' );
        $this->form->addQuickField('Cidade', $cidade,  '100%' );
        $this->form->addQuickField('Uf', $uf,  '100%' );
        $this->form->addQuickField('Cep', $cep,  '100%' );
        $this->form->addQuickField('Telefone', $telefone,  '100%' );
        $this->form->addQuickField('Celular', $celular,  '100%' );
        $this->form->addQuickField('Email', $email,  '100%' );
        $this->form->addQuickField('Cpf', $cpf,  '100%' );
        $this->form->addQuickField('Rg', $rg,  '100%' );
        $this->form->addQuickField('Ctps', $ctps,  '100%' );
        $this->form->addQuickField('Funcao', $funcao,  '100%' );
        $this->form->addQuickField('Data Admissao', $data_admissao,  '50%' );
        $this->form->addQuickField('Data Demissao', $data_demissao,  '50%' );
        $this->form->addQuickField('Situacao', $situacao,  '50%' );
        $this->form->addQuickField('Salario', $salario,  '50%' );
        $this->form->addQuickField('Comissao', $comissao,  '50%' );
        $this->form->addQuickField('Comissao2', $comissao2,  '100%' );
        $this->form->addQuickField('Obs1', $obs1,  '100%' );
        $this->form->addQuickField('Obs2', $obs2,  '100%' );
        $this->form->addQuickField('Obs3', $obs3,  '100%' );
        $this->form->addQuickField('Nascimento', $nascimento,  '50%' );
        $this->form->addQuickField('F Caixa', $f_caixa,  '50%' );
        $this->form->addQuickField('F Vendedor', $f_vendedor,  '50%' );
        $this->form->addQuickField('F Tecnico', $f_tecnico,  '50%' );
        $this->form->addQuickField('Numero', $numero,  '100%' );




        if (!empty($codigo))
        {
            $codigo->setEditable(FALSE);
        }
        
        /** samples
         $this->form->addQuickFields('Date', array($date1, new TLabel('to'), $date2)); // side by side fields
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( 100, 40 ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addQuickAction(_t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addQuickAction(_t('New'),  new TAction(array($this, 'onClear')), 'bs:plus-sign green');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add(TPanelGroup::pack('Title', $this->form));
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('siscom'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            
            $object = new cadfuncionario;  // create an empty object
            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated codigo
            $data->codigo = $object->codigo;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('siscom'); // open a transaction
                $object = new cadfuncionario($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
