<?php
/**
 * CadgrupoprodutoForm Form
 * @author  <your name here>
 */
class CadgrupoprodutoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadgrupoproduto');
        $this->form->setFormTitle('Grupo Produto');
        
        $idgrupo = $param['id']??'';
        if ( !empty($idgrupo))
        {
            TSession::setValue('idgrupo',$idgrupo);
        }

        // create the form fields
        $id = new TEntry('id');
        $grupoproduto = new TEntry('grupoproduto');
        $ativo = new TCombo('ativo');
        $comissao = new TEntry('comissao');
        $descontomaximo = new TEntry('descontomaximo');

        $ativo->addItems(s7sdiversos::listsimnao());
        $ativo->setValue('S');
        
        $comissao->setNumericMask(2, ',', '.', True);
        $descontomaximo->setNumericMask(2, ',', '.', True);

        // add the fields
        $this->form->addFields( [ new TLabel('Código') ], [ $id ] );
        $this->form->addFields( [ new TLabel('Grupo') ], [ $grupoproduto ] );
        $this->form->addFields( [ new TLabel('Ativo') ], [ $ativo ] );
        $this->form->addFields( [ new TLabel('Comissão') ], [ $comissao ] );
        $this->form->addFields( [ new TLabel('Desconto Máximo') ], [ $descontomaximo ] );



        // set sizes
        $id->setSize('10%');
        $grupoproduto->setSize('30%');
        $ativo->setSize('30%');
        $comissao->setSize('30%');
        $descontomaximo->setSize('30%');



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        //subgrupo
        //$this->form->addContent( ['<h4>Sub Grupo</h4><hr>'] );
        $label1 = new TLabel('Subgrupo', '#7D78B6', 12, 'b');                       
        $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $label1->setSize('100%');
        $this->form->addContent( [$label1] );    
        // place where the products page will be inserted
        $details_area = new TElement('div');
        $details_area->id = 'Cadsubgrupoproduto_area';            
        //$this->form->addContent( [TElement::tag('h4', 'Imagens')] );
        $this->form->addContent( [$details_area] );

        // Load SaleDetailForm into details_area
        AdiantiCoreApplication::loadPage('CadsubgrupoprodutoForm', 'onEdit', ['register_state'=>'false']);                 
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addAction(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadgrupoprodutoList','onReload')), 'fa:table blue');
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
         $container->add(new TXMLBreadCrumb('menu.xml', 'CadgrupoprodutoList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Cadgrupoproduto;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            
            $subgruposproduto = TSession::getValue('subgruposproduto');
            if ($subgruposproduto)
            {
                foreach ($subgruposproduto as $subgrupoproduto)
                {
                    //echo var_dump($contrato_item);
                    if ($subgrupoproduto['del'] == 'N')
                    {
                        $itemtmp = new Cadsubgrupoproduto;
                        $itemtmp->id = $subgrupoproduto['id'];
                        $itemtmp->subgrupoproduto = $subgrupoproduto['subgrupoproduto'];                     
                        $object->addCadsubgrupoproduto($itemtmp);                            
                    }   
                }    
            }            
            
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadgrupoproduto($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
