<?php
/**
 * CadprodutoForm Form
 * @author  <your name here>
 */
class CadprodutoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        parent::include_js('app/lib/include/application.js');
        parent::include_js('app/lib/include/app_sctipt_tabenter.js');
        TPage::include_js('app/resources/eventosjs.js');         
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadproduto');
        $this->form->setFormTitle('Cadastro de Produtos');
        TTransaction::open('goldnotas');
        //TTransaction::dump();
        $idempresa = TSession::getValue('userunitid');        
        $cadempresa = new Cadempresa($idempresa);        
        
        $uf = $cadempresa->cadcidade->uf;
        TTransaction::close();
        
        // create the form fields
        
        $id = new TEntry('id');
        $produto = new TEntry('produto');
        $unidade = new TEntry('unidade');
        $codbarras = new TEntry('codbarras');
        $reffabricante = new TEntry('reffabricante');
        $referencia = new TEntry('referencia');
        $tipo = new TCombo('tipo');
        $origem = new TCombo('origem');  
              
        $filter = new TCriteria; 
        $filter->add(new TFilter('uf', '=', $uf));                     
        $ncm = new TDBUniqueSearch('ncm', 'goldnotas', 'Cadncm', 'ncm', 'ncm', NULL, $filter);
        
        $ncmex = new TEntry('ncmex');
        $cest = new TEntry('cest');
        $datacadastro = new TDate('datacadastro');
        $custocompra = new TEntry('custocompra');
        $customedio = new TEntry('customedio');
        $custofinal = new TEntry('custofinal');
        $precovenda = new TEntry('precovenda');
        $margemlucro = new TEntry('margemlucro');
        $pesobruto = new TEntry('pesobruto');
        $pesoliquido = new TEntry('pesoliquido');
        $comissao = new TEntry('comissao');
        $descontomaximo = new TEntry('descontomaximo');
        $estoquemaximo = new TEntry('estoquemaximo');
        $estoqueminimo = new TEntry('estoqueminimo');
        $usagrade = new TCheckGroup('usagrade');
        $usaserial = new TCheckGroup('usaserial');
        $balancavalidade = new TEntry('balancavalidade');
        $balancatecla = new TEntry('balancatecla');
        $balancaexporta = new TCheckGroup('balancaexporta');
        $aplicacao = new TText('aplicacao');
        $pathimagem = new TEntry('pathimagem');
        $cadgrupoproduto_id = new TDBCombo('cadgrupoproduto_id', 'goldnotas', 'Cadgrupoproduto', 'id', 'grupoproduto');
        $cadsubgrupoproduto_id = new TDBCombo('cadsubgrupoproduto_id', 'goldnotas', 'Cadsubgrupoproduto', 'id', 'subgrupoproduto');
        $cadfabricante_id = new TDBCombo('cadfabricante_id', 'goldnotas', 'Cadfabricante', 'id', 'fabricante');
        $cadgrade_id = new TEntry('cadgrade_id');
        $ativo = new TCheckGroup('ativo');
        $produtoservico = new TCombo('produtoservico');
   

        // set sizes
        
        
        
        $id->setSize('100%');
        $produto->setSize('100%');
        $unidade->setSize('100%');
        $codbarras->setSize('100%');
        $reffabricante->setSize('100%');
        $referencia->setSize('100%');
        $tipo->setSize('100%');
        $origem->setSize('100%');
        $ncm->setSize('100%');
        $ncmex->setSize('100%');
        $cest->setSize('100%');
        $datacadastro->setSize('100%');
        $custocompra->setSize('100%');
        $customedio->setSize('100%');
        $custofinal->setSize('100%');
        $precovenda->setSize('100%');
        $margemlucro->setSize('100%');
        $pesobruto->setSize('100%');
        $pesoliquido->setSize('100%');
        $comissao->setSize('100%');
        $descontomaximo->setSize('100%');
        $estoquemaximo->setSize('100%');
        $estoqueminimo->setSize('100%');
        $usagrade->setSize('100%');
        $usaserial->setSize('100%');
        $balancavalidade->setSize('100%');
        $balancatecla->setSize('100%');
        $balancaexporta->setSize('100%');
        $aplicacao->setSize('100%');
        $pathimagem->setSize('100%');
        $cadgrupoproduto_id->setSize('100%');
        $cadsubgrupoproduto_id->setSize('100%');
        $cadfabricante_id->setSize('100%');
        $cadgrade_id->setSize('100%');
        $ativo->setSize('100%');
        $produtoservico->setSize('100%');
        $datacadastro->setMask('dd/mm/yyyy');
        $datacadastro->setDatabaseMask('yyyy-mm-dd');
        
        $origem->addItems(s7sdiversos::listorigemproduto());
        $tipo->addItems(s7sdiversos::listtipoproduto());
        $produtoservico->addItems(s7sdiversos::listprodutoservico());
               
        $onExitMargemLucro = new TAction(array($this, 'onExitMargemLucro'));  
        $margemlucro->setExitAction($onExitMargemLucro);
        
        
        $onExitprecovenda = new TAction(array($this, 'onExitPrecoVenda'));  
        $precovenda->setExitAction($onExitprecovenda); 
        
        $precovenda->setNumericMask(2, ',', '.', true);
        $custocompra->setNumericMask(2, ',', '.', true);
        $customedio->setNumericMask(2, ',', '.', true);
        $custofinal->setNumericMask(2, ',', '.', true);
        $margemlucro->setNumericMask(2, ',', '.', true);  
        $comissao->setNumericMask(2, ',', '.', true);
        $descontomaximo->setNumericMask(2, ',', '.', true);
        $estoquemaximo->setNumericMask(2, ',', '.', true);
        $estoqueminimo->setNumericMask(2, ',', '.', true);
        $pesobruto->setNumericMask(2, ',', '.', true);
        $pesoliquido->setNumericMask(2, ',', '.', true);
        
        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items);                     

        $usagrade->setLayout('horizontal');
        $items = array();
        $items['S'] ='Usa Grade?'; 
        $usagrade->addItems($items);
          
        $usaserial->setLayout('horizontal');
        $items = array();
        $items['S'] ='Usa Serial?'; 
        $usaserial->addItems($items);
                        
        $balancaexporta->setLayout('horizontal');
        $items = array();
        $items['S'] ='Exporta Balança?'; 
        $balancaexporta->addItems($items);         



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }

        
        $labelprincipal = new TLabel('Principal', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );                                        

        // add the fields
        $row = $this->form->addFields( [ new TLabel('Código') ,  $id ], [ new TLabel('Cód.Barras') ,  $codbarras ],[ new TLabel('Referência Interna') ,  $referencia ], [ new TLabel('Datacadastro') , $datacadastro ], [$ativo] );
        $row->layout = ['col-sm-1 control-label', 'col-sm-2 control-label', 'col-sm-2 control-label', 'col-sm-2 control-label', 'col-sm-1 control-label'];
        $row = $this->form->addFields( [ new TLabel('Produto') ,  $produto ],
                                       [ new TLabel('Unidade') ,  $unidade ],
                                       [ new TLabel('Produto/Serviço') ,  $produtoservico ]);
        $row->layout = ['col-sm-5 control-label', 
                        'col-sm-1 control-label',
                        'col-sm-2 control-label'];

        $row = $this->form->addFields( [ new TLabel('Ref. Fabrica') , $reffabricante ], [ new TLabel('Fabricante / Marca') ,  $cadfabricante_id ] );
        $row->layout = ['col-sm-3', 'col-sm-5'];        
        $row = $this->form->addFields( [ new TLabel('Grupo') ,  $cadgrupoproduto_id ] , [ new TLabel('SubGrupo') , $cadsubgrupoproduto_id ] );
        $row->layout = ['col-sm-4', 'col-sm-4'];
        
        $labelfiscal = new TLabel('Dados Fiscais', '#7D78B6', 12, 'b');
        $labelfiscal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelfiscal->setSize('100%');
        $this->form->addContent( [$labelfiscal] );        
        
        $row = $this->form->addFields( [ new TLabel('Tipo') ,  $tipo ], 
                                       [ new TLabel('Origem') , $origem ]);         
        $row->layout = ['col-sm-3 control-label', 
                        'col-sm-5 control-label'];
                        
        $row = $this->form->addFields( [ new TLabel('Ncm') , $ncm ], [ new TLabel('Ncm EX') ,  $ncmex ], [ new TLabel('Cest') , $cest ]);        
        $row->layout = ['col-sm-3 control-label', 
                        'col-sm-2 control-label',
                        'col-sm-3 control-label'];

                        
        $labelprecos = new TLabel('Preço Custo / Venda / Valores', '#7D78B6', 12, 'b');
        $labelprecos->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprecos->setSize('100%');
        $this->form->addContent( [$labelprecos] );                 
        
        $row = $this->form->addFields([ new TLabel('Custo Compra') , $custocompra ], 
                                      [ new TLabel('Custo Médio') , $customedio ],
                                      [ new TLabel('Custo Final') , $custofinal ]);
        $row->layout = ['col-sm-2 control-label', 
                        'col-sm-2 control-label', 
                        'col-sm-2 control-label'];
        $row = $this->form->addFields([ new TLabel('Margem Lucro') , $margemlucro ],                                      
                                      [ new TLabel('Preço Venda') , $precovenda ]);
        $row->layout = ['col-sm-2 control-label',                         
                        'col-sm-2 control-label'];                        

        $row = $this->form->addFields([ new TLabel('Desconto Máximo') , $descontomaximo ],                                      
                                      [ new TLabel('Comissão') , $comissao ]);
        $row->layout = ['col-sm-2 control-label',                         
                        'col-sm-2 control-label'];

        $labelestoqueoutros = new TLabel('Estoque / Outros', '#7D78B6', 12, 'b');
        $labelestoqueoutros->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelestoqueoutros->setSize('100%');
        $this->form->addContent( [$labelestoqueoutros] ); 
        
        $row = $this->form->addFields( [ new TLabel('Estoque Mínimo') ,  $estoqueminimo ],
                                       [ new TLabel('Estoque Máximo') ,  $estoquemaximo ],                
                                       [ new TLabel('Peso Bruto') , $pesobruto ], 
                                       [ new TLabel('Peso Líquido') , $pesoliquido ] );
        $row->layout = ['col-sm-2 control-label',                         
                        'col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];                                

        $row = $this->form->addFields( [ $usagrade ],
                                       [ $usaserial ] );
        $row->layout = ['col-sm-2 control-label',                         
                        'col-sm-2 control-label'];        
        
        $labelbalanca = new TLabel('Balança', '#7D78B6', 12, 'b');
        $labelbalanca->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelbalanca->setSize('100%');
        $this->form->addContent( [$labelbalanca] );        
                                       
        $row = $this->form->addFields( [ new TLabel('Validade Embalado') ,  $balancavalidade ], 
                                       [ new TLabel('Tecla Balança') ,  $balancatecla ], [$balancaexporta ] );
        $row->layout = ['col-sm-2 control-label',                         
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];                               
                                
        $row = $this->form->addFields( [ new TLabel('Aplicacao') ,  $aplicacao ] );
        $row->layout = ['col-sm-8 control-label'];
        
        //$this->form->addFields( [ new TLabel('Pathimagem') ], [ $pathimagem ] );
        /*
        $this->form->addFields( [ new TLabel('Cadgrupoproduto Id') ], [ $cadgrupoproduto_id ] );
        $this->form->addFields( [ new TLabel('Cadsubgrupoproduto Id') ], [ $cadsubgrupoproduto_id ] );
        */
        //$this->form->addFields( [ new TLabel('Cadfabricante Id') ], [ $cadfabricante_id ] );
        //$this->form->addFields( [ new TLabel('Cadgrade Id') ], [ $cadgrade_id ] );
        //$this->form->addFields( [ new TLabel('Ativo') ], [ $ativo ] );
        
        //$cadgrupoproduto_id->enableSearch();              
        $cadgrupoproduto_id->setChangeAction( new TAction( array($this, 'onChangeCadgrupoproduto')) );
       
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
        //$margemlucro->onBlur = 'FuncMargemLucro()';        
        TScript::create('FuncMargemLucro = function() 
        {
            var precovenda = 0;
            var custofinal = parseFloat(document.form_Cadproduto.custofinal.value);
            var margemlucro = parseFloat(document.form_Cadproduto.margemlucro.value);
            /*
            console.log(margemlucro);
            console.log(custofinal);
            console.log(custofinal + (custofinal * (margemlucro / 100)));
            console.log((margemlucro > 0 && custofinal > 0));
            */ 
            if ((custofinal > 0) && (margemlucro > 0))
            {
                form_Cadproduto.precovenda.value = custofinal + (custofinal * (margemlucro / 100));
            }
            else
            {
                console.log("Não");
                form_Cadproduto.precovenda.value = 0;   
            }
        };');         
        //$precovenda  = $custofinal + ($custofinal * ($margemlucro / 100)); 
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addAction(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadprodutoList','onReload')), 'fa:table blue');
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadprodutoList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
                   
            $object = new Cadproduto;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            
            //echo 'Produto Serviço  ' . $data->produtoservico . '<br />';
            
            $ativo = $data->ativo;
            if ( !empty($ativo)) 
            {               
                $object->ativo = 'S';
            }
            else { $object->ativo = 'N'; }             
            
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            //new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadproduto($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                
                $obj = new StdClass;
                if ($object->ativo == 'S')
                {
                    $obj->ativo = 'S';
                }                              
                TForm::sendData('form_Cadproduto', $obj);
                
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);                
                $obj = new StdClass;
                $obj->ativo = 'S'; 
                $obj->produtoservico = 'P';                
                $obj->datacadastro = TDate::date2br(date("Y-m-d"));
                TForm::sendData('form_Cadproduto', $obj);

            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
   
    public static function onChangeCadgrupoproduto($param)
    {
        try
        {
            TTransaction::open('goldnotas');
            if (!empty($param['cadgrupoproduto_id']))
            {
                $criteria = TCriteria::create( ['cadgrupoproduto_id' => $param['cadgrupoproduto_id'] ] );
                
                // formname, field, database, model, key, value, ordercolumn = NULL, criteria = NULL, startEmpty = FALSE
                TDBCombo::reloadFromModel('form_Cadproduto', 'cadsubgrupoproduto_id', 'goldnotas', 'Cadsubgrupoproduto', 'id', 'subgrupoproduto', 'subgrupoproduto', $criteria, TRUE);
            }
            else
            {
                TCombo::clearField('form_Cadproduto', 'cadsubgrupoproduto_id');
            }
            
            TTransaction::close();
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    } 
         
    public static function onExitMargemLucro($param)
    {                           
        $custofinal   = (double) PMaskFormate::reais_to_decimal($param['custofinal']);
        $precovenda   = (double) PMaskFormate::reais_to_decimal($param['precovenda']);
        $margemlucro  = (double) PMaskFormate::reais_to_decimal($param['margemlucro']);
	    if (($custofinal > 0) and ($margemlucro > 0))
	    {
            $precovenda  = $custofinal + ($custofinal * ($margemlucro / 100));          
            $precovenda  = PMaskFormate::formata_valor($precovenda);
            $obj = new StdClass;
            $obj->precovenda = $precovenda;
            TForm::sendData('form_Cadproduto', $obj, False, False);	
        
	    }
	    else
	    {	  
            $precovenda  = 0;
            $obj = new StdClass;
            $obj->precovenda = $precovenda;
            TForm::sendData('form_Cadproduto', $obj, False, False); 
	    }             
    }   
    
    public static function onExitPrecoVenda($param)
    {                        
        $custofinal   = (double) PMaskFormate::reais_to_decimal($param['custofinal']);
        $precovenda   = (double) PMaskFormate::reais_to_decimal($param['precovenda']);
        $margemlucro  = (double) PMaskFormate::reais_to_decimal($param['margemlucro']);
	    if (($custofinal > 0) and ($precovenda > 0))
	    {
            $margemlucro  = (($precovenda / $custofinal) * 100) - 100;//number_format(($valor / $mil), 2, ',', '.');          
            $margemlucro  = PMaskFormate::formata_valor($margemlucro);
            $obj = new StdClass;
            $obj->margemlucro = $margemlucro;
            TForm::sendData('form_Cadproduto', $obj, False, False);                        	        
	    }
	    else
	    {	  
            $margemlucro  = 0;
            $obj = new StdClass;
            $obj->margemlucro = $margemlucro;           
            TForm::sendData('form_Cadproduto', $obj, False, False);            
	    }             
    }           
}
