<?php
/**
 * CadprodutoList Listing
 * @author  <your name here>
 */
class CadprodutoList extends TPage
{
    private $form; // form
    private $datagrid; // listing
    private $pageNavigation;
    private $formgrid;
    private $loaded;
    private $deleteButton;
    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadproduto');
        $this->form->setFormTitle('Listagem de Produtos');
        

        // create the form fields
        $id = new TEntry('id');
        $produto = new TEntry('produto');
        $codbarras = new TEntry('codbarras');
        $reffabricante = new TEntry('reffabricante');
        $referencia = new TEntry('referencia');
        $ativo = new TCombo('ativo');
        $cadfabricante_id = new TDBUniqueSearch('cadfabricante_id', 'goldnotas', 'Cadfabricante', 'id', 'fabricante');

        $ativo->addItems(s7sdiversos::listsimnao());

        // add the fields
        $this->form->addFields( [ new TLabel('Código') ], [ $id ], [ new TLabel('Cód. Barras') ], [ $codbarras ] );
        $this->form->addFields( [ new TLabel('Produto') ], [$produto ], [ New TLabel('Fabricante') ], [ $cadfabricante_id ]);              
        //$this->form->addFields( [ new TLabel('Codbarras') ], [ $codbarras ] );
        $this->form->addFields( [ new TLabel('Ref. Fabricante') ], [ $reffabricante ], [ new TLabel('Referência') ], [ $referencia ] );
        //$this->form->addFields( [ new TLabel('Referencia') ], [ $referencia ] );
        $this->form->addFields( [ new TLabel('Ativo') ], [ $ativo ],[] );


        // set sizes
        $id->setSize('30%');
        $produto->setSize('100%');
        //$unidade->setSize('20%');        
        $codbarras->setSize('100%');
        $reffabricante->setSize('100%');
        $referencia->setSize('100%');
        $ativo->setSize('100%');
        $cadfabricante_id->setSize('100%');
        

        
        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue('Cadproduto_filter_data') );
        
        // add the search form actions
        $btn = $this->form->addAction(_t('Find'), new TAction([$this, 'onSearch']), 'fa:search');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addActionLink(_t('New'), new TAction(['CadprodutoForm', 'onEdit']), 'fa:plus green');
        
        // creates a Datagrid
        $this->datagrid = new BootstrapDatagridWrapper(new TDataGrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_id = new TDataGridColumn('id', 'Código', 'right');
        $column_produto = new TDataGridColumn('produto', 'Produto', 'left');       
        $column_codbarras = new TDataGridColumn('codbarras', 'Cód.Barras', 'left');
        $column_reffabricante = new TDataGridColumn('reffabricante', 'Ref. Fabricante', 'left');
        $column_referencia = new TDataGridColumn('referencia', 'Referência', 'left');
        $column_ativo = new TDataGridColumn('ativo', 'Ativo', 'left');

        $column_ativo->setTransformer( function($value, $object, $row) {
            $class = ($value=='N') ? 'danger' : 'success';
            $label = ($value=='N') ? _t('No') : _t('Yes');
            $div = new TElement('span');
            $div->class="label label-{$class}";
            $div->style="text-shadow:none; font-size:12px; font-weight:lighter";
            $div->add($label);
            return $div;
        });         


        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_id);
        $this->datagrid->addColumn($column_produto);        
        $this->datagrid->addColumn($column_codbarras);
        $this->datagrid->addColumn($column_reffabricante);
        $this->datagrid->addColumn($column_referencia);
        $this->datagrid->addColumn($column_ativo);

        
        // create EDIT action
        $action_edit = new TDataGridAction(['CadprodutoForm', 'onEdit']);
        //$action_edit->setUseButton(TRUE);
        //$action_edit->setButtonClass('btn btn-default');
        $action_edit->setLabel(_t('Edit'));
        $action_edit->setImage('far:edit blue fa-lg');
        $action_edit->setField('id');
        $this->datagrid->addAction($action_edit);
        
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onDelete'));
        //$action_del->setUseButton(TRUE);
        //$action_del->setButtonClass('btn btn-default');
        $action_del->setLabel(_t('Delete'));
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('id');
        $this->datagrid->addAction($action_del);
        
        // create the datagrid model
        $this->datagrid->createModel();
        
        // creates the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->setAction(new TAction([$this, 'onReload']));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());
        


        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        $container->add(TPanelGroup::pack('', $this->datagrid, $this->pageNavigation));
        
        parent::add($container);
    }
    
    /**
     * Inline record editing
     * @param $param Array containing:
     *              key: object ID value
     *              field name: object attribute to be updated
     *              value: new attribute content 
     */
    public function onInlineEdit($param)
    {
        try
        {
            // get the parameter $key
            $field = $param['field'];
            $key   = $param['key'];
            $value = $param['value'];
            
            TTransaction::open('goldnotas'); // open a transaction with database
            $object = new Cadproduto($key); // instantiates the Active Record
            $object->{$field} = $value;
            $object->store(); // update the object in the database
            TTransaction::close(); // close the transaction
            
            $this->onReload($param); // reload the listing
            new TMessage('info', "Record Updated");
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Register the filter in the session
     */
    public function onSearch()
    {
        // get the search form data
        $data = $this->form->getData();
        
        // clear session filters
        TSession::setValue('CadprodutoList_filter_id',   NULL);
        TSession::setValue('CadprodutoList_filter_produto',   NULL);
        TSession::setValue('CadprodutoList_filter_unidade',   NULL);
        TSession::setValue('CadprodutoList_filter_codbarras',   NULL);
        TSession::setValue('CadprodutoList_filter_reffabricante',   NULL);
        TSession::setValue('CadprodutoList_filter_cadfabricante_id',   Null);
        TSession::setValue('CadprodutoList_filter_referencia',   NULL);
        TSession::setValue('CadprodutoList_filter_ativo',   NULL);

        if (isset($data->id) AND ($data->id)) {
            $filter = new TFilter('id', '=', "$data->id"); // create the filter
            TSession::setValue('CadprodutoList_filter_id',   $filter); // stores the filter in the session
        }


        if (isset($data->produto) AND ($data->produto)) {
            $filter = new TFilter('produto', 'like', "%{$data->produto}%"); // create the filter
            TSession::setValue('CadprodutoList_filter_produto',   $filter); // stores the filter in the session
        }

        if (isset($data->produto) AND ($data->cadfabricante_id)) {
            $filter = new TFilter('produto', 'like', "%{$data->cadfabricante_id}%"); // create the filter
            TSession::setValue('CadprodutoList_filter_cadfabricante_id',   $filter); // stores the filter in the session
        }

        if (isset($data->codbarras) AND ($data->codbarras)) {
            $filter = new TFilter('codbarras', 'like', "%{$data->codbarras}%"); // create the filter
            TSession::setValue('CadprodutoList_filter_codbarras',   $filter); // stores the filter in the session
        }


        if (isset($data->reffabricante) AND ($data->reffabricante)) {
            $filter = new TFilter('reffabricante', 'like', "%{$data->reffabricante}%"); // create the filter
            TSession::setValue('CadprodutoList_filter_reffabricante',   $filter); // stores the filter in the session
        }


        if (isset($data->referencia) AND ($data->referencia)) {
            $filter = new TFilter('referencia', 'like', "%{$data->referencia}%"); // create the filter
            TSession::setValue('CadprodutoList_filter_referencia',   $filter); // stores the filter in the session
        }


        if (isset($data->ativo) AND ($data->ativo)) {
            $filter = new TFilter('ativo', 'like', "%{$data->ativo}%"); // create the filter
            TSession::setValue('CadprodutoList_filter_ativo',   $filter); // stores the filter in the session
        }

        
        // fill the form with data again
        $this->form->setData($data);
        
        // keep the search data in the session
        TSession::setValue('Cadproduto_filter_data', $data);
        
        $param = array();
        $param['offset']    =0;
        $param['first_page']=1;
        $this->onReload($param);
    }
    
    /**
     * Load the datagrid with data
     */
    public function onReload($param = NULL)
    {
        try
        {
            // open a transaction with database 'goldnotas'
            TTransaction::open('goldnotas');
            
            // creates a repository for Cadproduto
            $repository = new TRepository('Cadproduto');
            $limit = 10;
            // creates a criteria
            $criteria = new TCriteria;
            
            // default order
            if (empty($param['order']))
            {
                $param['order'] = 'id';
                $param['direction'] = 'asc';
            }
            $criteria->setProperties($param); // order, offset
            $criteria->setProperty('limit', $limit);
            

            if (TSession::getValue('CadprodutoList_filter_id')) {
                $criteria->add(TSession::getValue('CadprodutoList_filter_id')); // add the session filter
            }


            if (TSession::getValue('CadprodutoList_filter_produto')) {
                $criteria->add(TSession::getValue('CadprodutoList_filter_produto')); // add the session filter
            }
            
            if (TSession::getValue('CadprodutoList_filter_cadfabricante_id')) {
                $criteria->add(TSession::getValue('CadprodutoList_filter_cadfabricante_id')); // add the session filter
            }            

            if (TSession::getValue('CadprodutoList_filter_codbarras')) {
                $criteria->add(TSession::getValue('CadprodutoList_filter_codbarras')); // add the session filter
            }


            if (TSession::getValue('CadprodutoList_filter_reffabricante')) {
                $criteria->add(TSession::getValue('CadprodutoList_filter_reffabricante')); // add the session filter
            }


            if (TSession::getValue('CadprodutoList_filter_referencia')) {
                $criteria->add(TSession::getValue('CadprodutoList_filter_referencia')); // add the session filter
            }


            if (TSession::getValue('CadprodutoList_filter_ativo')) {
                $criteria->add(TSession::getValue('CadprodutoList_filter_ativo')); // add the session filter
            }

            
            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);
            
            if (is_callable($this->transformCallback))
            {
                call_user_func($this->transformCallback, $objects, $param);
            }
            
            $this->datagrid->clear();
            if ($objects)
            {
                // iterate the collection of active records
                foreach ($objects as $object)
                {
                    // add the object inside the datagrid
                    $this->datagrid->addItem($object);
                }
            }
            
            // reset the criteria for record count
            $criteria->resetProperties();
            $count= $repository->count($criteria);
            
            $this->pageNavigation->setCount($count); // count of records
            $this->pageNavigation->setProperties($param); // order, page
            $this->pageNavigation->setLimit($limit); // limit
            
            // close the transaction
            TTransaction::close();
            $this->loaded = true;
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }
    
    /**
     * Ask before deletion
     */
    public static function onDelete($param)
    {
        // define the delete action
        $action = new TAction([__CLASS__, 'Delete']);
        $action->setParameters($param); // pass the key parameter ahead
        
        // shows a dialog to the user
        new TQuestion(TAdiantiCoreTranslator::translate('Do you really want to delete ?'), $action);
    }
    
    /**
     * Delete a record
     */
    public static function Delete($param)
    {
        try
        {
            $key=$param['key']; // get the parameter $key
            TTransaction::open('goldnotas'); // open a transaction with database
            $object = new Cadproduto($key, FALSE); // instantiates the Active Record
            $object->delete(); // deletes the object from the database
            TTransaction::close(); // close the transaction
            
            $pos_action = new TAction([__CLASS__, 'onReload']);
            new TMessage('info', TAdiantiCoreTranslator::translate('Record deleted'), $pos_action); // success message
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    



    
    /**
     * method show()
     * Shows the page
     */
    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded AND (!isset($_GET['method']) OR !(in_array($_GET['method'],  array('onReload', 'onSearch')))) )
        {
            if (func_num_args() > 0)
            {
                $this->onReload( func_get_arg(0) );
            }
            else
            {
                $this->onReload();
            }
        }
        parent::show();
    }
}
