<?php
/**
 * CadpessoaCadplgEditarForm Form
 * @author  <your name here>
 */
class CadsubgrupoprodutoEditarForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        // creates the form
        parent::__construct();   
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
        // creates the form
        $this->adianti_target_container = 'Cadsubgrupoproduto_area';
        $this->form = new BootstrapFormBuilder('form_CadsubgrupoprodutoEditar');        


        // create the form fields
        $id = new TEntry('id');
        $subgrupoproduto = new TEntry('subgrupoproduto');
        $grupoproduto_id = new THidden('grupoproduto_id');

        $id->setEditable(FALSE);
        $id->setSize('50%');             
        
        $subgrupoproduto->setSize('50%');
        
        $this->form->addFields([new TLabel('Código')],[$id]);
        $this->form->addFields([new TLabel('Subgrupo')],[$subgrupoproduto]);
        $this->form->addFields([$grupoproduto_id]);

         
        // create the form actions
        $subgrupoproduto_sav = new TButton('subgrupoprodutoSav');
        $subgrupoproduto_sav_action = new TAction(array($this, 'onSave'));
        $subgrupoproduto_sav->setAction($subgrupoproduto_sav_action, 'Salvar');
        $subgrupoproduto_sav->setImage('far:save');        

        $subgrupoproduto_can = new TButton('subgrupoprodutoCan');
        $subgrupoproduto_can_action = new TAction(array($this, 'onCancel'));
        $subgrupoproduto_can->setAction($subgrupoproduto_can_action, 'Voltar');
        $subgrupoproduto_can->setImage('far:save');  
        
        $this->form->addFields([],[$subgrupoproduto_sav,$subgrupoproduto_can]);  
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';        
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            $data = $this->form->getData();
            $this->form->validate();
            $subgruposproduto = TSession::getValue('subgruposproduto');  
            $subgrupoproduto_id = TSession::getValue('subgrupoproduto_id');
            if (empty($subgrupoproduto_id))
            {                      
                $subgruposproduto_count = TSession::getValue('subgruposproduto_count');
                $subgruposproduto_count++;            
                TSession::setValue('subgruposproduto_count', $subgruposproduto_count);                               
            } 
            else
            {                
                $subgruposproduto_count = $subgrupoproduto_id;                       
            }                      
            $subgruposproduto[$subgruposproduto_count] = array(
                                                        'id' => $param['id'],
                                                        'subgrupoproduto_id' => $subgruposproduto_count,
                                                        'subgrupoproduto' => $param['subgrupoproduto'],
                                                        'del' => 'N');
            //HDebug::debug($subgruposproduto,'Salvar Subgrupoproduto');                                                                                                                           
            TSession::setValue('subgruposproduto', $subgruposproduto);
            TSession::delValue('subgrupoproduto_id');
            AdiantiCoreApplication::loadPage('CadsubgrupoprodutoForm', 'onReload', ['register_state'=>'false']);
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);       
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            $data = $this->form->getData();             
            $this->form->clear(TRUE);            
            $subgrupoproduto_id = TSession::getValue('subgrupoproduto_id');
            $subgruposproduto = TSession::getValue('subgruposproduto');
            $id = $subgruposproduto[$subgrupoproduto_id]['id'];            
            $subgrupoproduto = $subgruposproduto[$subgrupoproduto_id]['subgrupoproduto']; 

                    
            $obj = new StdClass;
            $obj->id = $id;
            $obj->subgrupoproduto_id = $subgrupoproduto_id;
            $obj->subgrupoproduto = $subgrupoproduto;
            TForm::sendData('form_CadsubgrupoprodutoEditar', $obj);                                  
            
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    }
    public function onCancel( $param )
    {
        try
        {
            AdiantiCoreApplication::loadPage('CadsubgrupoprodutoForm', 'onReload', ['register_state'=>'false']);
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            new TMessage('error', $e->getMessage());
        }
    } 
}
