<?php
/**
 * CadsubgrupoprodutoForm Listing
 * @author  <your name here>
 */
class CadsubgrupoprodutoForm extends TPage
{
    private $form; // form
    private $datagrid; // listing    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();        
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');         
        // creates the form
        $this->adianti_target_container = 'Cadsubgrupoproduto_area';        
        $this->form = new BootstrapFormBuilder('form_CadsubgrupoprodutoForm');
        
        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_subgrupoproduto_id = new TDataGridColumn('subgrupoproduto_id', 'Código', 'right');
        $column_subgrupoproduto = new TDataGridColumn('subgrupoproduto', 'Subgrupo', 'left');
        
        //SubgrupoProduto
        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_subgrupoproduto_id);
        $this->datagrid->addColumn($column_subgrupoproduto);       
        
        // create EDIT action
        $action_edit = new TDataGridAction(array('CadsubgrupoprodutoForm', 'onSubgrupoProdutoEdi'));
        //$action_edit->setUseButton(TRUE);
        //$action_edit->setButtonClass('btn btn-default');
        $action_edit->setLabel(_t('Edit'));
        $action_edit->setImage('far:edit blue fa-lg');
        $action_edit->setField('subgrupoproduto_id');
        $this->datagrid->addAction($action_edit);
        
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onSubgrupoProdutoDel'));
        //$action_del->setUseButton(TRUE);
        //$action_del->setButtonClass('btn btn-default');
        $action_del->setLabel(_t('Delete'));
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('subgrupoproduto_id');
        $this->datagrid->addAction($action_del);

        /*
        $action_group = new TDataGridActionGroup('Ações', 'bs:th');        
        $action_group->addHeader('Cadastro');
        $action_group->addAction($action_edit);
        $action_group->addAction($action_del);*/       
        // add the actions to the datagrid
        //$this->datagrid->addActionGroup($action_group);        
        
        
        $subgrupoproduto_add = new TButton('subgrupoproduto');
        $subgrupoproduto_action = new TAction(array($this, 'onSubgrupoProdutoAdd'));
        $subgrupoproduto_add->setAction($subgrupoproduto_action, 'Adcionar');
        $subgrupoproduto_add->setImage('bs:plus-sign green');                 
        $this->form->addFields([$subgrupoproduto_add]);        
        
        // create the datagrid model
        $this->datagrid->createModel();
        $this->form->addContent([$this->datagrid]);    
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        //$container->add(TPanelGroup::pack('', $this->datagrid, $this->pageNavigation));        
        parent::add($container);
    }

    public function onEdit( $param )
    {
        try
        {
            TSession::delValue('subgruposproduto');
            TSession::delValue('subgruposproduto_loaded');            
            TSession::delValue('subgruposproduto_count');
            $key = TSession::getValue('idgrupo');            
            if (!empty($key))
            {                
                $this->loadSubGruposProduto($key);                 
                $this->onReload($param);                                                                              
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    public function onClear( $param )
    {
        $this->form->clear(TRUE);                        
    }    
    
    /**
     * Load the datagrid with data
     */
    public function onReload()
    {
        try
        {               
            //HDebug::debug(TSession::getValue('subgruposproduto_loaded'),'Reload Subgrupoproduto');
            if (!empty(TSession::getValue('subgruposproduto_loaded')))            
            {    
                //$data = $this->form->getData(); // get form data as array                                   
                $subgruposproduto = TSession::getValue('subgruposproduto');                         
                $this->datagrid->clear();                            
                if ($subgruposproduto)
                {                                                                  
                    TTransaction::open('goldnotas'); // open a transaction                
                    foreach ($subgruposproduto as $subgrupoproduto_id => $subgrupoproduto)
                    {   // add the object inside the datagrid
                        if ($subgrupoproduto['del'] == 'N')
                        {
                            //$pessoa = printf("[%10s]\n", $pessoa_contrato['contrato_cadpessoa_id']) . ' - ' . $pessoa_contrato['contrato_pessoa'];
                            //$objpessoa = new Cadpessoa($pessoa_contrato['cadpessoa_id']);
                            //$pessoa = $pessoa_contrato['contrato_cadpessoa_id'] . ' - ' . $objpessoa->pessoa;
                            $item = new StdClass;
                            $item->subgrupoproduto_id  = $subgrupoproduto['subgrupoproduto_id'];
                            $item->subgrupoproduto = $subgrupoproduto['subgrupoproduto'];                           
                            $this->datagrid->addItem($item);
                        }                        
                    }
                    TTransaction::close();                    
                }   
                //$this->form->setData($data);          
                //$this->loaded = TRUE; 
            }          
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
        }
    }

    public function onSubGrupoProdutoAdd($param)
    {               
        try 
        {                           
            $data = $this->form->getData();   
            TSession::delValue('subgrupoproduto_id');                                 
            TApplication::loadPage('CadsubgrupoprodutoEditarForm','onClear', ['register_state'=>'false']);
            $this->onReload();              
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }
    
    public function onSubGrupoProdutoEdi($param)
    {               
        try 
        {                           
            $data = $this->form->getData();
            $key=$param['key'];           
            TSession::setValue('subgrupoproduto_id',$key);                                      
            TApplication::loadPage('CadsubgrupoprodutoEditarForm','onEdit', ['register_state'=>'false']);             
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }

    public function onSubGrupoProdutoDel($param)
    {
        try
        {
            $key=$param['key']; // get the parameter $key
            $subgruposproduto = TSession::getValue('subgruposproduto');
            $subgruposproduto[$param['key']]['del'] = 'S';
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    function loadSubGruposProduto($cadgrupoproduto_id)
    {
        if(is_numeric($cadgrupoproduto_id))
        {
            try
            {           
                if(!TSession::getValue('subgruposproduto_loaded')) 
                {
                    $subgruposproduto = TSession::delValue('subgruposproduto'); 
                    TTransaction::open('goldnotas');                    
                    $subgruposproduto_criteria = new TCriteria;                     
                    $subgruposproduto_criteria->add(new TFilter('cadgrupoproduto_id', '=', $cadgrupoproduto_id));
                     
                    $repository = new TRepository('Cadsubgrupoproduto'); 
                    $subgruposproduto_repo = $repository->load($subgruposproduto_criteria);
                    $subgruposproduto_max_ordem = 0;
                    $subgruposproduto_count = 0 ;                    
                    foreach ($subgruposproduto_repo as $subgrupoproduto_obj) 
                    {                                             
                        $subgruposproduto_count++;                                                                       
                        $subgruposproduto[$subgruposproduto_count] = array(
                                                  'id' => $subgrupoproduto_obj->id,
                                                  'subgrupoproduto_id' => $subgruposproduto_count,                                                  
                                                  'subgrupoproduto' => $subgrupoproduto_obj->subgrupoproduto,
                                                  'del' => 'N');  
                                                                        
                    }
 
                    TSession::setValue('subgruposproduto_count', $subgruposproduto_count);                    
                    TSession::setValue('subgruposproduto_loaded', true); 
                    TTransaction::close();
                    TSession::setValue('subgruposproduto', $subgruposproduto); 
                }//joao vitor ex goleiro
            }
            catch (Exception $e)
            {
                TTransaction::rollback(); 
                new TMessage('error', $e->getMessage());
            }
        }
        return true;  
    } 

}
