<?php
/**
 * CadprodutoList Listing
 * @author  <your name here>
 */
class PesquisaProdutos extends TWindow
{
    private $form; // form
    private $datagrid; // listing
    private $pageNavigation;
    private $formgrid;
    private $loaded;
    private $deleteButton;
    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();
        parent::setSize( 1024, 750);        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_PesquisaProdutos');
        $this->form->setFormTitle('Listagem de Produtos');        
        
        $campopesquisa = new TCombo('campopesquisa');
        $buscaproduto = new TEntry('buscaproduto');          
        
        $itens = array();
        $itens['0'] = 'Código';
        $itens['1'] = 'Produto';
        $itens['2'] = 'Cód.Barras';
        $itens['3'] = 'Ref.Interna';
        $itens['4'] = 'Ref.Fabrica';

        $buscaproduto->setSize('100%');
        $campopesquisa->setSize('100%');
        $campopesquisa->addItems($itens);
        
        $campopesquisa->addValidation('Campo de Pesquisa', new TRequiredValidator );
        $campopesquisa->setChangeAction( new TAction( array($this, 'onChangecampopesquisa')) );        
        
        $buscaproduto->setSize('100%');
        
        $btn = $buscar = new TButton('buscar');
        $btn->class = 'btn btn-sm btn-primary';
        $buscar_action = new TAction(array($this, 'onSearch'));
        $buscar->setAction($buscar_action, 'Buscar');
        $buscar->setImage('fa:search');         
        
        $row = $this->form->addFields([new TLabel('Campo de Pesquisa'),$campopesquisa],
                                      [new TLabel('Conteúdo a Pesquisar'),$buscaproduto],
                                      [new TLabel(''),$buscar]);
        $row->layout = ['col-sm-3','col-sm-6','col-sm-3'];         
        
        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue('PesquisaProdutos_filter_data') );
        
        // add the search form actions
        //$btn = $this->form->addAction(_t('Find'), new TAction([$this, 'onSearch']), 'fa:search');
        //$btn->class = 'btn btn-sm btn-primary';
        //$this->form->addActionLink(_t('New'), new TAction(['CadprodutoForm', 'onEdit']), 'fa:plus green');
        
        // creates a Datagrid
        $this->datagrid = new BootstrapDatagridWrapper(new TDataGrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        $this->datagrid->setHeight(300);
        $this->datagrid->makeScrollable();        

        // creates the datagrid columns
        $column_id = new TDataGridColumn('id', 'Código', 'right', '10%');
        $column_produto = new TDataGridColumn('produto', 'Produto', 'left', '50%');      
        $column_unidade = new TDataGridColumn('unidade', 'Und.', 'center', '10%');
        $column_precovenda = new TDataGridColumn('precovenda', 'Valor R$', 'right', '15%');         
        $column_codbarras = new TDataGridColumn('codbarras', 'Cód.Barras', 'right', '15%');
        $column_reffabricante = new TDataGridColumn('reffabricante', 'Ref. Fabricante', 'right', '15%');
        $column_referencia = new TDataGridColumn('referencia', 'Referência', 'right', '15%');

        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_id);
        $this->datagrid->addColumn($column_produto);
        $this->datagrid->addColumn($column_unidade);
        $this->datagrid->addColumn($column_precovenda);        
        $this->datagrid->addColumn($column_codbarras);
        $this->datagrid->addColumn($column_reffabricante);
        $this->datagrid->addColumn($column_referencia);
        
        
        $format_value = function($value) {
            if (is_numeric($value)) {
                return 'R$ '.number_format($value, 2, ',', '.');
            }
            return $value;
        };
        $column_precovenda->setTransformer($format_value);        

        $select = new TDataGridAction(array($this, 'onSelect'));
        $select->setLabel('Select');
        // $action1->setUseButton(TRUE);
        $select->setImage('far:check-circle green fa-lg');
        $select->setField('id');
        $this->datagrid->addAction($select);        
        
        // create the datagrid model
        $this->datagrid->createModel();
        
        // creates the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->setAction(new TAction([$this, 'onReload']));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());        
        
        //$this->form->addContent([$this->datagrid]);
        $this->form->addContent([TPanelGroup::pack('', $this->datagrid, $this->pageNavigation)]);
        


        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        //$container->add(TPanelGroup::pack('', /*$this->datagrid,*/ $this->pageNavigation));
        
        parent::add($container);
    }
    
    /**
     * Inline record editing
     * @param $param Array containing:
     *              key: object ID value
     *              field name: object attribute to be updated
     *              value: new attribute content 
     */
    public function onInlineEdit($param)
    {
        try
        {
            // get the parameter $key
            $field = $param['field'];
            $key   = $param['key'];
            $value = $param['value'];
            
            TTransaction::open('goldnotas'); // open a transaction with database
            $object = new Cadproduto($key); // instantiates the Active Record
            $object->{$field} = $value;
            $object->store(); // update the object in the database
            TTransaction::close(); // close the transaction
            
            $this->onReload($param); // reload the listing
            new TMessage('info', "Record Updated");
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Register the filter in the session
     */
    public function onSearch()
    {
        // get the search form data
        $this->form->validate();
        $data = $this->form->getData();
        
        $fieldpesquisa = 'produto';
        switch($data->campopesquisa)
        {
            case "0":
                $fieldpesquisa = 'id';
                break;
            case "1":
                $fieldpesquisa = 'produto';
                break;
            case "2":
                $fieldpesquisa = 'codbarras';
                break;
            case "3":
                $fieldpesquisa = 'referencia';
                break;
            case "4":
                $fieldpesquisa = 'reffabricante';
                break;                                                
        }        
        
        // clear session filters
        TSession::setValue('PesquisaProdutos_filter_id',   NULL);
        TSession::setValue('PesquisaProdutos_filter_produto',   NULL);
        TSession::setValue('PesquisaProdutos_filter_codbarras',   NULL);
        TSession::setValue('PesquisaProdutos_filter_reffabricante',   NULL);
        TSession::setValue('PesquisaProdutos_filter_referencia',   NULL);
        TSession::setValue('PesquisaProdutos_filter_ativo',   NULL);
        
            
            
        if (isset($data->buscaproduto) AND ($data->buscaproduto) and ($data->campopesquisa == '0')) 
        {
            $filter = new TFilter('id', '=', "{$data->buscaproduto}"); // create the filter
            TSession::setValue('PesquisaProdutos_filter_id',   $filter); // stores the filter in the session
        }


        if (isset($data->buscaproduto) AND ($data->buscaproduto) and ($data->campopesquisa == '1')) 
        {
            $filter = new TFilter('produto', 'like', "%{$data->buscaproduto}%"); // create the filter
            TSession::setValue('PesquisaProdutos_filter_produto',   $filter); // stores the filter in the session
        }


        if (isset($data->buscaproduto) AND ($data->buscaproduto) and ($data->campopesquisa == '2')) 
        {
            $filter = new TFilter('codbarras', 'like', "%{$data->buscaproduto}%"); // create the filter
            TSession::setValue('PesquisaProdutos_filter_codbarras',   $filter); // stores the filter in the session
        }


        if (isset($data->buscaproduto) AND ($data->buscaproduto) and ($data->campopesquisa == '3')) 
        {
            $filter = new TFilter('reffabricante', 'like', "%{$data->buscaproduto}%"); // create the filter
            TSession::setValue('PesquisaProdutos_filter_reffabricante',   $filter); // stores the filter in the session
        }


        if (isset($data->buscaproduto) AND ($data->buscaproduto) and ($data->campopesquisa == '4')) 
        {
            $filter = new TFilter('referencia', 'like', "%{$data->buscaproduto}%"); // create the filter
            TSession::setValue('PesquisaProdutos_filter_referencia',   $filter); // stores the filter in the session
        }


        $filter = new TFilter('ativo', 'like', 'S'); // create the filter
        TSession::setValue('PesquisaProdutos_filter_ativo',   $filter); // stores the filter in the session
        

        
        // fill the form with data again
        $this->form->setData($data);
        
        // keep the search data in the session
        TSession::setValue('PesquisaProdutos_filter_data', $data);
        
        $param = array();
        $param['offset']    =0;
        $param['first_page']=1;
        $this->onReload($param);
    }
    
    /**
     * Load the datagrid with data
     */
    public function onReload($param = NULL)
    {
        try
        {
            // open a transaction with database 'goldnotas'
            TTransaction::open('goldnotas');
            
            // creates a repository for Cadproduto
            $repository = new TRepository('Cadproduto');
            $limit = 10;
            // creates a criteria
            $criteria = new TCriteria;
            
            // default order
            if (empty($param['order']))
            {
                $param['order'] = 'id';
                $param['direction'] = 'asc';
            }
            $criteria->setProperties($param); // order, offset
            $criteria->setProperty('limit', $limit);
            

            if (TSession::getValue('PesquisaProdutos_filter_id')) {
                $criteria->add(TSession::getValue('PesquisaProdutos_filter_id')); // add the session filter
            }


            if (TSession::getValue('PesquisaProdutos_filter_produto')) {
                $criteria->add(TSession::getValue('PesquisaProdutos_filter_produto')); // add the session filter
            }         

            if (TSession::getValue('PesquisaProdutos_filter_codbarras')) {
                $criteria->add(TSession::getValue('PesquisaProdutos_filter_codbarras')); // add the session filter
            }


            if (TSession::getValue('PesquisaProdutos_filter_reffabricante')) {
                $criteria->add(TSession::getValue('PesquisaProdutos_filter_reffabricante')); // add the session filter
            }


            if (TSession::getValue('PesquisaProdutos_filter_referencia')) {
                $criteria->add(TSession::getValue('PesquisaProdutos_filter_referencia')); // add the session filter
            }


            if (TSession::getValue('PesquisaProdutos_filter_ativo')) {
                $criteria->add(TSession::getValue('PesquisaProdutos_filter_ativo')); // add the session filter
            }

            
            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);
            
            if (is_callable($this->transformCallback))
            {
                call_user_func($this->transformCallback, $objects, $param);
            }
            
            $this->datagrid->clear();
            if ($objects)
            {
                // iterate the collection of active records
                foreach ($objects as $object)
                {
                    // add the object inside the datagrid
                    $this->datagrid->addItem($object);
                }
            }
            
            // reset the criteria for record count
            $criteria->resetProperties();
            $count= $repository->count($criteria);
            
            $this->pageNavigation->setCount($count); // count of records
            $this->pageNavigation->setProperties($param); // order, page
            $this->pageNavigation->setLimit($limit); // limit
            
            // close the transaction
            TTransaction::close();
            $this->loaded = true;
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }
    
    /**
     * Ask before deletion
     */
    public static function onDelete($param)
    {
        // define the delete action
        $action = new TAction([__CLASS__, 'Delete']);
        $action->setParameters($param); // pass the key parameter ahead
        
        // shows a dialog to the user
        new TQuestion(TAdiantiCoreTranslator::translate('Do you really want to delete ?'), $action);
    }
    
    /**
     * Delete a record
     */
    public static function Delete($param)
    {
        try
        {
            $key=$param['key']; // get the parameter $key
            TTransaction::open('goldnotas'); // open a transaction with database
            $object = new Cadproduto($key, FALSE); // instantiates the Active Record
            $object->delete(); // deletes the object from the database
            TTransaction::close(); // close the transaction
            
            $pos_action = new TAction([__CLASS__, 'onReload']);
            new TMessage('info', TAdiantiCoreTranslator::translate('Record deleted'), $pos_action); // success message
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    



    
    /**
     * method show()
     * Shows the page
     */
    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded AND (!isset($_GET['method']) OR !(in_array($_GET['method'],  array('onReload', 'onSearch')))) )
        {
            if (func_num_args() > 0)
            {
                $this->onReload( func_get_arg(0) );
            }
            else
            {
                $this->onReload();
            }
        }
        parent::show();
    }
    
    public static function onChangecampopesquisa($param)
    {
        try   
        {         
            $campopesquisa = 'produto';
            switch($param['campopesquisa'])
            {
                case "0":
                    $campopesquisa = 'id';
                    break;
                case "1":
                    $campopesquisa = 'produto';
                    break;
                case "2":
                    $campopesquisa = 'codbarras';
                    break;
                case "3":
                    $campopesquisa = 'referencia';
                    break;
                case "4":
                    $campopesquisa = 'reffabricante';
                    break;                                                
            }            
            $obj = new StdClass;
            $obj->campofitro = $campofitro;
            TForm::sendData('form_PesquisaProdutos', $obj, False, False);                                
 
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
        }                
        
    }     
    
}
