<?php
/**
 * MovcaixacontacorrenteTransfList Listing
 * @author  <your name here>
 */
class MovcaixacontacorrenteTransfList extends TPage
{
    private $form; // form
    private $datagrid; // listing
    private $pageNavigation;
    private $formgrid;
    private $loaded;
    private $deleteButton;
    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_MovcaixacontacorrenteTransf');
        $this->form->setFormTitle('Movimento Transferência Caixa / Conta Banco');
        

        // create the form fields
        $datalancamento_inicio = new TDate('datalancamento_inicio');
        $datalancamento_final = new TDate('datalancamento_final');
        $historico = new TEntry('historico');
        $cre_cadcaixacontacorrente_id = new TDBUniqueSearch('cre_cadcaixacontacorrente_id', 'goldnotas', 'Cadcaixacontacorrente', 'id', 'caixacontacorrente');
        $deb_cadcaixacontacorrente_id = new TDBUniqueSearch('deb_cadcaixacontacorrente_id', 'goldnotas', 'Cadcaixacontacorrente', 'id', 'caixacontacorrente');                                            

        // add the fields
        $row = $this->form->addFields( [ new TLabel('Data Inicial') ,  $datalancamento_inicio ], 
                                       [ new TLabel('Data Final') ,  $datalancamento_final ] );
        $row->layout = ['col-sm-3', 'col-sm-3'];                        
        //$this->form->addFields( [ new TLabel('Data Final') ], [ $datalancamento_final ] );
        $row = $this->form->addFields( [ new TLabel('Conta Crédito') ,  $cre_cadcaixacontacorrente_id ] );
        $row->layout = ['col-sm-6'];
        $row = $this->form->addFields( [ new TLabel('Conta Débito') ,  $deb_cadcaixacontacorrente_id ] );
        $row->layout = ['col-sm-6'];        
        $row = $this->form->addFields( [ new TLabel('Histórico') ,  $historico ] );
        $row->layout = ['col-sm-6'];


        // set sizes
        $datalancamento_inicio->setSize('100%');
        $datalancamento_final->setSize('100%');
        $historico->setSize('100%');
        $cre_cadcaixacontacorrente_id->setSize('100%');
        $deb_cadcaixacontacorrente_id->setSize('100%');

        
        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue('MovcaixacontacorrenteTransf_filter_data') );
        
        // add the search form actions
        $btn = $this->form->addAction(_t('Find'), new TAction([$this, 'onSearch']), 'fa:search');
        $btn->class = 'btn btn-sm btn-primary';            
        $this->form->addActionLink(_t('New'), new TAction(['MovcaixacontacorrenteTransfForm', 'onEdit']), 'fa:plus green');
        
        // creates a Datagrid
        $this->datagrid = new BootstrapDatagridWrapper(new TDataGrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_id = new TDataGridColumn('id', 'Id', 'right');
        $column_datalancamento = new TDataGridColumn('datalancamento', 'Data', 'left');
        //$column_cadcaixacontacorrentetipotransf_id = new TDataGridColumn('cadcaixacontacorrentetipotransf_id', 'Cadcaixacontacorrentetipotransf Id', 'right');
        $column_historico = new TDataGridColumn('historico', 'Historico', 'left');
        $column_valor = new TDataGridColumn('valor', 'Valor', 'left');
        $column_cre_cadcaixacontacorrente_id = new TDataGridColumn('cre_caixacontacorrente', 'Conta Crédito', 'left');
        $column_deb_cadcaixacontacorrente_id = new TDataGridColumn('deb_caixacontacorrente', 'Conta Débito', 'left');
        $column_login_systemuser = new TDataGridColumn('login_systemuser', 'Usuário', 'left');

        $column_valor->setTransformer(array($this, 'formataValor'));
        $column_datalancamento->setTransformer(array($this, 'formataData'));
        
        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_id);
        $this->datagrid->addColumn($column_datalancamento);
        //$this->datagrid->addColumn($column_cadcaixacontacorrentetipotransf_id);
        $this->datagrid->addColumn($column_historico);
        $this->datagrid->addColumn($column_valor);
        $this->datagrid->addColumn($column_cre_cadcaixacontacorrente_id);
        $this->datagrid->addColumn($column_deb_cadcaixacontacorrente_id);
        $this->datagrid->addColumn($column_login_systemuser);

        
        // create EDIT action
        $action_edit = new TDataGridAction(['MovcaixacontacorrenteTransfForm', 'onEdit']);
        //$action_edit->setUseButton(TRUE);
        //$action_edit->setButtonClass('btn btn-default');
        $action_edit->setLabel(_t('Edit'));
        $action_edit->setImage('far:edit blue fa-lg');
        $action_edit->setField('id');
        $this->datagrid->addAction($action_edit);
        
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onDelete'));
        //$action_del->setUseButton(TRUE);
        //$action_del->setButtonClass('btn btn-default');
        $action_del->setLabel(_t('Delete'));
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('id');
        $this->datagrid->addAction($action_del);
        
        // create the datagrid model
        $this->datagrid->createModel();
        
        // creates the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->setAction(new TAction([$this, 'onReload']));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());
        


        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        $container->add(TPanelGroup::pack('', $this->datagrid, $this->pageNavigation));
        
        parent::add($container);
    }
    
    /**
     * Format salary
     */
    public function formataValor($valor, $object, $row)
    {       
        $number = number_format($valor, 2, ',', '.');
        if ($object->tipo1 == 'D')
        {
            return "<span style='color:red'>$number</span>";
        }
        else
        {
            return "<span style='color:blue'>$number</span>";
        }
        
        /*
        if ($valor > 0)
        {
            return "<span style='color:blue'>$number</span>";
        }
        else
        {
            $row->style = "background: #FFF9A7";
            return "<span style='color:red'>$number</span>";
        }
        */
    }  
    
    public function formataData($data, $object)
    {
        $date = new DateTime($data);
        return $date->format('d/m/Y');
    }      
    
    /**
     * Inline record editing
     * @param $param Array containing:
     *              key: object ID value
     *              field name: object attribute to be updated
     *              value: new attribute content 
     */
    public function onInlineEdit($param)
    {
        try
        {
            // get the parameter $key
            $field = $param['field'];
            $key   = $param['key'];
            $value = $param['value'];
            
            TTransaction::open('goldnotas'); // open a transaction with database
            $object = new MovcaixacontacorrenteTransf($key); // instantiates the Active Record
            $object->{$field} = $value;
            $object->store(); // update the object in the database
            TTransaction::close(); // close the transaction
            
            $this->onReload($param); // reload the listing
            new TMessage('info', "Record Updated");
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Register the filter in the session
     */
    public function onSearch()
    {
        // get the search form data
        $data = $this->form->getData();
        
        // clear session filters
        TSession::setValue('MovcaixacontacorrenteTransfList_filter_datalancamento_inicio',   NULL);
        TSession::setValue('MovcaixacontacorrenteTransfList_filter_datalancamento_final',   NULL);
        TSession::setValue('MovcaixacontacorrenteTransfList_filter_historico',   NULL);
        TSession::setValue('MovcaixacontacorrenteTransfList_filter_cre_cadcaixacontacorrente_id',   NULL);
        TSession::setValue('MovcaixacontacorrenteTransfList_filter_deb_cadcaixacontacorrente_id',   NULL);

        if (isset($data->datalancamento) AND ($data->datalancamento)) {
            $filter = new TFilter('datalancamento', '>=', "$data->datalancamento"); // create the filter
            TSession::setValue('MovcaixacontacorrenteTransfList_filter_datalancamento_inicio',   $filter); // stores the filter in the session
        }


        if (isset($data->datalancamento) AND ($data->datalancamento)) {
            $filter = new TFilter('datalancamento', '<=', "$data->datalancamento"); // create the filter
            TSession::setValue('MovcaixacontacorrenteTransfList_filter_datalancamento_final',   $filter); // stores the filter in the session
        }


        if (isset($data->historico) AND ($data->historico)) {
            $filter = new TFilter('historico', 'like', "%{$data->historico}%"); // create the filter
            TSession::setValue('MovcaixacontacorrenteTransfList_filter_historico',   $filter); // stores the filter in the session
        }


        if (isset($data->cre_cadcaixacontacorrente_id) AND ($data->cre_cadcaixacontacorrente_id)) {
            $filter = new TFilter('cre_cadcaixacontacorrente_id', '=', "$data->cre_cadcaixacontacorrente_id"); // create the filter
            TSession::setValue('MovcaixacontacorrenteTransfList_filter_cre_cadcaixacontacorrente_id',   $filter); // stores the filter in the session
        }


        if (isset($data->deb_cadcaixacontacorrente_id) AND ($data->deb_cadcaixacontacorrente_id)) {
            $filter = new TFilter('deb_cadcaixacontacorrente_id', '=', "$data->deb_cadcaixacontacorrente_id"); // create the filter
            TSession::setValue('MovcaixacontacorrenteTransfList_filter_deb_cadcaixacontacorrente_id',   $filter); // stores the filter in the session
        }

        
        // fill the form with data again
        $this->form->setData($data);
        
        // keep the search data in the session
        TSession::setValue('MovcaixacontacorrenteTransf_filter_data', $data);
        
        $param = array();
        $param['offset']    =0;
        $param['first_page']=1;
        $this->onReload($param);
    }
    
    /**
     * Load the datagrid with data
     */
    public function onReload($param = NULL)
    {
        try
        {
            // open a transaction with database 'goldnotas'
            TTransaction::open('goldnotas');
            
            // creates a repository for MovcaixacontacorrenteTransf
            $repository = new TRepository('MovcaixacontacorrenteTransf');
            $limit = 10;
            // creates a criteria
            $criteria = new TCriteria;
            
            // default order
            if (empty($param['order']))
            {
                $param['order'] = 'id';
                $param['direction'] = 'asc';
            }
            $criteria->setProperties($param); // order, offset
            $criteria->setProperty('limit', $limit);
            

            if (TSession::getValue('MovcaixacontacorrenteTransfList_filter_datalancamento_inicio')) {
                $criteria->add(TSession::getValue('MovcaixacontacorrenteTransfList_filter_datalancamento_inicio')); // add the session filter
            }


            if (TSession::getValue('MovcaixacontacorrenteTransfList_filter_datalancamento_final')) {
                $criteria->add(TSession::getValue('MovcaixacontacorrenteTransfList_filter_datalancamento_final')); // add the session filter
            }


            if (TSession::getValue('MovcaixacontacorrenteTransfList_filter_historico')) {
                $criteria->add(TSession::getValue('MovcaixacontacorrenteTransfList_filter_historico')); // add the session filter
            }


            if (TSession::getValue('MovcaixacontacorrenteTransfList_filter_cre_cadcaixacontacorrente_id')) {
                $criteria->add(TSession::getValue('MovcaixacontacorrenteTransfList_filter_cre_cadcaixacontacorrente_id')); // add the session filter
            }


            if (TSession::getValue('MovcaixacontacorrenteTransfList_filter_deb_cadcaixacontacorrente_id')) {
                $criteria->add(TSession::getValue('MovcaixacontacorrenteTransfList_filter_deb_cadcaixacontacorrente_id')); // add the session filter
            }

            
            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);
            
            if (is_callable($this->transformCallback))
            {
                call_user_func($this->transformCallback, $objects, $param);
            }
            
            $this->datagrid->clear();
            if ($objects)
            {
                // iterate the collection of active records
                foreach ($objects as $object)
                {
                    // add the object inside the datagrid
                    $this->datagrid->addItem($object);
                }
            }
            
            // reset the criteria for record count
            $criteria->resetProperties();
            $count= $repository->count($criteria);
            
            $this->pageNavigation->setCount($count); // count of records
            $this->pageNavigation->setProperties($param); // order, page
            $this->pageNavigation->setLimit($limit); // limit
            
            // close the transaction
            TTransaction::close();
            $this->loaded = true;
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }
    
    /**
     * Ask before deletion
     */
    public static function onDelete($param)
    {
        // define the delete action
        $action = new TAction([__CLASS__, 'Delete']);
        $action->setParameters($param); // pass the key parameter ahead
        
        // shows a dialog to the user
        new TQuestion(TAdiantiCoreTranslator::translate('Do you really want to delete ?'), $action);
    }
    
    /**
     * Delete a record
     */
    public static function Delete($param)
    {
        try
        {
            $key=$param['key']; // get the parameter $key
            TTransaction::open('goldnotas'); // open a transaction with database
            
            $criteria = new TCriteria;  
            $criteria->add(new TFilter('movcaixacontacorrente_transf_id', '=', $key));             
            $repository = new TRepository('Movplanoconta'); 
            $repository->delete($criteria); 
                        
            $criteria = new TCriteria; 
            $criteria->add(new TFilter('movcaixacontacorrente_transf_id', '=', $key));             
            $repository = new TRepository('Movcaixacontacorrente'); 
            $repository->delete($criteria);                          
            
            $object = new MovcaixacontacorrenteTransf($key, FALSE); // instantiates the Active Record
            $object->delete(); // deletes the object from the database
            TTransaction::close(); // close the transaction
            
            $pos_action = new TAction([__CLASS__, 'onReload']);
            new TMessage('info', TAdiantiCoreTranslator::translate('Record deleted'), $pos_action); // success message
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    



    
    /**
     * method show()
     * Shows the page
     */
    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded AND (!isset($_GET['method']) OR !(in_array($_GET['method'],  array('onReload', 'onSearch')))) )
        {
            if (func_num_args() > 0)
            {
                $this->onReload( func_get_arg(0) );
            }
            else
            {
                $this->onReload();
            }
        }
        parent::show();
    }
}
