<?php
/**
 * MovcontacorrenteList Listing
 * @author  <your name here>
 */
class MovcontacorrenteList extends TPage
{
    private $form; // form
    private $datagrid; // listing
    private $pageNavigation;
    private $formgrid;
    private $loaded;    
    private $deleteButton;
    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Movcontacorrente');
        $this->form->setFormTitle('Movimento Conta Banco');
        

        // create the form fields
        //$id = new TEntry('id');
        $cadcontacorrente_id = new TDBUniqueSearch('cadcontacorrente_id', 'goldnotas', 'Cadcontacorrente', 'id', 'contacorrente');
        $tipo = new TCombo('tipo');
        $historico = new TEntry('historico');
        $valor = new TEntry('valor');
        $compensado = new TEntry('compensado');
        $datalancamento = new TDate('datalancamento');
        $datalancamento2 = new TDate('datalancamento2');
        $datacompensado = new TEntry('datacompensado');       
        $cadempresa_id = new THidden('cadempresa_id');
        $system_user_id = new THidden('system_user_id');

        $saldoanterior = new TEntry('saldoanterior');
        $credito = new TEntry('credito');
        $debito = new TEntry('debito');
        $saldoatual = new TEntry('saldoatual');
        
        $itenstipo = array();
        $itenstipo['D'] = 'Débito';
        $itenstipo['C'] = 'Crédito';
        $tipo->addItems($itenstipo);

        // add the fields
        //$this->form->addFields( [ new TLabel('Id') ], [ $id ] );
        $row = $this->form->addFields( [ new TLabel('Conta Banco') ,  $cadcontacorrente_id ],
                                       [ new TLabel('Tipo') ,  $tipo ]);
        $row->layout = ['col-sm-4', 'col-sm-2'];                                  
        $row = $this->form->addFields( [ new TLabel('Data Inicial') , $datalancamento],
                                       [ new TLabel('Data Final') , $datalancamento2 ] );
        $row->layout = ['col-sm-3', 'col-sm-3'];                                    
        //$this->form->addFields( [ new TLabel('Tipo') ], [ $tipo ] );
        $row = $this->form->addFields( [ new TLabel('Historico') , $historico ] );
        $row->layout = ['col-sm-6'];
        //$this->form->addFields( [ new TLabel('Valor') ], [ $valor ] );
        //$this->form->addFields( [ new TLabel('Compensado') ], [ $compensado ] );        
        //$this->form->addFields( [ new TLabel('Datacompensado') ], [ $datacompensado ] );
        //$this->form->addFields( [ new TLabel('Cadcontacorrenteorigem Id') ], [ $cadcontacorrenteorigem_id ] );        
        $this->form->addFields( [ $system_user_id,$cadempresa_id ] );

        //$row->layout = ['col-sm-2', 'col-sm-6', 'col-sm-2', 'col-sm-2' ];

        // set sizes
        //$id->setSize('100%');
        $cadcontacorrente_id->setSize('100%');
        $tipo->setSize('100%');
        $historico->setSize('100%');
        $valor->setSize('40%');
        $compensado->setSize('40%');
        $datalancamento->setSize('100%');
        $datalancamento2->setSize('100%');
        $datacompensado->setSize('100%');        
        $cadempresa_id->setSize('100%');
        $system_user_id->setSize('100%');
        
        $saldoanterior->setSize('100%');
        $saldoanterior->setNumericMask(2, ',', '.');
        $saldoanterior->setEditable(FALSE);
        
        $credito->setSize('100%');
        $credito->setNumericMask(2, ',', '.');
        $credito->setEditable(FALSE);        

        $debito->setSize('100%');
        $debito->setNumericMask(2, ',', '.');
        $debito->setEditable(FALSE); 

        $saldoatual->setSize('100%');
        $saldoatual->setNumericMask(2, ',', '.');
        $saldoatual->setEditable(FALSE);
        
        $datalancamento->setMask('dd/mm/yyyy');
        $datalancamento->setDatabaseMask('yyyy-mm-dd');
        $datalancamento2->setMask('dd/mm/yyyy');
        $datalancamento2->setDatabaseMask('yyyy-mm-dd');        
        // keep the form filled during navigation with session data
        
        /*
        // add the search form actions
        $btn = $this->form->addAction(_t('Find'), new TAction([$this, 'onSearch']), 'fa:search');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addActionLink(_t('New'), new TAction(['MovcontacorrenteForm', 'onEdit']), 'fa:plus green');
        */
        
        // create the form actions
        $btnbuscar = new TButton('btnbuscar');
        $btnbuscar->class = 'btn btn-sm btn-primary';
        $btnbuscar_action = new TAction(array($this, 'onSearch'));
        $btnbuscar->setAction($btnbuscar_action, 'Buscar');
        $btnbuscar->setImage('fa:search');   
        
        $btnnovo = new TButton('btnnovo');
        //$btnnovo->class = 'btn btn-sm btn-primary';
        $btnnovo_action = new TAction(array('MovcontacorrenteForm', 'onEdit'));
        $btnnovo->setAction($btnnovo_action, 'Novo');
        $btnnovo->setImage('fa:plus green');              
        
        $this->form->addFields([$btnbuscar,$btnnovo]);                
        // creates a Datagrid
        $this->datagrid = new BootstrapDatagridWrapper(new TDataGrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_id = new TDataGridColumn('id', 'Código', 'right');
        $column_datalancamento = new TDataGridColumn('datalancamento', 'Data', 'left');        
        //$column_nome_contacorrenteorigem = new TDataGridColumn('nome_contacorrenteorigem', 'Origem', 'left');
        $column_nome_contacorrente = new TDataGridColumn('nome_contacorrente', 'Conta Banco', 'left');
        $column_historico = new TDataGridColumn('historico', 'Histórico', 'left');
        $column_valor = new TDataGridColumn('valor', 'Valor', 'right');
        //$column_login_systemuser = new TDataGridColumn('login_systemuser', 'Usuário', 'left');
        
        
        //$column_valor->setTransformer(array($this, 'formataValor'));
        //$column_datalancamento->setTransformer(array($this, 'formataData'));
        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_id);
        $this->datagrid->addColumn($column_datalancamento);        
        //$this->datagrid->addColumn($column_nome_contacorrenteorigem);
        $this->datagrid->addColumn($column_nome_contacorrente);        
        $this->datagrid->addColumn($column_historico);
        $this->datagrid->addColumn($column_valor);
        //$this->datagrid->addColumn($column_login_systemuser);
        /*
        $column_valor->setTotalFunction( function($values) {
            return array_sum((array) $values);
        });
        */
        // create EDIT action
        $action_edit = new TDataGridAction(['MovcontacorrenteForm', 'onEdit']);
        //$action_edit->setUseButton(TRUE);
        //$action_edit->setButtonClass('btn btn-default');
        $action_edit->setLabel(_t('Edit'));
        $action_edit->setImage('far:edit blue fa-lg');
        $action_edit->setField('id');        
        $action_edit->setDisplayCondition(array($this,'displayColumnEdit'));
        $this->datagrid->addAction($action_edit);
        
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onDelete'));
        //$action_del->setUseButton(TRUE);
        //$action_del->setButtonClass('btn btn-default');
        $action_del->setLabel(_t('Delete'));
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('id');
        $action_del->setDisplayCondition(array($this,'displayColumnEdit'));
        $this->datagrid->addAction($action_del);
        
        // create the datagrid model
        $this->datagrid->createModel();
        
        // creates the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->setAction(new TAction([$this, 'onReload']));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());             
        $this->form->addContent([TPanelGroup::pack('', $this->datagrid, $this->pageNavigation)]);
        

        $row = $this->form->addFields( [ new TLabel('Saldo Anterior'),$saldoanterior ],
                                       [ new TLabel('Débito'),$debito ],
                                       [ new TLabel('Crédito'),$credito ],
                                       [ new TLabel('Saldo Atual'),$saldoatual ] );
        $row->layout = ['col-sm-3', 'col-sm-3', 'col-sm-3', 'col-sm-3' ];

        //$this->form->setData( TSession::getValue('Movcontacorrente_filter_data') );
        //$this->form->addContent([$this->datagrid]);
        //$this->form->addContent([$this->pageNavigation]);
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        //$container->add(TPanelGroup::pack('', $this->datagrid, $this->pageNavigation));
        
        parent::add($container);
    }

    public function displayColumnEdit( $object )
    {
        //return ($object->nome_contacorrenteorigem == '');
        TTransaction::open('goldnotas'); // open a transaction with database
        $objmov = new Movcontacorrente($object->id); // instantiates the Active Record
        return ($objmov->cadcontacorrenteorigem_id == '1');
        TTransaction::close(); // close the transaction        
    } 
    /**
     * Format salary
     */
    public function formataValor($valor, $object, $row)
    {       
        $number = number_format($valor, 2, ',', '.');
        if ($object->tipo1 == 'D')
        {
            return "<span style='color:red'>$number</span>";
        }
        else
        {
            return "<span style='color:blue'>$number</span>";
        }
        
        /*
        if ($valor > 0)
        {
            return "<span style='color:blue'>$number</span>";
        }
        else
        {
            $row->style = "background: #FFF9A7";
            return "<span style='color:red'>$number</span>";
        }
        */
    }  
    
    public function formataData($data, $object)
    {
        $date = new DateTime($data);
        return $date->format('d/m/Y');
    }        
    
    /**
     * Inline record editing
     * @param $param Array containing:
     *              key: object ID value
     *              field name: object attribute to be updated
     *              value: new attribute content 
     */
    public function onInlineEdit($param)
    {
        try
        {
            // get the parameter $key
            $field = $param['field'];
            $key   = $param['key'];
            $value = $param['value'];
            
            TTransaction::open('goldnotas'); // open a transaction with database
            $object = new Movcontacorrente($key); // instantiates the Active Record
            $object->{$field} = $value;
            $object->store(); // update the object in the database
            TTransaction::close(); // close the transaction
            
            $this->onReload($param); // reload the listing
            new TMessage('info', "Record Updated");
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Register the filter in the session
     */
    public function onSearch()
    {
        // get the search form data
        $data = $this->form->getData();
        
        // clear session filters
        //TSession::setValue('Movcontacorrente_filter_data',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_id',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_cadcontacorrente_id',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_tipo',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_historico',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_valor',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_compensado',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_datalancamento',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_datalancamento2',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_datacompensado',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_cadcontacorrenteorigem_id',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_cadempresa_id',   NULL);
        TSession::setValue('MovcontacorrenteList_filter_system_user_id',   NULL);

        if (isset($data->id) AND ($data->id)) {
            $filter = new TFilter('id', '=', "$data->id"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_id',   $filter); // stores the filter in the session
        }


        if (isset($data->cadcontacorrente_id) AND ($data->cadcontacorrente_id)) {
            $filter = new TFilter('cadcontacorrente_id', '=', "$data->cadcontacorrente_id"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_cadcontacorrente_id',   $filter); // stores the filter in the session
        }


        if (isset($data->tipo) AND ($data->tipo)) {
            $filter = new TFilter('tipo', 'like', "%{$data->tipo}%"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_tipo',   $filter); // stores the filter in the session
        }


        if (isset($data->historico) AND ($data->historico)) {
            $filter = new TFilter('historico', 'like', "%{$data->historico}%"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_historico',   $filter); // stores the filter in the session
        }


        if (isset($data->valor) AND ($data->valor)) {
            $filter = new TFilter('valor', 'like', "%{$data->valor}%"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_valor',   $filter); // stores the filter in the session
        }


        if (isset($data->compensado) AND ($data->compensado)) {
            $filter = new TFilter('compensado', 'like', "%{$data->compensado}%"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_compensado',   $filter); // stores the filter in the session
        }


        if (isset($data->datalancamento) AND ($data->datalancamento)) {
            $filter = new TFilter('datalancamento', '>=', "{$data->datalancamento}"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_datalancamento',   $filter); // stores the filter in the session

            $filter = new TFilter('datalancamento', '<', "{$data->datalancamento}"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_datalancamento_anterior',   $filter); // stores the filter in the session                        
        }

        if (isset($data->datalancamento2) AND ($data->datalancamento2)) {
            $filter = new TFilter('datalancamento', '<=', "{$data->datalancamento2}"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_datalancamento2',   $filter); // stores the filter in the session
        }

        if (isset($data->datacompensado) AND ($data->datacompensado)) {
            $filter = new TFilter('datacompensado', 'like', "%{$data->datacompensado}%"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_datacompensado',   $filter); // stores the filter in the session
        }


        if (isset($data->cadcontacorrenteorigem_id) AND ($data->cadcontacorrenteorigem_id)) {
            $filter = new TFilter('cadcontacorrenteorigem_id', '=', "$data->cadcontacorrenteorigem_id"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_cadcontacorrenteorigem_id',   $filter); // stores the filter in the session
        }


        if (isset($data->cadempresa_id) AND ($data->cadempresa_id)) {
            $filter = new TFilter('cadempresa_id', '=', "$data->cadempresa_id"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_cadempresa_id',   $filter); // stores the filter in the session
        }


        if (isset($data->system_user_id) AND ($data->system_user_id)) {
            $filter = new TFilter('system_user_id', '=', "$data->system_user_id"); // create the filter
            TSession::setValue('MovcontacorrenteList_filter_system_user_id',   $filter); // stores the filter in the session
        }

        $this->onCalculaRodape($data);
        //echo var_dump($data) . '</br>';        
        // fill the form with data again
        $data = $this->form->getData();
        $this->form->setData($data);   
        //echo var_dump($data);     
        // keep the search data in the session
        TSession::setValue('Movcontacorrente_filter_data', $data);
        $data = TSession::getValue('Movcontacorrente_filter_data');
        //echo var_dump($data);
        $param = array();
        $param['offset']    =0;
        $param['first_page']=1;
        $this->onReload($param);
    }
    
    /**
     * Load the datagrid with data
     */
    public function onReload($param = NULL)
    {
        try
        {
            // open a transaction with database 'goldnotas'
            TTransaction::open('goldnotas');
            
            // creates a repository for Movcontacorrente
            $repository = new TRepository('Movcontacorrente');
            $limit = 10;
            // creates a criteria
            $criteria = new TCriteria;
            
            // default order
            if (empty($param['order']))
            {
                $param['order'] = 'id';
                $param['direction'] = 'asc';
            }
            $criteria->setProperties($param); // order, offset
            $criteria->setProperty('limit', $limit);
            

            if (TSession::getValue('MovcontacorrenteList_filter_id')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_id')); // add the session filter
            }


            if (TSession::getValue('MovcontacorrenteList_filter_cadcontacorrente_id')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_cadcontacorrente_id')); // add the session filter
            }


            if (TSession::getValue('MovcontacorrenteList_filter_tipo')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_tipo')); // add the session filter
            }


            if (TSession::getValue('MovcontacorrenteList_filter_historico')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_historico')); // add the session filter
            }


            if (TSession::getValue('MovcontacorrenteList_filter_valor')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_valor')); // add the session filter
            }


            if (TSession::getValue('MovcontacorrenteList_filter_compensado')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_compensado')); // add the session filter
            }


            if (TSession::getValue('MovcontacorrenteList_filter_datalancamento')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_datalancamento')); // add the session filter
            }

            if (TSession::getValue('MovcontacorrenteList_filter_datalancamento2')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_datalancamento2')); // add the session filter
            }

            if (TSession::getValue('MovcontacorrenteList_filter_datacompensado')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_datacompensado')); // add the session filter
            }


            if (TSession::getValue('MovcontacorrenteList_filter_cadcontacorrenteorigem_id')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_cadcontacorrenteorigem_id')); // add the session filter
            }


            if (TSession::getValue('MovcontacorrenteList_filter_cadempresa_id')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_cadempresa_id')); // add the session filter
            }


            if (TSession::getValue('MovcontacorrenteList_filter_system_user_id')) {
                $criteria->add(TSession::getValue('MovcontacorrenteList_filter_system_user_id')); // add the session filter
            }

            //echo $criteria->dump();
            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);
            
            if (is_callable($this->transformCallback))
            {
                call_user_func($this->transformCallback, $objects, $param);
            }
            
            $this->datagrid->clear();
            if ($objects)
            {
                // iterate the collection of active records
                foreach ($objects as $object)
                {
                    // add the object inside the datagrid
                    //$this->datagrid->addItem($object);
                    
                    $item = new StdClass;
                    $item->id  = $object->id;
                    $item->datalancamento = HDateFormat::date2br($object->datalancamento);                         
                    //$item->nome_contacorrenteorigem = $object->nome_contacorrenteorigem;
                    $item->nome_contacorrente = $object->nome_contacorrente;
                    $item->historico = $object->historico;
                    $item->valor = HMoneyFormat::reais($object->valor);
                    //$item->login_systemuser = $object->login_systemuser; 
                    $row = $this->datagrid->addItem($item);
                    $row->popover = 'true';
                    $row->popside = 'bottom';
                    $row->popcontent = "<table class='popover-table'>";
                    $row->popcontent = $row->popcontent . "<tr><td>Usuário</td><td>{$object->login_systemuser}</td></tr>";
                    $row->popcontent = $row->popcontent . "</table>";
                    $row->poptitle = 'Detalhes';                        
                                    
                }
            }
            
            // reset the criteria for record count
            $criteria->resetProperties();
            $count= $repository->count($criteria);
            
            $criteria->resetProperties();                     
            
            $this->pageNavigation->setCount($count); // count of records
            $this->pageNavigation->setProperties($param); // order, page
            $this->pageNavigation->setLimit($limit); // limit
            $data = TSession::getValue('Movcontacorrente_filter_data');
            //var_dump($data);
            $this->form->setData( $data );
            $this->onCalculaRodape(null);
            // close the transaction
            TTransaction::close();
            $this->loaded = true;
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }
    
    /**
     * Ask before deletion
     */         
     
    public static function onDelete($param)
    {
        // define the delete action
        $action = new TAction([__CLASS__, 'Delete']);
        $action->setParameters($param); // pass the key parameter ahead        
        // shows a dialog to the user
        new TQuestion(TAdiantiCoreTranslator::translate('Do you really want to delete ?'), $action);
    }
    
    /**
     * Delete a record
     */
    public static function Delete($param)
    {
        try
        {
            $key=$param['key']; // get the parameter $key
            TTransaction::open('goldnotas'); // open a transaction with database
            $criteria = new TCriteria; 
            $criteria->add(new TFilter('movcontacorrente_id', '=', $key));             
            $repository = new TRepository('Movplanoconta'); 
            $repository->delete($criteria);            
            $object = new Movcontacorrente($key, FALSE); // instantiates the Active Record
            $object->delete(); // deletes the object from the database            
            TTransaction::close(); // close the transaction
            
            $pos_action = new TAction([__CLASS__, 'onReload']);
            new TMessage('info', TAdiantiCoreTranslator::translate('Record deleted'), $pos_action); // success message
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onCalculaRodape( $data )
    {
        try
        {
            TTransaction::open('goldnotas');
            
            // creates a repository for Movcontacorrente
            //$repository = new TRepository('Movcontacorrente');
            //creditos           
            $criteria = new TCriteria;
            if (TSession::getValue('MovcontacorrenteList_filter_cadcaixa_id')) {
                $criteria->add(TSession::getValue('MovcaixaList_filter_cadcaixa_id')); // add the session filter
            }
            if (TSession::getValue('MovcontacorrenteList_filter_historico')) {
                $criteria->add(TSession::getValue('MovcaixaList_filter_historico')); // add the session filter
            }
            if (TSession::getValue('MovcontacorrenteList_filter_datalancamento')) {
                $criteria->add(TSession::getValue('MovcaixaList_filter_datalancamento')); // add the session filter
            }
            if (TSession::getValue('MovcontacorrenteList_filter_datalancamento2')) {
                $criteria->add(TSession::getValue('MovcaixaList_filter_datalancamento2')); // add the session filter
            }                  
            $repossum = new HRepository('Movcontacorrente');
                        
            $filter = new TFilter('tipo', '=', 'C');
            $criteria->add($filter);            
            $credito = $repossum->sum('valor',$criteria);
            //debitos
            $criteria = new TCriteria;
            if (TSession::getValue('MovcontacorrenteList_filter_cadcaixa_id')) {
                $criteria->add(TSession::getValue('MovcaixaList_filter_cadcaixa_id')); // add the session filter
            }
            if (TSession::getValue('MovcontacorrenteList_filter_historico')) {
                $criteria->add(TSession::getValue('MovcaixaList_filter_historico')); // add the session filter
            }
            if (TSession::getValue('MovcontacorrenteList_filter_datalancamento')) {
                $criteria->add(TSession::getValue('MovcaixaList_filter_datalancamento')); // add the session filter
            }
            if (TSession::getValue('MovcontacorrenteList_filter_datalancamento2')) {
                $criteria->add(TSession::getValue('MovcaixaList_filter_datalancamento2')); // add the session filter
            }                  
            $repossum = new HRepository('Movcontacorrente');
            
            $filter = new TFilter('tipo', '=', 'D');
            $criteria->add($filter);            
            $debito = $repossum->sum('valor',$criteria);            
            $saldoatual = $credito + $debito;            
            
            //saldo anterior
            if (TSession::getValue('MovcontacorrenteList_filter_datalancamento_anterior')) 
            {
                $criteria = new TCriteria;
                if (TSession::getValue('MovcontacorrenteList_filter_cadcontacorrente_id')) {
                    $criteria->add(TSession::getValue('MovcontacorrenteList_filter_cadcontacorrente_id')); // add the session filter
                }
                if (TSession::getValue('MovcontacorrenteList_filter_tipo')) {
                    $criteria->add(TSession::getValue('MovcontacorrenteList_filter_tipo')); // add the session filter
                }
                if (TSession::getValue('MovcontacorrenteList_filter_historico')) {
                    $criteria->add(TSession::getValue('MovcontacorrenteList_filter_historico')); // add the session filter
                }
                if (TSession::getValue('MovcontacorrenteList_filter_datalancamento')) {
                    $criteria->add(TSession::getValue('MovcontacorrenteList_filter_datalancamento_anterior')); // add the session filter
                }                
                $repossum = new HRepository('Movcontacorrente');
                $saldoanterior = $repossum->sum('valor',$criteria);
                //echo $criteria->dump();
            } else $saldoanterior = 0;           
            $saldoatual = $saldoatual + $saldoanterior;
            $obj = new StdClass;
            //devolve ao form os valores em real
            $obj->saldoatual = HMoneyFormat::reais($saldoatual);   
            $obj->saldoanterior = HMoneyFormat::reais($saldoanterior); 
            $obj->credito = HMoneyFormat::reais($credito);
            $obj->debito = HMoneyFormat::reais($debito);          
            TForm::sendData('form_Movcontacorrente', $obj); 
            //TSession::setValue('Movcontacorrente_filter_data',$obj);
            // close the transaction
            TTransaction::close();                          
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
            
    }    
    
    /**
     * method show()
     * Shows the page
     */
    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded AND (!isset($_GET['method']) OR !(in_array($_GET['method'],  array('onReload', 'onSearch')))) )
        {
            $this->form->setData( TSession::getValue('Movcontacorrente_filter_data') );
            if (func_num_args() > 0)
            {
                $this->onReload( func_get_arg(0) );
            }
            else
            {
                $this->onReload();
            }
        }
        parent::show();
    }
}
