<?php
/**
 * CadtipooperacaoList Listing
 * @author  <your name here>
 */
class CadtipooperacaoList extends TPage
{
    private $form; // form
    private $datagrid; // listing
    private $pageNavigation;
    private $formgrid;
    private $loaded;
    private $deleteButton;
    
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_search_Cadtipooperacao');
        $this->form->setFormTitle('Listagem Tipo de Operação');
        

        // create the form fields
        $id = new TEntry('id');
        $descricao = new TEntry('descricao');
        $tipooperacao = new TCombo('tipooperacao');
        $serie = new TEntry('serie');
        $modelodfe = new TCombo('modelodfe');


        // add the fields
        $row = $this->form->addFields( [ new TLabel('Código') , $id ], 
                                       [ new TLabel('Descrição') , $descricao ] );
        $row->layout = ['col-sm-2  control-label', 'col-sm-4  control-label'];
                                               
        $row = $this->form->addFields( [ new TLabel('Tipo Operação') , $tipooperacao ], 
                                       [ new TLabel('Série') , $serie ], 
                                       [ new TLabel('Modelo DFe') , $modelodfe ] );
        $row->layout = ['col-sm-2  control-label', 'col-sm-2  control-label', 'col-sm-2  control-label'];                                       


        // set sizes
        $id->setSize('100%');
        $descricao->setSize('100%');
        $tipooperacao->setSize('100%');
        $serie->setSize('100%');
        $modelodfe->setSize('100%');
        
        $tipooperacao->addItems(diversosmovimento::listtipooperacao());
        $modelodfe->addItems(diversosdfe::listmodelodfe());
        
        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue(__CLASS__ . '_filter_data') );
        
        // add the search form actions
        $btn = $this->form->addAction(_t('Find'), new TAction([$this, 'onSearch']), 'fa:search');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addActionLink(_t('New'), new TAction(['CadtipooperacaoForm', 'onEdit']), 'fa:plus green');
        
        // creates a Datagrid
        $this->datagrid = new BootstrapDatagridWrapper(new TDataGrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        

        // creates the datagrid columns
        $column_id = new TDataGridColumn('id', 'Código', 'right');
        $column_descricao = new TDataGridColumn('descricao', 'Descrição', 'left');
        $column_desctipooperacao = new TDataGridColumn('desctipooperacao', 'Tipo Operação', 'left');
        $column_serie = new TDataGridColumn('serie', 'Série', 'left');
        $column_descmodelodfe = new TDataGridColumn('descmodelodfe', 'Modelo DFe', 'left');


        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_id);
        $this->datagrid->addColumn($column_descricao);
        $this->datagrid->addColumn($column_desctipooperacao);
        $this->datagrid->addColumn($column_serie);
        $this->datagrid->addColumn($column_descmodelodfe);


        $action1 = new TDataGridAction(['CadtipooperacaoForm', 'onEdit'], ['id'=>'{id}']);
        $action2 = new TDataGridAction([$this, 'onDelete'], ['id'=>'{id}']);
        
        $this->datagrid->addAction($action1, _t('Edit'),   'far:edit blue');
        $this->datagrid->addAction($action2 ,_t('Delete'), 'far:trash-alt red');
        
        // create the datagrid model
        $this->datagrid->createModel();
        
        // creates the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->setAction(new TAction([$this, 'onReload']));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        $container->add(TPanelGroup::pack('', $this->datagrid, $this->pageNavigation));
        
        parent::add($container);
    }
    
    /**
     * Inline record editing
     * @param $param Array containing:
     *              key: object ID value
     *              field name: object attribute to be updated
     *              value: new attribute content 
     */
    public function onInlineEdit($param)
    {
        try
        {
            // get the parameter $key
            $field = $param['field'];
            $key   = $param['key'];
            $value = $param['value'];
            
            TTransaction::open('goldnotas'); // open a transaction with database
            $object = new Cadtipooperacao($key); // instantiates the Active Record
            $object->{$field} = $value;
            $object->store(); // update the object in the database
            TTransaction::close(); // close the transaction
            
            $this->onReload($param); // reload the listing
            new TMessage('info', "Record Updated");
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Register the filter in the session
     */
    public function onSearch()
    {
        // get the search form data
        $data = $this->form->getData();
        
        // clear session filters
        TSession::setValue(__CLASS__.'_filter_id',   NULL);
        TSession::setValue(__CLASS__.'_filter_descricao',   NULL);
        TSession::setValue(__CLASS__.'_filter_tipooperacao',   NULL);
        TSession::setValue(__CLASS__.'_filter_serie',   NULL);
        TSession::setValue(__CLASS__.'_filter_modelodfe',   NULL);

        if (isset($data->id) AND ($data->id)) {
            $filter = new TFilter('id', '=', $data->id); // create the filter
            TSession::setValue(__CLASS__.'_filter_id',   $filter); // stores the filter in the session
        }


        if (isset($data->descricao) AND ($data->descricao)) {
            $filter = new TFilter('descricao', 'like', "%{$data->descricao}%"); // create the filter
            TSession::setValue(__CLASS__.'_filter_descricao',   $filter); // stores the filter in the session
        }


        if (isset($data->tipooperacao) AND ($data->tipooperacao)) {
            $filter = new TFilter('tipooperacao', 'like', "%{$data->tipooperacao}%"); // create the filter
            TSession::setValue(__CLASS__.'_filter_tipooperacao',   $filter); // stores the filter in the session
        }


        if (isset($data->serie) AND ($data->serie)) {
            $filter = new TFilter('serie', 'like', "%{$data->serie}%"); // create the filter
            TSession::setValue(__CLASS__.'_filter_serie',   $filter); // stores the filter in the session
        }


        if (isset($data->modelodfe) AND ($data->modelodfe)) {
            $filter = new TFilter('modelodfe', 'like', "%{$data->modelodfe}%"); // create the filter
            TSession::setValue(__CLASS__.'_filter_modelodfe',   $filter); // stores the filter in the session
        }

        
        // fill the form with data again
        $this->form->setData($data);
        
        // keep the search data in the session
        TSession::setValue(__CLASS__ . '_filter_data', $data);
        
        $param = array();
        $param['offset']    =0;
        $param['first_page']=1;
        $this->onReload($param);
    }
    
    /**
     * Load the datagrid with data
     */
    public function onReload($param = NULL)
    {
        try
        {
            // open a transaction with database 'goldnotas'
            TTransaction::open('goldnotas');
            
            // creates a repository for Cadtipooperacao
            $repository = new TRepository('Cadtipooperacao');
            $limit = 10;
            // creates a criteria
            $criteria = new TCriteria;
            
            // default order
            if (empty($param['order']))
            {
                $param['order'] = 'id';
                $param['direction'] = 'asc';
            }
            $criteria->setProperties($param); // order, offset
            $criteria->setProperty('limit', $limit);
            

            if (TSession::getValue(__CLASS__.'_filter_id')) {
                $criteria->add(TSession::getValue(__CLASS__.'_filter_id')); // add the session filter
            }


            if (TSession::getValue(__CLASS__.'_filter_descricao')) {
                $criteria->add(TSession::getValue(__CLASS__.'_filter_descricao')); // add the session filter
            }


            if (TSession::getValue(__CLASS__.'_filter_tipooperacao')) {
                $criteria->add(TSession::getValue(__CLASS__.'_filter_tipooperacao')); // add the session filter
            }


            if (TSession::getValue(__CLASS__.'_filter_serie')) {
                $criteria->add(TSession::getValue(__CLASS__.'_filter_serie')); // add the session filter
            }


            if (TSession::getValue(__CLASS__.'_filter_modelodfe')) {
                $criteria->add(TSession::getValue(__CLASS__.'_filter_modelodfe')); // add the session filter
            }

            
            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);
            
            if (is_callable($this->transformCallback))
            {
                call_user_func($this->transformCallback, $objects, $param);
            }
            
            $this->datagrid->clear();
            if ($objects)
            {
                // iterate the collection of active records
                foreach ($objects as $object)
                {
                    // add the object inside the datagrid
                    $this->datagrid->addItem($object);
                }
            }
            
            // reset the criteria for record count
            $criteria->resetProperties();
            $count= $repository->count($criteria);
            
            $this->pageNavigation->setCount($count); // count of records
            $this->pageNavigation->setProperties($param); // order, page
            $this->pageNavigation->setLimit($limit); // limit
            
            // close the transaction
            TTransaction::close();
            $this->loaded = true;
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
            TTransaction::rollback();
        }
    }
    
    /**
     * Ask before deletion
     */
    public static function onDelete($param)
    {
        // define the delete action
        $action = new TAction([__CLASS__, 'Delete']);
        $action->setParameters($param); // pass the key parameter ahead
        
        // shows a dialog to the user
        new TQuestion(AdiantiCoreTranslator::translate('Do you really want to delete ?'), $action);
    }
    
    /**
     * Delete a record
     */
    public static function Delete($param)
    {
        try
        {
            $key=$param['key']; // get the parameter $key
            TTransaction::open('goldnotas'); // open a transaction with database
            $object = new Cadtipooperacao($key, FALSE); // instantiates the Active Record
            $object->delete(); // deletes the object from the database
            TTransaction::close(); // close the transaction
            
            $pos_action = new TAction([__CLASS__, 'onReload']);
            new TMessage('info', AdiantiCoreTranslator::translate('Record deleted'), $pos_action); // success message
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * method show()
     * Shows the page
     */
    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded AND (!isset($_GET['method']) OR !(in_array($_GET['method'],  array('onReload', 'onSearch')))) )
        {
            if (func_num_args() > 0)
            {
                $this->onReload( func_get_arg(0) );
            }
            else
            {
                $this->onReload();
            }
        }
        parent::show();
    }
}
