<?php
/**
 * MovimentoForm Form
 * @author  <your name here>
 */
class MovimentoFechaForm extends TPage
{
    protected $form; // form
    protected $datagridparcs;
    protected $datagridformapgto; //desativado
    protected $formapgto_list;
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        parent::include_js('app/lib/include/app_sctipt_tabenter.js');
        //TScript::create('setTimeout(function() { $("input[name=\'cadtipooperacao_id\']").focus() }, 500);'); 
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Movimentofecha');
        $this->form->setFormTitle('Fechamento de Venda');
        $this->form->setFieldSizes('100%');

        $movimentoid = $param['idmovimento']??'';
        // create the form fields
        $idmovimento = new THidden('idmovimento');        
        $movimentoitem = new THidden('movimentoitem');
        $movimentoitem_loaded = new THidden('movimentoitem_loaded');
        $movimentoitem_count = new THidden('movimentoitem_count');
        $tipooperacao = new THidden('tipooperacao'); 
        
        $movimentoformapgto_loaded = new THidden('movimentoformapgto_loaded');
        $movimentoformapgto_count = new THidden('movimentoformapgto_count');
        $movimentoformapgto = new THidden('movimentoformapgto');                 
        
        $id = new THidden('id');
        $cadempresa_id = new THidden('cadempresa_id');
        $cadalmoxarifado_id = new THidden('cadalmoxarifado_id');
        $cadtipooperacao_id = new TDBCombo('cadtipooperacao_id', 'goldnotas', 'Cadtipooperacao', 'id', 'descricao');
        $cadcondpgto_id = new TDBCombo('cadcondpgto_id', 'goldnotas', 'Cadcondpgto', 'id', 'descricao');
        
        $filtro = new TCriteria;                     
        $filtro->add(new TFilter('evendedor', '=', "S"), TExpression::OR_OPERATOR);
        
        $vendedor_cadpessoa_id = new TDBCombo('vendedor_cadpessoa_id', 'goldnotas', 'Cadpessoa', 'id', 'pessoa', null, $filtro);
        $numero = new TEntry('numero');
        $serie = new TEntry('serie');
        $dataemissao = new TDate('dataemissao');
        $dataentrada = new TDate('dataentrada');
        $cadnaturezaoperacao_id = new TDBCombo('cadnaturezaoperacao_id', 'goldnotas', 'Cadnaturezaoperacao', 'id', '{id_natureza} - {natureza}');
                   
        $filtro = new TCriteria;                     
        $filtro->add(new TFilter('ecliente', '=', "S"), TExpression::OR_OPERATOR);
        $filtro->add(new TFilter('efornecedor', '=', "S"), TExpression::OR_OPERATOR); 
        
        $cadpessoa_id = new TDBCombo('cadpessoa_id', 'goldnotas', 'Cadpessoa', 'id', 'pessoa', null, $filtro);
        $subtotalgeral = new TEntry('subtotalgeral');
        $totalgeral = new TEntry('totalgeral');
        $itens = new TEntry('itens');
        $itens->style = 'text-align: center';
        $descontogeral = new TEntry('descontogeral');
        $margem_descontogeral = new TEntry('margem_descontogeral');

        $obs = new TText('obs');
        $nomeconsumidor = new TEntry('nomeconsumidor');
        $cpfcnpjconsumidor = new TEntry('cpfcnpjconsumidor');
        $total_produtos = new TEntry('total_produtos');
        $total_servicos = new TEntry('total_servicos');               

        $idmovimento->setValue($movimentoid);
        $itens->setEditable(False);
        $subtotalgeral->setEditable(False);
        $total_produtos->setEditable(False);
        $total_servicos->setEditable(False);
        $totalgeral->setEditable(False);
        $cadtipooperacao_id->setEditable(False);
        $cadpessoa_id->setEditable(False);
        $vendedor_cadpessoa_id->setEditable(False);
        $cadcondpgto_id->setEditable(False); 
        $numero->setEditable(False);
        $serie->setEditable(False);
        $dataemissao->setEditable(False);
        $dataentrada->setEditable(False);       
        
        $subtotalgeral->setNumericMask(2, ',', '.', true);
        $total_produtos->setNumericMask(2, ',', '.', true);
        $total_servicos->setNumericMask(2, ',', '.', true);
        $descontogeral->setNumericMask(2, ',', '.', true);
        $totalgeral->setNumericMask(2, ',', '.', true);
        
        $descontogeral->setEditable(False);
        $margem_descontogeral->setEditable(False);
        
        
        $dataemissao->setMask('dd/mm/yyyy');
        $dataemissao->setDatabaseMask('yyyy-mm-dd');
        
        $dataentrada->setMask('dd/mm/yyyy');
        $dataentrada->setDatabaseMask('yyyy-mm-dd');                
       

        // add the fields
        $row = $this->form->addFields( [ new TLabel('Tipo de Operação') , $cadtipooperacao_id ] ,
                                       [ new TLabel('Número') , $numero ],
                                       [ new TLabel('Série') , $serie ],
                                       [ new TLabel('Dt. Emissão') , $dataemissao ],
                                       [ new TLabel('Dt. Entrada') , $dataentrada ]);
        $row->layout = ['col-sm-4','col-sm-1','col-sm-1','col-sm-2','col-sm-2'];  
        $row = $this->form->addFields( [ new TLabel('Pessoa') , $cadpessoa_id ],
                                       [ new TLabel('Vendedor') , $vendedor_cadpessoa_id ],        
                                       [ new TLabel('Condição de Pagamento') , $cadcondpgto_id ] );
        $row->layout = ['col-sm-4','col-sm-3','col-sm-3'];        
                                                             
        $this->form->addFields( [ $id ], [$idmovimento],[ $cadempresa_id ],[ $cadalmoxarifado_id ],
                                [$movimentoitem], [$movimentoitem_loaded], [$movimentoitem_count],
                                [$tipooperacao],
                                [$movimentoformapgto],
                                [$movimentoformapgto_count],
                                [$movimentoformapgto_loaded] );        
       
   
        $row = $this->form->addFields( [ new TLabel('Itens') , $itens ],
                                       [ new TLabel('Produtos') , $total_produtos ],
                                       [ new TLabel('Servicos') , $total_servicos ],                                    
                                       [ new TLabel('Subtotal') ,  $subtotalgeral ],
                                       [ new TLabel('Desconto') ,  $descontogeral ],        
                                       [ new TLabel('Total') , $totalgeral ] );
        $row->layout = ['col-sm-1',
                        'col-sm-1',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2'];
/*
Tratamentos datas
$dataini = new DateTime($object->dataalteracao);
$datafim = new DateTime(date('Y-m-d'));
$diferenca = $dataini->diff($datafim);
$object->dias = ($diferenca->d+1);

$data = '17/11/2014';
$data = DateTime::createFromFormat('d/m/Y', $data);
*/

        // set sizes
        $id->setSize('100%');
        $cadempresa_id->setSize('100%');
        $cadalmoxarifado_id->setSize('100%');
        $cadtipooperacao_id->setSize('100%');
        $cadcondpgto_id->setSize('100%');
        $numero->setSize('100%');
        $serie->setSize('100%');
        $dataemissao->setSize('100%');
        $dataentrada->setSize('100%');
        $cadnaturezaoperacao_id->setSize('100%');
        $cadpessoa_id->setSize('100%');
        $subtotalgeral->setSize('100%');
        $totalgeral->setSize('100%');

        $obs->setSize('100%');
        $nomeconsumidor->setSize('100%');
        $cpfcnpjconsumidor->setSize('100%');
        $total_produtos->setSize('100%');
        $total_servicos->setSize('100%');
        /*
        $desconto_produtos->setSize('100%');
        $desconto_servicos->setSize('100%');
        $margem_desconto_produtos->setSize('100%');
        $margem_desconto_servicos->setSize('100%');
        */
        $vendedor_cadpessoa_id->setSize('100%');

        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }

        // creates a Datagrid
        $this->datagridparcs = new TDataGrid;
        $this->datagridparcs = new BootstrapDatagridWrapper($this->datagridparcs);
        $this->datagridparcs->style = 'width: 100%';
        $this->datagridparcs->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        // make scrollable and define height
        $this->datagridparcs->setHeight(200);
        $this->datagridparcs->makeScrollable();        

        // creates the datagrid columns
        $column_parcela       = new TDataGridColumn('parcela',        'Parc',        'center', '10%');
        $column_vencimento    = new TDataGridColumn('vencimento',     'Vencimento',  'center','10%');                
        $column_valor         = new TDataGridColumn('valor',          'Valor',       'right','20%');                              
        
        //movimentoitem
        // add the columns to the DataGrid
        $this->datagridparcs->addColumn($column_parcela);
        $this->datagridparcs->addColumn($column_vencimento);
        $this->datagridparcs->addColumn($column_valor);              
                            
        // create the datagrid model
        $this->datagridparcs->createModel();    
        
        
        
        // creates a Datagrid
        $this->datagridformapgto = new TDataGrid;
        $this->datagridformapgto = new BootstrapDatagridWrapper($this->datagridformapgto);
        $this->datagridformapgto->style = 'width: 100%';
        $this->datagridformapgto->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        // make scrollable and define height
        $this->datagridformapgto->setHeight(200);
        $this->datagridformapgto->makeScrollable();        

        // creates the datagrid columns
        $column_item               = new TDataGridColumn('item',               'Item',                 'center', '15%');
        $column_valor              = new TDataGridColumn('valor',              'Valor',                'right','15%');                      
        $column_formapgto          = new TDataGridColumn('formapgto',          'Forma Pgto',           'left', '35%');
        $column_caixacontacorrente = new TDataGridColumn('caixacontacorrente', 'Caixa/Conta Corrente', 'left','35%');                              
        
        //movimentoitem
        // add the columns to the DataGrid
        $this->datagridformapgto->addColumn($column_item);
        $this->datagridformapgto->addColumn($column_valor);
        $this->datagridformapgto->addColumn($column_formapgto);
        $this->datagridformapgto->addColumn($column_caixacontacorrente);     
        
        // create DELETE action
        $formapgto_del = new TDataGridAction(array($this, 'onFormaPgtoDel'));
        $formapgto_del->setLabel(_t('Delete'));
        $formapgto_del->setImage('far:trash-alt red fa-lg');
        $formapgto_del->setField('idmovimento');
        $this->datagridformapgto->addAction($formapgto_del);                         
                            
        // create the datagrid model
        $this->datagridformapgto->createModel();
        
        
        $subform = new BootstrapFormBuilder;
        $subform->setFieldSizes('100%');
        $subform->setProperty('style', 'border:none');        
        
        $cadformapgto_id = new TDBCombo('cadformapgto_id','goldnotas','Cadformapgto','id','descricao');
        $valorpgto = new TEntry('valorpgto');
        $cadcaixacontacorrente_id = new TDBCombo('cadcaixacontacorrente_id','goldnotas','Cadcaixacontacorrente','id','pessoa');  
        $valorpgto->setNumericMask(2, ',', '.', true);  
        
        $cadformapgto_id->setSize('100%');
        $cadcaixacontacorrente_id->setSize('100%'); 
        
        //itens dos produtos
        $additem = new TButton('additem');
        $additem_action = new TAction([$this, 'onFormaPgto']);
        $additem->setAction($additem_action, 'Adcionar');
        $additem->setImage('bs:plus-sign green');                 

        $additem->style = 'font-size:16px;width:100%;height:30px;padding:0px;color:#FF4000;background-color: #F5F6CE;';                   

        $totalreceber = new TEntry('totalreceber');
        $totalrecebido = new TEntry('totalrecebido');
        $totalrestante = new TEntry('totalrestante');
        
        $totalreceber->setEditable(False);
        $totalrecebido->setEditable(False);
        $totalrestante->setEditable(False);
        $totalreceber->setNumericMask(2, ',', '.', true);
        $totalrecebido->setNumericMask(2, ',', '.', true);
        //$totalrestante->setNumericMask(2, ',', '.', true);
        $totalrestante->style = 'text-align:right';                           
                                
        $row = $this->form->addFields([],
                                      [new TLabel('Valor'),$valorpgto],
                                      [new TLabel('Forma Pagamento'),$cadformapgto_id],
                                      [new TLabel('Caixa / Conta Corrente'),$cadcaixacontacorrente_id],
                                      [new TLabel(''),$additem]);
        $row->layout = ['col-sm-4',
                        'col-sm-1',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-1'];
                        
        /*                 
        $subform->addContent([$this->datagridformapgto]);
        
        $this->form->addContent([TPanelGroup::pack('Parcelas', $this->datagridparcs)] ,
                                [TPanelGroup::pack('Pagamentos', $subform)] )->layout= [ 'col-sm-4', 'col-sm-8'];        
        */         
        
        $this->form->addContent([TPanelGroup::pack('Parcelas', $this->datagridparcs)] ,
                                [TPanelGroup::pack('Pagamentos', $this->datagridformapgto)] )->layout= [ 'col-sm-4', 'col-sm-6'];
           
        $row = $this->form->addFields([],
                                      [new TLabel('Total Receber'),$totalreceber],
                                      [new TLabel('Informado'),$totalrecebido],
                                      [new TLabel('Restante/Troco'),$totalrestante]);
        $row->layout = ['col-sm-4',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2'];                                              
         
                                
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'fa:save');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addAction('Voltar',  new TAction([$this, 'onCancel']), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));        
        $container->add($this->form);
        //$container->add($hbox);        
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            
            /*
            $win = TWindow::create('test', 0.6, 0.8);
            $win->add( '<pre>'.str_replace("\n", '<br>', print_r($param, true) ).'</pre>'  );
            $win->show();            
            */
            //TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
           // echo '<pre>'.str_replace("\n", '<br>', print_r($param, true) ).'</pre>' . '<br \>';
            $cadformapgtolist = $param['cadformapgto_id'];
            $cadcaixacontacorrentelist = $param['cadcaixacontacorrente_id'];
            $valorpgtolist = $param['valorpgto'];
             
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            /*
            $object = new Movimento;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            */
            $this->form->setData($data); // fill form data
            
            //$formapgtolist = array_merge($cadformapgto_id,$cadcaixacontacorrente_id,$valorpgto);
            
            //echo var_dump($formapgtolist) . '<br \>';
            /*
            echo '<pre>'.str_replace("\n", '<br>', var_dump($cadformapgtolist) ).'</pre>' . '<br \>';
            echo '<pre>'.str_replace("\n", '<br>', var_dump($cadcaixacontacorrentelist) ).'</pre>' . '<br \>';
            echo '<pre>'.str_replace("\n", '<br>', var_dump($valorpgtolist) ).'</pre>' . '<br \>';
            $listcount = 0;
            $listcount = count($cadformapgtolist);
            
            TFieldList::clear('formapgtolist');
            
            //TFieldList::addRows('formapgtolist', $listcount);            
            //$this->formapgto_list->addHeader();
            $vai = False;
            $index = 0;
            while (!$vai ==  true)
            {
                $data = new stdClass;
                $data->cadformapgto_id = $cadformapgtolist[$index];
                $data->cadcaixacontacorrente_id = $cadcaixacontacorrentelist[$index];
                $data->valorpgto = $valorpgtolist[$index];
                $this->formapgto_list->addDetail($data);
                $index++; 
                if ($listcount == $index){
                    $vai = true;                             
                }
                echo 'Linha ' . $index . '<br \>'; 
            }
            */
            //$this->formapgto_list->addCloneAction();
            
            /*
            $data = new stdClass;
            $data->cadformapgto_id = [$cadformapgto_list];
            $data->cadcaixacontacorrente_id = [$cadcaixacontacorrente_list];
            $data->valorpgto = [$valorpgto_list ];            
            TForm::sendData('form_Movimentofecha', $data, false, true, 200);            
            */
            /*
            TTransaction::close(); // close the transaction
            
            new TMessage('info', AdiantiCoreTranslator::translate('Record saved'));
            */
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Load the datagrid with data
     */
    public function onReload( $param = null)
    {
        try
        {                                                  
            if (isset($param))
            {
                $movimento = TSession::getValue('movimento_'.$param['idmovimento']);                
                $data = (object) $movimento;                                    
                $this->form->clear(TRUE);           
                //$this->form->setData($data);                
                $param['movimentoformapgto_loaded'] = $data->movimentoformapgto_loaded;
                $param['movimentoformapgto_count'] = $data->movimentoformapgto_count;
                $param['movimentoformapgto'] = $data->movimentoformapgto;  
                            
            }     
            else
            {
                $data = $this->form->getData();
                $param = array();
                $param['idmovimento'] = $data->idmovimento;
                $param['movimentoformapgto_loaded'] = $data->movimentoformapgto_loaded;
                $param['movimentoformapgto_count'] = $data->movimentoformapgto_count;
                $param['movimentoformapgto'] = $data->movimentoformapgto;
                               
            }
            //echo 'Total Receber 1 ' . $data->totalreceber . '<br \>';
            $totalreceber   = $data->totalreceber;
            $totalrecebido  = 0;
            $totalrestante  = 0; 
            //$valorpago      = 0;      
            
            if (!empty(TSession::getValue('movimentoparc_'.$param['idmovimento'])))            
            {             
                $movimentoparclist = TSession::getValue('movimentoparc_'.$param['idmovimento']);
                foreach ($movimentoparclist as $movimentoparc_id => $movimentoparc)
                {                    
                    
                    $item = new StdClass;                   
                    $item->key = $movimentoparc['key'];                                   
                    $item->parcela  = $movimentoparc['parcela'];
                    $item->valor  = number_format($movimentoparc['valor'], 2, ',', '.');
                    $item->valororiginal  = $movimentoparc['valororiginal'];
                    $item->vencimento  = $movimentoparc['vencimento']; 
                    $item->vencimentooriginal  = $movimentoparc['vencimentooriginal'];                                     
                    $this->datagridparcs->addItem($item);                                    
                }  
            }                
            
            //echo var_dump($data) . '<br \>';
            if (!empty(TSession::getValue($param['movimentoformapgto_loaded'])))            
            {                    
                //echo var_dump($data) . '<br \>';
                //$data = $this->form->getData(); // get formitem data as array                                   
                $formapgtolist = TSession::getValue($param['movimentoformapgto']);                         
                $this->datagridformapgto->clear();                            
                if ($formapgtolist)
                {                                                                                                     
                    foreach ($formapgtolist as $formapgto_id => $formapgto)
                    {   // add the object inside the datagrid
                        if ($formapgto['del'] == 'N')
                        {
                            $item = new StdClass;                   
                            $item->key = $formapgto['key'];  
                            $item->item = $formapgto['item']; 
                            $item->formapgto = $formapgto['descricao'];   
                            $item->idmovimento = $formapgto['idmovimento'];
                            $item->caixacontacorrente = $formapgto['caixacontacorrente'];
                            $item->valor = number_format($formapgto['valor'], 2, ',', '.');//$formapgto['valor'];                            
                            $this->datagridformapgto->addItem($item); 
                            //$valorpago = number_format($formapgto['valor'], 2, ',', '.');
                                                       
                            $totalrecebido = $totalrecebido + $formapgto['valor'];
                            //echo 'Total Recebido ' . $totalrecebido . '<br \>';   
                            //echo 'Forma Pgto ' . $formapgto['valor'] . '<br \>';                           
                        }                        
                    }                
                }   
                //$totalrecebido = number_format($totalrecebido, 2, ',', '.');
                
                //echo 'Total Receber 2 ' . $totalreceber . '<br \>';
                //echo 'Total Recebido ' . $totalrecebido . '<br \>';                               
                $totalrestante = $totalreceber - $totalrecebido;
                $totalrestante = number_format($totalrestante, 2, ',', '.');
                //number_format($value, 2, ',', '.');
                //echo 'Total Restante/Troco ' . $totalrestante . '<br \>';  
                       
                $data->totalreceber = $totalreceber;
                $data->totalrecebido = $totalrecebido;
                $data->totalrestante = $totalrestante;
                $data->valorpgto = '';
                $data->cadformapgto_id = '';
                $data->cadcaixacontacorrente_id = '';
                
                $movimento = (array) $data;
                TSession::setValue('movimento_'.$data->idmovimento, $movimento);
                $this->form->setData($data);
                /*
                $obj = new stdClass;
                $obj->totalreceber = $totalreceber;
                $obj->totalrecebido = $totalrecebido;
                $obj->totalrestante = $totalrestante;   
                TForm::sendData('form_Movimentofecha',$obj); 
                */            
                //echo var_dump($data) . '<br \>';    
                //echo var_dump($movimento) . '<br \>';         
                TScript::create('setTimeout(function() { $("input[name=\'valor\']").focus() }, 500);');              
            }          
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep formitem data
        }
    }    
    
    public function onFormaPgto($param)
    {
        try
        {
            $data = $this->form->getData();
            //echo 'Data = ' . print_r($data) . '<br \>';
            //echo 'Param = ' . var_dump($param) . '<br \>';          
            
            if ($param['valorpgto'] <= 0)
            {             
                $this->form->setData( $data );
                $this->onReload();               
                throw new Exception('Quantidade não informitemada!');
            } 
            if ($param['cadformapgto_id'] == '')
            {             
                $this->form->setData( $data );
                $this->onReload();               
                throw new Exception('Forma de Pagamento não informada!');
            }              
            TTransaction::open('goldnotas');            
            $formapgto = new Cadformapgto($param['cadformapgto_id']);
            $caixacontacorrente_id = '';
            $caixacontacorrente    = '';
            
            if (!$formapgto->tipo == '01')
            {
                $caixacontacorrente_id = '';
                $caixacontacorrente    = '';                
            }
            else
            {
                if ($formapgto->tipo == '01')
                {
                    //echo 'Forma Pgto: ' . $formapgto->tipo . '<br \>';
                    if ($param['cadcaixacontacorrente_id'] == '')
                    {
                        $this->form->setData( $data );
                        $this->onReload();               
                        throw new Exception('Caixa / Conta Corrente não informado!');                        
                    }
                    $cadcaixacontacorrente = new Cadcaixacontacorrente($param['cadcaixacontacorrente_id']);
                    $caixacontacorrente_id = $param['cadcaixacontacorrente_id'];
                    $caixacontacorrente    = $cadcaixacontacorrente->pessoa;  
                    //echo 'Caixa / Conta Corrente: ' . $param['cadcaixacontacorrente_id'] . ' = ' . $caixacontacorrente . '<br \>';                  
                } 
            }
            TTransaction::close();
            $param['caixacontacorrente_id'] = $caixacontacorrente_id;
            $param['caixacontacorrente']    = $caixacontacorrente;
            //MovimentoChequeForm
            if ($formapgto->tipo == '02')
            {
                $this->form->setData( $data );
                $this->onReload();                
                TApplication::loadPage('MovimentoChequeForm','onEdit');                    
            }            
            else{ 
                $this->onFormaPgtoAdd($param);
            }                
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback();
        }        
    }     
    
    public function onFormaPgtoAdd($param)
    {
        try
        {
            TTransaction::open('goldnotas');            
            $formapgto = new Cadformapgto($param['cadformapgto_id']);

            $caixacontacorrente_id = $param['caixacontacorrente_id'];
            $caixacontacorrente    = $param['caixacontacorrente'];
            
            $idmovimento = $param['idmovimento'];
            $movimentoformapgto = TSession::getValue($param['movimentoformapgto']);  
            $idmovimento = $param['idmovimento'];

            //number_format($value, 2, ',', '.');                
            $formapgto_count = TSession::getValue($param['movimentoformapgto_count']);
            $formapgto_count++;                                                                  
            $movimentoformapgto[$formapgto_count] = array(
                                                        'key' => $formapgto_count,
                                                        'item' => $formapgto_count,
                                                        'cadformapgto_id' => $param['cadformapgto_id'],                                                                                                       
                                                        'descricao' => $formapgto->descricao,
                                                        'valor' => PMaskFormate::reais_to_decimal($param['valorpgto']),
                                                        'tipo' => $formapgto->tipo,
                                                        'tipocartao' => $formapgto->tipocartao,  
                                                        'adm_cartao_cadpessoa_id' => $formapgto->adm_catao_cadpessoa_id,
                                                        'dias_vencimento' => $formapgto->dias_vencimento,
                                                        'taxaadm' => $formapgto->taxaadm,
                                                        'cadcentrocusto_id' => $formapgto->cadcentrocusto_id,
                                                        'cadplanoconta_id' => $formapgto->cadplanoconta_id,
                                                        'cadcaixacontacorrente_id'=> $caixacontacorrente_id,
                                                        'caixacontacorrente'=> $caixacontacorrente,
                                                        'idmovimento' => $formapgto_count . '_' . $idmovimento,                                                                                                           
                                                        'del' => 'N');
            //HDebug::debug($movimentoitem,'Salvar Movimento Item');     
            TTransaction::close();
            TSession::setValue($param['movimentoformapgto_count'], $formapgto_count);                    
            TSession::setValue($param['movimentoformapgto_loaded'], true);
            TSession::setValue($param['movimentoformapgto'], $movimentoformapgto);            
            $this->onReload(); 
                                  
                          
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback();
        }        
    }    
    
    public function onFormaPgtoDel($param)
    {
        try
        {

            $key=$param['idmovimento']; // get the parameter $key           
            $pos = strpos($key,'_');
            $tam = strlen($key);
            $id = substr($key, 0, $pos);
            $idmovimento = substr($key, $pos + 1, $tam - $pos);
            $param['idmovimento']          = $idmovimento;
            $param['movimentoformapgto']        = 'movimentoformapgto_'.$idmovimento;
            $param['movimentoformapgto_loaded'] = 'movimentoformapgto_loaded'.'_'.$idmovimento;
            $param['movimentoformapgto_count']  = 'movimentoformapgto_count'.'_'.$idmovimento;                      
            //echo var_dump($param);
            echo 'Del = ' . $param['movimentoformapgto'] . '<br \>';
            $movimentoformapgto = TSession::getValue($param['movimentoformapgto']);
            $movimentoformapgto[$id]['del'] = 'S';   
            //var_dump($movimentoitem);
            TSession::setValue($param['movimentoformapgto'], $movimentoformapgto);         
            $this->onReload($param);
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }    
        
    public function onCancel($param)
    {
        try
        {            
            AdiantiCoreApplication::loadPage('MovimentoForm', 'onEdit', ['register_state'=>'false','movimento' => $param]);            
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
        }        
    }
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {            

            $movimento = $param['movimento'];
            $data = (object) $movimento;                                    
            //$this->form->clear(TRUE);              
            
            //echo var_dump($data) . '<br \>';         
            //$this->form->setData($data);
            $movimento = (array) $data;
            $this->onGeraParcs($movimento);
            //echo 'onGeraParcs' . '<br \>';
            $this->onReload($movimento);
            //echo 'onReload' . '<br \>';
            //$movimento = TSession::getValue('movimento_'.$param['idmovimento']);
            $movimento = TSession::getValue('movimento_'.$param['idmovimento']); 
            $data = (object) $movimento;
            //echo var_dump($movimento) . '<br \>'; 
            $this->form->setData($data);                          
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }  
    public function onGeraParcs($param = null)
    {
        try
        {            
            
            TTransaction::open('goldnotas');
            $data = (object) $param;
            //$movimento = TSession::getValue('movimento_'.$param['idmovimento']);
            //echo var_dump($param) . '<br \>';
            $cadcondpgto  = new Cadcondpgto($data->cadcondpgto_id);
            $dataemissao  = $data->dataemissao;
            $totalnota    = $data->totalgeral;
            $idmovimento  = strval($data->idmovimento);
            $diasprim     = $cadcondpgto->dias_primparc;
            $diasparc     = $cadcondpgto->dias_entreparc;
            $qtdeparcs    = $cadcondpgto->qtd_parcs;  
            $percentrada  = $cadcondpgto->perc_entrada;
            $qtde         = $qtdeparcs;
            $valorprazo   = 0;            
            $total        = 0;
            $prestacao    = 1;
            $diferenca    = 0;
            
            if (($percentrada > 0) and ($qtdeparcs > 1)) 
            { //calcula entrada
              $valorentrada = round($totalnota * ($percentrada / 100),2);
              $valorprazo   = $totalnota - $valorentrada;
              $qtdeparcs    = $qtdeparcs - 1;
            }
            elseif (($percentrada > 0) and ($qtdeparcs = 1))
            { //forca a vista
              $valorentrada = $totalnota;
              $valorparcela = $totalnota;
              $valorprazo   = 0;
              $qtdeparcs    = 0;
            }
            else
            {
              $valorprazo   = $totalnota;
              $valorentrada = 0;
            }
        
            if (($valorprazo > 0) and ($qtdeparcs = 1))
            {
              $valorparcela = $valorprazo;
              $totalprazo   = $valorprazo;
              $totalpgto    = $valorprazo;
              $diferenca    = 0;
            }
            elseif (($valorprazo > 0) and ($qtdeparcs > 1))
            {
              $valorparcela = Round($valorprazo / $qtdeparcs, 2);
              $totalprazo   = Round($qtdeparcs * $valorparcela, 2);
              $totalpgto    = Round($totalprazo + $valorentrada, 2);
              $diferenca    = Round($totalnota - $totalpgto, 2);
            } 
            $movimentoparclist = TSession::delValue('movimentoparc_'.$idmovimento);
            $movimentoparc_count = 0;
            while (!$qtde == 0)
            {
                
                if (($prestacao = 1) and ($percentrada = 0)){
                    $vencimento = date('d/m/Y', strtotime('+'.$diasprim.' days', strtotime($dataemissao)));
                }
                
                elseif (($prestacao = 1) and ($percentrada > 0)){
                    $vencimento = $dataemissao;
                }  
                else { 
                    $vencimento = date('d/m/Y', strtotime('+'.$diasparc.' days', strtotime($dataemissao)));
                }            
                if (($prestacao = $qtde) and ($qtdeparcs > 1)){
                    $valor = $valorparcela + $diferenca;
                }    
                elseif (($prestacao = 1) and ($percentrada > 0)){
                    $valor = $valorentrada;
                }
                else {                 
                    $valor = $valorparcela;
                }    
                $movimentoparc_count++;               
                $movimentoparclist[$movimentoparc_count] = array(
                                          'key' => $movimentoparc_count,
                                          'parcela' => $prestacao,
                                          'vencimento' => $vencimento,                                                  
                                          'valor' => $valor,
                                          'vencimentooriginal' => $vencimento,                                                  
                                          'valororiginal' => $valor);                               
                               
                $prestacao++;
                $qtde = $qtde - 1;
            }
            if ($diferenca > 0)
            {
                $valor = $movimentoparc[$movimentoparc_count]['valor'];
                $valor = $valor + $diferenca;
                $movimentoparc[$movimentoparc_count]['valor'] = $valor;
                $movimentoparc[$movimentoparc_count]['valororiginal'] = $valor;
                     
            }
            //$movimentoitem[$id]['del'] = 'S';
            /*
            foreach ($movimentoparclist as $movimentoparc_id => $movimentoparc)
            {
                
                $item = new StdClass;                   
                $item->key = $movimentoparc['key'];                                   
                $item->parcela  = $movimentoparc['parcela'];
                $item->valor  = $movimentoparc['valor'];
                $item->valororiginal  = $movimentoparc['valororiginal'];
                $item->vencimento  = $movimentoparc['vencimento']; 
                $item->vencimentooriginal  = $movimentoparc['vencimentooriginal'];                                     
                $this->datagridparcs->addItem($item);                
                
            }  
            */
            
            $data->totalreceber  = $valorentrada;
            $data->totalrecebido = 0;
            $data->totalrestante = $valorentrada;  
            $movimento = (array) $data;          
            TSession::setValue('movimento_'.strval($idmovimento), $movimento);
            
            TSession::setValue('movimentoparc_'.strval($idmovimento), $movimentoparclist);            
            TTransaction::close();
                                       
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback();
        }        
    }               
}

