<?php
/**
 * MovimentoForm Form
 * @author  <your name here>
 */
class MovimentoForm extends TPage
{
    protected $form; // form
    private $datagrid; // listing 
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        parent::include_js('app/lib/include/app_sctipt_tabenter.js');
        TScript::create('setTimeout(function() { $("input[name=\'cadtipooperacao_id\']").focus() }, 500);'); 
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Movimento');
        $this->form->setFormTitle('Vendas / Saídas');
        $this->form->setFieldSizes('100%');

        $movimentoid = $param['movimentoid']??'';
        //echo 'MovimentoForm movimentoid = ' . $movimentoid . '<br \>';
        if (empty($movimentoid))
        {
            $userid = TSession::getValue('userid');
            $movimentoid = $userid . mt_rand() . $userid;                   
        }
        else
        {
            echo 'id: ' . $movimentoid . '<br \>';
        }

        // create the form fields
        $idmovimento = new THidden('idmovimento');
        $movimentoitem = new THidden('movimentoitem');
        $movimentoitem_loaded = new THidden('movimentoitem_loaded');
        $movimentoitem_count = new THidden('movimentoitem_count');
        $tipooperacao = new THidden('tipooperacao');           
        $movimentoformapgto_loaded = new THidden('movimentoformapgto_loaded');
        $movimentoformapgto_count = new THidden('movimentoformapgto_count');
        $movimentoformapgto = new THidden('movimentoformapgto');           
        $totalreceber = new THidden('totalreceber');
        $totalrecebido = new THidden('totalrecebido');
        $totalrestante = new THidden('totalrestante');        
        
                   
        
        $id = new THidden('id');
        $cadempresa_id = new THidden('cadempresa_id');
        $cadalmoxarifado_id = new THidden('cadalmoxarifado_id');
        $cadtipooperacao_id = new TDBCombo('cadtipooperacao_id', 'goldnotas', 'Cadtipooperacao', 'id', 'descricao');
        $cadcondpgto_id = new TDBCombo('cadcondpgto_id', 'goldnotas', 'Cadcondpgto', 'id', 'descricao');
        
        $filtro = new TCriteria;                     
        $filtro->add(new TFilter('evendedor', '=', "S"), TExpression::OR_OPERATOR);
        
        $vendedor_cadpessoa_id = new TDBCombo('vendedor_cadpessoa_id', 'goldnotas', 'Cadpessoa', 'id', 'pessoa', null, $filtro);
        $numero = new TEntry('numero');
        $serie = new TEntry('serie');
        $dataemissao = new TDate('dataemissao');
        $dataentrada = new TDate('dataentrada');
        $cadnaturezaoperacao_id = new TDBCombo('cadnaturezaoperacao_id', 'goldnotas', 'Cadnaturezaoperacao', 'id', '{id_natureza} - {natureza}');
        
        
        $cadtipooperacao_id->addValidation('Tipo de Operação', new TRequiredValidator );
        $cadtipooperacao_id->setChangeAction( new TAction( array($this, 'onChangetipooperacao')) );        
        
        
        $filtro = new TCriteria;                     
        $filtro->add(new TFilter('ecliente', '=', "S"), TExpression::OR_OPERATOR);
        $filtro->add(new TFilter('efornecedor', '=', "S"), TExpression::OR_OPERATOR); 
        
        $cadpessoa_id = new TDBCombo('cadpessoa_id', 'goldnotas', 'Cadpessoa', 'id', 'pessoa', null, $filtro);
        $subtotalgeral = new TEntry('subtotalgeral');
        $totalgeral = new TEntry('totalgeral');
        $itens = new TEntry('itens');
        $itens->style = 'text-align: center';
        $descontogeral = new TEntry('descontogeral');
        $margem_descontogeral = new TEntry('margem_descontogeral');

        $obs = new TText('obs');
        $nomeconsumidor = new TEntry('nomeconsumidor');
        $cpfcnpjconsumidor = new TEntry('cpfcnpjconsumidor');
        $total_produtos = new TEntry('total_produtos');
        $total_servicos = new TEntry('total_servicos');
        
        $itens->setEditable(False);
        $subtotalgeral->setEditable(False);
        $total_produtos->setEditable(False);
        $total_servicos->setEditable(False);
        $totalgeral->setEditable(False);        
        
        $subtotalgeral->setNumericMask(2, ',', '.', true);
        $total_produtos->setNumericMask(2, ',', '.', true);
        $total_servicos->setNumericMask(2, ',', '.', true);
        $descontogeral->setNumericMask(2, ',', '.', true);
        $totalgeral->setNumericMask(2, ',', '.', true);
        
        $descontogeral->setEditable(False);
        $margem_descontogeral->setEditable(False);
        
        
        $dataemissao->setMask('dd/mm/yyyy');
        $dataemissao->setDatabaseMask('yyyy-mm-dd');
        
        $dataentrada->setMask('dd/mm/yyyy');
        $dataentrada->setDatabaseMask('yyyy-mm-dd'); 
        
        // set sizes
        $id->setSize('100%');
        $cadempresa_id->setSize('100%');
        $cadalmoxarifado_id->setSize('100%');
        $cadtipooperacao_id->setSize('100%');
        $cadcondpgto_id->setSize('100%');
        $numero->setSize('100%');
        $serie->setSize('100%');
        $dataemissao->setSize('100%');
        $dataentrada->setSize('100%');
        $cadnaturezaoperacao_id->setSize('100%');
        $cadpessoa_id->setSize('100%');
        $subtotalgeral->setSize('100%');
        $totalgeral->setSize('100%');

        $obs->setSize('100%');
        $nomeconsumidor->setSize('100%');
        $cpfcnpjconsumidor->setSize('100%');
        $total_produtos->setSize('100%');
        $total_servicos->setSize('100%');
        /*
        $desconto_produtos->setSize('100%');
        $desconto_servicos->setSize('100%');
        $margem_desconto_produtos->setSize('100%');
        $margem_desconto_servicos->setSize('100%');
        */
        $vendedor_cadpessoa_id->setSize('100%');



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }        
        
        //create 
        //fields itens             
        
        $cadproduto_id = new TSeekButton('cadproduto_id');
        
        $obj = new PesquisaProdutosMovimento;
        $action = new TAction(array($obj, 'onReload'));
        $cadproduto_id->setAction($action);
        $onExitcadproduto_id = new TAction(array($this, 'onExitCadproduto_id'));  
        $cadproduto_id->setExitAction($onExitcadproduto_id);               
        
        $produto = new TEntry('produto');
        $produtoservico = new THidden('produtoservico');
        $descontomaximo = new THidden('descontomaximo');        
        $unidade = new TEntry('unidade');
        $qtde = new TEntry('qtde');
        $unitario = new TEntry('unitario');
        $subtotal = new TEntry('subtotal');
        $desconto = new TEntry('desconto');
        $margem_desconto = new TEntry('margem_desconto');
        $total = new TEntry('total');
        
        //$totalgeral 
        
        //variaveis de sessao unica
        $idmovimento->setValue($movimentoid);
        $movimentoitem->setValue('movimentoitem'.'_'.$movimentoid);
        $movimentoitem_loaded->setValue('movimentoitem_loaded'.'_'.$movimentoid);
        $movimentoitem_count->setValue('movimentoitem_count'.'_'.$movimentoid);
        $tipooperacao->setValue('tipooperacao'.'_'.$movimentoid);    
        
        $movimentoformapgto->setValue('movimentoformapgto'.'_'.$movimentoid);
        $movimentoformapgto_loaded->setValue('movimentoformapgto_loaded'.'_'.$movimentoid);
        $movimentoformapgto_count->setValue('movimentoformapgto_count'.'_'.$movimentoid);                              
        
        $onExitqtde = new TAction(array($this, 'onExitQtde'));  
        $qtde->setExitAction($onExitqtde);       
        
        $onExitDesconto = new TAction(array($this, 'onExitDesconto'));
        $desconto->setExitAction($onExitDesconto);
        
        $onExitMargemDesconto = new TAction(array($this, 'onExitMargemDesconto'));
        $margem_desconto->setExitAction($onExitMargemDesconto);
        
        $cadproduto_id->setSize('100%');
        $produto->setSize('100%');
        $produto->setEditable(False);
        $unidade->setSize('100%');

        $qtde->setNumericMask(2, ',', '.', true);
        $unitario->setNumericMask(2, ',', '.', true);
        $subtotal->setNumericMask(2, ',', '.', true);
        $total->setNumericMask(2, ',', '.', true);
        $desconto->setNumericMask(2, ',', '.', true);
        $margem_desconto->setNumericMask(2, ',', '.', true);
        
        $qtde->setSize('100%');
        $unitario->setSize('100%');
        $subtotal->setSize('100%');
        $margem_desconto->setSize('100%');
        $desconto->setSize('100%');
        $total->setSize('100%');
        
        $unidade->setEditable(False);
        $subtotal->setEditable(False);
        $total->setEditable(False);
        
        /*
        $subtotal->addValidation('SubTotal Inválido', new TMinValueValidator, array(0.1));
        $qtde->addValidation('Quantidade Inválida', new TMinValueValidator, array(0.1));
        $unitario->addValidation('Valor unitário Inválido', new TMinValueValidator, array(0.1));      
        */

        // add the fields
        $row = $this->form->addFields( [ new TLabel('Tipo de Operação') , $cadtipooperacao_id ] ,
                                       [ new TLabel('Número') , $numero ],
                                       [ new TLabel('Série') , $serie ],
                                       [ new TLabel('Dt. Emissão') , $dataemissao ],
                                       [ new TLabel('Dt. Entrada') , $dataentrada ]);
        $row->layout = ['col-sm-4','col-sm-1','col-sm-1','col-sm-2','col-sm-2'];  
        $row = $this->form->addFields( [ new TLabel('Pessoa') , $cadpessoa_id ],
                                       [ new TLabel('Vendedor') , $vendedor_cadpessoa_id ],        
                                       [ new TLabel('Condição de Pagamento') , $cadcondpgto_id ] );
        $row->layout = ['col-sm-4','col-sm-3','col-sm-3'];        
                                                             
        $this->form->addFields( [$id ], 
                                [$cadempresa_id ],
                                [$cadalmoxarifado_id],  
                                [$idmovimento],
                                [$movimentoitem],
                                [$movimentoitem_count],
                                [$movimentoitem_loaded],
                                [$tipooperacao],
                                [$movimentoformapgto],
                                [$movimentoformapgto_count],
                                [$movimentoformapgto_loaded]);
                                
        $this->form->addFields( [$totalreceber],
                                [$totalrecebido],
                                [$totalrestante]);                                 
                                
                                

        //itens dos produtos
        $additem = new TButton('additem');
        $additem_action = new TAction(array($this, 'onMovimentoAdd'));
        $additem->setAction($additem_action, 'Adcionar');
        $additem->setImage('bs:plus-sign green');                 

        $additem->style = 'font-size:16px;width:100%;height:30px;padding:0px;color:#FF4000;background-color: #F5F6CE;';               
        $this->form->addFields([$produtoservico],
                               [$descontomaximo]);
        $cadproduto_id->setSize('100%');        
        $row = $this->form->addFields([new TLabel('Produto'),$cadproduto_id], //[new TLabel(''), $buscaproduto], 
                                      [new TLabel('Descrição'), $produto],
                                      [new TLabel('Unidade'),$unidade]);
        $row->layout = ['col-sm-2','col-sm-9','col-sm-1'];                                      
                                        
        $row = $this->form->addFields([new TLabel('Qtde.') , $qtde],
                                      [new TLabel('Unitário') , $unitario],
                                      [new TLabel('Subtotal'), $subtotal],
                                      [new TLabel('Desc. %'), $margem_desconto],
                                      [new TLabel('Desconto R$'), $desconto],
                                      [new TLabel('Total'), $total],
                                      [new TLabel('<br>','#21610B'),$additem]); 
        $row->layout = ['col-sm-1','col-sm-2','col-sm-2','col-sm-1','col-sm-2','col-sm-2','col-sm-2'];  
        
        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        // make scrollable and define height
        $this->datagrid->setHeight(200);
        $this->datagrid->makeScrollable();        

        // creates the datagrid columns
        $column_item          = new TDataGridColumn('item',          'Item',     'center', '5%');        
        $column_cadproduto_id = new TDataGridColumn('cadproduto_id', 'Código',   'center', '5%');
        $column_produto       = new TDataGridColumn('produto',       'Produto',  'left',  '30%');
        $column_unidade       = new TDataGridColumn('unidade',       'Und.',     'center','5%');
        $column_qtde          = new TDataGridColumn('qtde',          'Qtde.',    'right','15%');
        $column_unitario      = new TDataGridColumn('unitario',      'Unitário', 'right','10%');
        $column_subtotal      = new TDataGridColumn('subtotal',      'Subtotal', 'right', '10%');        
        $column_desconto      = new TDataGridColumn('desconto',      'Desconto', 'right', '10%');
        $column_total         = new TDataGridColumn('total',         'Total',    'right', '10%');
                        
        
        
        //movimentoitem
        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_item);
        $this->datagrid->addColumn($column_cadproduto_id);
        $this->datagrid->addColumn($column_produto);
        $this->datagrid->addColumn($column_unidade);
        $this->datagrid->addColumn($column_qtde);
        $this->datagrid->addColumn($column_unitario);
        $this->datagrid->addColumn($column_subtotal);
        $this->datagrid->addColumn($column_desconto);
        $this->datagrid->addColumn($column_total);               

        $format_value = function($value) {
            if (is_numeric($value)) {
                //return 'R$ '.number_format($value, 2, ',', '.');
                return number_format($value, 2, ',', '.');
            }
            return $value;
        };
        
        $column_qtde->setTransformer($format_value);
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onMovimentoDel'));
        $action_del->setLabel(_t('Delete'));
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('idmovimento');
        $this->datagrid->addAction($action_del);
                            
        // create the datagrid model
        $this->datagrid->createModel();        
        /*
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->add(TPanelGroup::pack('', $this->datagrid));      
        */  
                                       
        $this->form->addContent([TPanelGroup::pack('', $this->datagrid)]);

        // Rodape da nota

        
        $row = $this->form->addFields( [],
                                       [ new TLabel('Itens') , $itens ],
                                       [ new TLabel('Total Produtos') , $total_produtos ],
                                       [ new TLabel('Total Servicos') , $total_servicos ],                                    
                                       [ new TLabel('Subtotal') ,  $subtotalgeral ],
                                       [ new TLabel('Desconto') ,  $descontogeral ],        
                                       [ new TLabel('Total') , $totalgeral ] );
        $row->layout = ['col-sm-1',
                        'col-sm-1',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2'];

        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        //$this->form->addContent( [$subform] ); 
        
               
         
        // create the form actions
        $btn = $this->form->addAction('Fechar', new TAction([$this, 'onSave']), 'fa:save');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addActionLink('Cancelar',  new TAction([$this, 'onEdit']), 'fa:eraser red');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array            //'movimento' => 
            AdiantiCoreApplication::loadPage('MovimentoFechaForm', 'onEdit', ['register_state'=>'false','idmovimento' => $data->idmovimento,'movimento' => $data]);
            /*
            $object = new Movimento;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            */
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            //new TMessage('info', AdiantiCoreTranslator::translate('Record saved'));
            
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {     
        try
        {         
            if (isset($param['key']))
            {
            
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Movimento($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            elseif (isset($param['movimento']))
            {
              
                $movimento = $param['movimento'];
                //echo var_dump($movimento) . '<br \>';              
                $obj = (object) $movimento;                                    
                $this->form->clear(TRUE);           
                $this->form->setData($obj);
                $this->onChangetipooperacao($movimento);
                //$this->onMostraTelaItem(tipooperacao);
                $idmovimento = $obj->idmovimento;
                TSession::setValue('movimento_'.$idmovimento, $movimento);                  
                $param['movimentoitem']        = 'movimentoitem_'.$idmovimento;
                $param['movimentoitem_loaded'] = 'movimentoitem_loaded'.'_'.$idmovimento;
                $param['movimentoitem_count']  = 'movimentoitem_count'.'_'.$idmovimento;
                $param['tipooperacao']  = 'tipooperacao'.'_'.$idmovimento;                  
                //reload             
                $this->onReload(['idmovimento' => $idmovimento]);                                
                                
            }
            else
            {
            
                $this->form->clear(TRUE);
                $obj = new StdClass;             
                $obj->dataemissao = TDate::date2br(date("Y-m-d"));
                $obj->dataentrada = TDate::date2br(date("Y-m-d"));
                TForm::sendData('form_Movimento', $obj);                                
            
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
   
    }  

    public function onMostraTelaItem($param)
    {
        //echo var_dump($param) . 'Id Sessao' . '<br \>';
        $tipooperacao = TSession::getValue($param['tipooperacao']);
        //echo var_dump($tipooperacao) . '<br \>';
        
        if ($tipooperacao)
        {
            
            //foreach ($tipooperacao as $tipooperacao_id => $tipooperacaoitem)
                        
            if ($tipooperacao['itemusadesconto'] == 'S'){
                TEntry::enableField('form_Movimento','desconto');
                TEntry::enableField('form_Movimento','margem_desconto');                                                
            } else {
                TEntry::disableField('form_Movimento','desconto');
                TEntry::disableField('form_Movimento','margem_desconto');                       
            }            
            if ($tipooperacao['itemeditavalor'] == 'S') {
                TEntry::enableField('form_Movimento','unitario');                                                    
            } else {
                TEntry::disableField('form_Movimento','unitario');                       
            }
            if ($tipooperacao['editadtemissao'] == 'S') {
                TDate::enableField('form_Movimento','editadtemissao');                                                
            }
            else {
                TDate::disableField('form_Movimento','editadtemissao');     
            }
            if ($tipooperacao['editanumeronota'] == 'S') {
                TEntry::enableField('form_Movimento','numero');                                                
                TEntry::enableField('form_Movimento','serie');
            }
            else {
                TEntry::disableField('form_Movimento','numero');
                TEntry::disableField('form_Movimento','serie');     
            }             
                        
            TDBCombo::disableField('form_Movimento','cadtipooperacao_id');          
          
        }
                
       
    } 
    
    /**
     * Load the datagrid with data
     */
    public function onReload( $param = null)
    {
        try
        {                                                  
            if (isset($param))
            {
                $movimento = TSession::getValue('movimento_'.$param['idmovimento']);                
                $data = (object) $movimento;                                    
                $this->form->clear(TRUE);           
                //$this->form->setData($data);                
                $param['movimentoitem_loaded'] = $data->movimentoitem_loaded;
                $param['movimentoitem_count'] = $data->movimentoitem_count;
                $param['movimentoitem'] = $data->movimentoitem;
                $param['tipooperacao'] = $data->tipooperacao;                
            }     
            else
            {
                $data = $this->form->getData();
                $param = array();
                $param['movimentoitem_loaded'] = $data->movimentoitem_loaded;
                $param['movimentoitem_count'] = $data->movimentoitem_count;
                $param['movimentoitem'] = $data->movimentoitem;
                $param['tipooperacao'] = $data->tipooperacao;                 
            }
            //echo var_dump($param) . '<br \>';
            $itens = 0 ;
            $totalprodutos = 0;
            $totalservicos = 0;
            $totaldesconto = 0;
            $totalliquido = 0;
            //echo var_dump($data) . '<br \>';
            //HDebug::debug(TSession::getValue($param['movimentoitem_loaded']),'Reload Movimento Item');
            if (!empty(TSession::getValue($param['movimentoitem_loaded'])))            
            {    
                //$data = $this->form->getData(); // get formitem data as array                                   
                $movimentoitemlist = TSession::getValue($param['movimentoitem']);                         
                $this->datagrid->clear();                            
                if ($movimentoitemlist)
                {                                                                 
                    //var_dump($movimentoitemlist);                 
                    TTransaction::open('goldnotas'); // open a transaction                
                    foreach ($movimentoitemlist as $movimentoitem_id => $movimentoitem)
                    {   // add the object inside the datagrid
                        if ($movimentoitem['del'] == 'N')
                        {
                            $item = new StdClass;                   
                            $item->key = $movimentoitem['key'];                                   
                            $item->item  = $movimentoitem['item'];
                            $item->cadproduto_id = $movimentoitem['cadproduto_id'];
                            $item->produto = $movimentoitem['produto'];            
                            $item->qtde = $movimentoitem['qtde'];
                            $item->unidade = $movimentoitem['unidade'];
                            $item->unitario = $movimentoitem['unitario'];
                            $item->subtotal = $movimentoitem['subtotal'];
                            $item->desconto = $movimentoitem['desconto'];
                            $item->margem_desconto = $movimentoitem['margem_desconto'];
                            $item->total = $movimentoitem['total'];
                            $item->idmovimento = $movimentoitem['idmovimento'];                                           
                            $this->datagrid->addItem($item);
                            $itens++;
                            if ($movimentoitem['produtoservico'] == 'P')
                            {
                                $totalprodutos = $totalprodutos + PMaskFormate::reais_to_decimal($movimentoitem['subtotal']); 
                            }
                            else
                            {
                                $totalservicos = $totalservicos + PMaskFormate::reais_to_decimal($movimentoitem['subtotal']);    
                            }
                            $totaldesconto = $totaldesconto + PMaskFormate::reais_to_decimal($movimentoitem['desconto']);
                            $totalliquido = $totalliquido + PMaskFormate::reais_to_decimal($movimentoitem['total']);
                        }                        
                    }
                    TTransaction::close();                    
                }   
                //$this->form->setData($data);                
                //limpa itens   
                //echo 'Total Geral ' . ($totalprodutos + $totalservicos) . '<br \>';             
                $data->cadproduto_id = '';
                $data->produto = '';
                $data->qtde = '';
                $data->unitario = 0;
                $data->subtotal = 0;
                $data->desconto = 0;
                $data->margem_desconto = 0;
                $data->total = 0;
                $data->unidade = '';                 
                //atualiza rodape da nota                
                $data->itens = $itens;
                $data->total_produtos =  number_format($totalprodutos, 2, ',', '.');
                $data->total_servicos = number_format($totalservicos, 2, ',', '.');
                $data->subtotalgeral = number_format($totalprodutos + $totalservicos, 2, ',', '.');
                $data->descontogeral = number_format($totaldesconto, 2, ',', '.');
                $data->totalgeral = number_format($totalliquido, 2, ',', '.');
                $movimento = (array) $data;
                TSession::setValue('movimento_'.$data->idmovimento, $movimento);
                $this->form->setData($data);
                $this->onMostraTelaItem(['tipooperacao' => $param['tipooperacao']]);               
                TScript::create('setTimeout(function() { $("input[name=\'cadproduto_id\']").focus() }, 500);');              
            }          
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep formitem data
        }
    }

    public function onMovimentoAdd($param)
    {               
        try
        {
            //echo var_dump($param) . '<br \>';
            $tipooperacao = TSession::getValue($param['tipooperacao']);                                                               
            if (!$tipooperacao)
            {
                throw new Exception('Tipo de Operação não informitemado!');     
            }             
            //echo var_dump($tipooperacao) . '<br \>';   
            //$this->form->validate();         
            $data = $this->form->getData();
            if ($data->qtde <= 0)
            {             
                $this->form->setData( $data);
                $this->onReload();               
                throw new Exception('Quantidade não informitemada!!');
            }
            
            
            //$this->form->validate();
            $idmovimento = $param['idmovimento'];
            $movimentoitem = TSession::getValue($param['movimentoitem']);  
            $idmovimento = $param['idmovimento'];
                              
            $movimentoitem_count = TSession::getValue($param['movimentoitem_count']);
            $movimentoitem_count++;            
            TSession::setValue($param['movimentoitem_count'], $movimentoitem_count);                                                      
            $movimentoitem[$movimentoitem_count] = array(
                                                        'key' => $movimentoitem_count,
                                                        'item' => $movimentoitem_count,
                                                        'cadproduto_id' => $param['cadproduto_id'],                                                                                                       
                                                        'produto' => $param['produto'],
                                                        'unidade' => $param['unidade'],
                                                        'qtde' => $param['qtde'],
                                                        'unitario' => $param['unitario'],
                                                        'subtotal' => $param['subtotal'],
                                                        'desconto' => $param['desconto'],
                                                        'margem_desconto' => $param['margem_desconto'],
                                                        'total' => $param['total'],  
                                                        'idmovimento' => $movimentoitem_count . '_' . $idmovimento, 
                                                        'produtoservico' => $param['produtoservico'],
                                                        'descontomaximo' => $param['descontomaximo'],                                                                                                              
                                                        'del' => 'N');
            //HDebug::debug($movimentoitem,'Salvar Movimento Item');     
            
            TSession::setValue($param['movimentoitem_count'], $movimentoitem_count);                    
            TSession::setValue($param['movimentoitem_loaded'], true);
            TSession::setValue($param['movimentoitem'], $movimentoitem);            
            $this->onReload();                       
        }
        catch (Exception $e)
        {
            $this->form->setData( $this->form->getData());
            $this->onReload();
            new TMessage('error', $e->getMessage());
        }                          
    }
    
    public function onMovimentoEdi($param)
    {               
        try 
        {                           
            $data = $this->form->getData();
            $key=$param['key'];                    
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }

    public function onMovimentoDel($param)
    {
        try
        {

            $key=$param['idmovimento']; // get the parameter $key           
            $pos = strpos($key,'_');
            $tam = strlen($key);
            $id = substr($key, 0, $pos);
            $idmovimento = substr($key, $pos + 1, $tam - $pos);
            $param['idmovimento']          = $idmovimento;
            $param['movimentoitem']        = 'movimentoitem_'.$idmovimento;
            $param['movimentoitem_loaded'] = 'movimentoitem_loaded'.'_'.$idmovimento;
            $param['movimentoitem_count']  = 'movimentoitem_count'.'_'.$idmovimento;
            $param['tipooperacao']  = 'tipooperacao'.'_'.$idmovimento;            
            //echo var_dump($param);
            //echo 'Del = ' . $param['movimentoitem'] . '<br \>';
            if (TSession::getValue($param['movimentoitem'])) 
            {
                $movimentoitem = TSession::getValue($param['movimentoitem']);
                $movimentoitem[$id]['del'] = 'S';
                TSession::setValue($param['movimentoitem'], $movimentoitem);
            }               
            //var_dump($movimentoitem);                     
            $this->onReload($param);
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    function loadMovimentoitem($idmovimento)
    {
        if(is_numeric($idmovimento))
        {
            try
            {           
                if(!TSession::getValue($param['movimentoitem_loaded'])) 
                {
                    $movimentoitem = TSession::delValue($param['movimentoitem']); 
                    TTransaction::open('goldnotas');                    
                    $movimentoitem_criteria = new TCriteria;                     
                    $movimentoitem_criteria->add(new TFilter('movimento_id', '=', $idmovimento));
                     
                    $repository = new TRepository('Movimentoitem'); 
                    $movimentoitem_repo = $repository->load($movimentoitem_criteria);
                    $movimentoitem_max_ordem = 0;
                    $movimentoitem_count = 0 ;                    
                    foreach ($movimentoitem_repo as $movimentoitem_obj) 
                    {                                             
                        $movimentoitem_count++;                                                                       
                        $movimentoitem[$movimentoitem_count] = array(
                                                  'key' => $movimentoitem_count,
                                                  'item' => $movimentoitem_count,
                                                  'cadproduto_id' => $movimentoitem_obj->cadproduto_id,                                                  
                                                  'produto' => $movimentoitem_obj->produto,
                                                  'unidade' => $movimentoitem_obj->unidade,
                                                  'qtde' => $movimentoitem_obj->qtde,
                                                  'unitario' => $movimentoitem_obj->unitario,
                                                  'subtotal' => $movimentoitem_obj->subtotal,
                                                  'desconto' => $movimentoitem_obj->desconto,
                                                  'margem_desconto' => $movimentoitem_obj->margem_desconto,
                                                  'total' => $movimentoitem_obj->total,  
                                                  'idmovimento' => $movimentoitem_count . '_' . $idmovimento,                                                
                                                  'del' => 'N');  
                                                                        
                    }
 
                    TSession::setValue($param['movimentoitem_count'], $movimentoitem_count);                    
                    TSession::setValue($param['movimentoitem_loaded'], true);
                    TSession::setValue($param['movimentoitem'], $movimentoitem);                     
                    TTransaction::close(); 
                    
                }
            }
            catch (Exception $e)
            {
                TTransaction::rollback(); 
                new TMessage('error', $e->getMessage());
            }
        }
        return true;  
    }
    
    public static function onExitCadproduto_id($param)
    {
        if (!empty($param['cadproduto_id']))
        {            
            try   
            {          
                //echo $param['idmovimento'] . '<br \>';
                TTransaction::open('goldnotas'); 
                $criteria = new TCriteria;
                $criteria->add(new TFilter('id', '=', "{$param['cadproduto_id']}"), TExpression::OR_OPERATOR); 
                $criteria->add(new TFilter('codbarras','=', "%{$param['cadproduto_id']}%"), TExpression::OR_OPERATOR);
                $criteria->add(new TFilter('referencia','=', "%{$param['cadproduto_id']}%"), TExpression::OR_OPERATOR);
                $criteria->add(new TFilter('reffabricante','=', "%{$param['cadproduto_id']}%"), TExpression::OR_OPERATOR);             
                //echo $criteria->dump(); // (nome like 'pedro%' OR nome like 'maria%')
                
                // load using repository
                $repository = new TRepository('Cadproduto'); 
                $cadprodutos = $repository->load($criteria); 
                 
                foreach ($cadprodutos as $cadproduto) 
                {                     
                    $object = new StdClass;
                    $object->cadproduto_id = $cadproduto->id;
                    $object->produto = $cadproduto->produto;
                    $object->unidade = $cadproduto->unidade;           
                    $object->unitario =  number_format($cadproduto->precovenda, 2, ',', '.');
                    $object->produtoservico = $cadproduto->produtoservico;
                    $object->descontomaximo = $cadproduto->descontomaximo;  
                    $object->subtotal = 0;
                    $object->total = 0;        
                    $object->desconto = 0;
                    $object->margem_desconto = 0;                                      
                    TForm::sendData('form_Movimento', $object,False,False);
                    TScript::create('setTimeout(function() { $("input[name=\'qtde\']").focus() }, 500);');
                    break;                     
                }                
                TTransaction::close();
            }
            catch (Exception $e) // in case of exception
            {
                new TMessage('error', $e->getMessage()); // shows the exception error message
                $this->form->setData( $this->form->getData() ); // keep formitem data
                TTransaction::rollback(); // undo all pending operations
            }                                         
        }
    }
    
    public static function onExitQtde($param)
    {                        
        //echo var_dump($param) . '<br\>';
        $qtde     = PMaskFormate::reais_to_decimal($param['qtde']);
        $unitario = PMaskFormate::reais_to_decimal($param['unitario']);
        $subtotal = 0;
        $desconto = 0;
        $margemdesconto = 0;            
        $total  = 0;
	    if (($qtde > 0) and ($unitario > 0))
	    {
            $subtotal  = $qtde * $unitario;          
            $subtotal  = $subtotal;
            $total     = $subtotal;                                    	        
	    }   
	             
        $obj = new StdClass;
        $obj->subtotal = number_format($subtotal, 2, ',', '.');
        $obj->total = number_format($total, 2, ',', '.');        
        $obj->desconto = number_format($desconto, 2, ',', '.');
        $obj->margem_desconto = number_format($margemdesconto, 2, ',', '.');
        TForm::sendData('form_Movimento', $obj, False, False);	    
    }  
    
    public static function onExitDesconto($param)
    {
                
        $subtotal = PMaskFormate::reais_to_decimal($param['subtotal']);
        $desconto = PMaskFormate::reais_to_decimal($param['desconto']);        
        $margemdesconto = 0;                    
        $total = $subtotal;
	    if (($subtotal > 0) and ($desconto > 0))
	    {
            $total  = $subtotal - $desconto; 
            $margemdesconto = (($desconto / $subtotal) * 100);         
	    }          
        
        $obj = new StdClass;        
        $obj->total = number_format($total, 2, ',', '.');        
        $obj->desconto = number_format($desconto, 2, ',', '.');
        $obj->margem_desconto = number_format($margemdesconto, 2, ',', '.');
        TForm::sendData('form_Movimento', $obj, False, False);	        
    } 
    
    public static function onExitMargemDesconto($param)
    {
                
        $subtotal = PMaskFormate::reais_to_decimal($param['subtotal']);
        $margemdesconto = PMaskFormate::reais_to_decimal($param['margem_desconto']);        
        $desconto = 0;                    
        $total = $subtotal;
	    if (($subtotal > 0) and ($margemdesconto > 0))
	    {
            $desconto  = ($subtotal * $margemdesconto) / 100; 
            $total = $subtotal - $desconto;         
	    }          
        
        $obj = new StdClass;        
        $obj->total = number_format($total, 2, ',', '.');        
        $obj->desconto = number_format($desconto, 2, ',', '.');
        $obj->margem_desconto = number_format($margemdesconto, 2, ',', '.');
        TForm::sendData('form_Movimento', $obj, False, False);	        
    }          
        
    public static function onChangetipooperacao($param)
    {
        try   
        {         
            if (!empty($param['cadtipooperacao_id']))
            {
                TTransaction::open('goldnotas');    
                
                $cadtipooperacao = new Cadtipooperacao($param['cadtipooperacao_id']);
                if ($cadtipooperacao->editadtemissao == 'S') {                    
                    TDate::enableField('form_Movimento','dataemissao');
                }
                else {
                    TDate::disableField('form_Movimento','dataemissao');    
                }
                if ($cadtipooperacao->editadtentrada == 'S'){                    
                    TDate::enableField('form_Movimento','dataentrada');
                }
                else {
                    TDate::disableField('form_Movimento','dataentrada');    
                }     
                if ($cadtipooperacao->editanumeronota == 'S') {                    
                    TEntry::enableField('form_Movimento','numero');
                    TEntry::enableField('form_Movimento','serie');
                }
                else {
                    TEntry::disableField('form_Movimento','numero');
                    TEntry::disableField('form_Movimento','serie');    
                }  
                if ($cadtipooperacao->itemeditavalor == 'S') {
                    TEntry::enableField('form_Movimento','unitario');                                                                 
                }
                else {
                    TEntry::disableField('form_Movimento','unitario');
                }
                
                if ($cadtipooperacao->itemusadesconto == 'S') {
                    TEntry::enableField('form_Movimento','desconto');
                    TEntry::enableField('form_Movimento','margem_desconto');                                                                 
                }
                else {
                    TEntry::disableField('form_Movimento','desconto');
                    TEntry::disableField('form_Movimento','margem_desconto');
                }                
                
                $tipooperacao = 'tipooperacao'.'_'.$param['idmovimento'];                                                                    
                if (TSession::getValue($tipooperacao))
                {
                    TSession::delValue($tipooperacao);     
                } 
                
                $tipooperacaotmp = array();
                $tipooperacaotmp['id'] = $cadtipooperacao->id;
                $tipooperacaotmp['editadtemissao'] = $cadtipooperacao->editadtemissao;
                $tipooperacaotmp['editadtentrada'] = $cadtipooperacao->editadtentrada;
                $tipooperacaotmp['editanumeronota'] = $cadtipooperacao->editanumeronota;
                $tipooperacaotmp['itemusadesconto'] = $cadtipooperacao->itemusadesconto;
                $tipooperacaotmp['itemeditavalor'] = $cadtipooperacao->itemeditavalor;
                $tipooperacaotmp['itemprodutoduplicado'] = $cadtipooperacao->itemprodutoduplicado;
                $tipooperacaotmp['itemservicoduplicado'] = $cadtipooperacao->itemservicoduplicado;
                $tipooperacaotmp['itemvendedor'] = $cadtipooperacao->itemvendedor;
                $tipooperacaotmp['itemvendedorautomatico'] = $cadtipooperacao->itemvendedorautomatico;
                $tipooperacaotmp['itemvendedorobrigatorio'] = $cadtipooperacao->itemvendedorobrigatorio;
                TSession::setValue($tipooperacao, $tipooperacaotmp);
                
                $obj = new StdClass;             
                $obj->dataemissao = TDate::date2br(date("Y-m-d"));
                $obj->dataentrada = TDate::date2br(date("Y-m-d"));
                TForm::sendData('form_Movimento', $obj);                
                
                TTransaction::close();                          
            }               
 
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }                                          
    }         
}
