<?php
/**
 * MovimentoForm Form
 * @author  <your name here>
 */
class MovimentoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Movimento');
        $this->form->setFormTitle('Vendas / Saídas');
        $this->form->setFieldSizes('100%');

        $movimentoid = $param['id']??'';
        if (empty($movimentoid))
        {
            $userid = TSession::getValue('userid');
            $movimentoid = $userid . mt_rand() . $userid;                   
        }

        // create the form fields
        $idmovimento = new THidden('idmovimento');
        $id = new THidden('id');
        $cadempresa_id = new THidden('cadempresa_id');
        $cadalmoxarifado_id = new THidden('cadalmoxarifado_id');
        $cadtipooperacao_id = new TDBCombo('cadtipooperacao_id', 'goldnotas', 'Cadtipooperacao', 'id', 'descricao');
        $cadcondpgto_id = new TDBCombo('cadcondpgto_id', 'goldnotas', 'Cadcondpgto', 'id', 'descricao');
        
        $filtro = new TCriteria;                     
        $filtro->add(new TFilter('evendedor', '=', "S"), TExpression::OR_OPERATOR);
        
        $vendedor_cadpessoa_id = new TDBCombo('vendedor_cadpessoa_id', 'goldnotas', 'Cadpessoa', 'id', 'pessoa', null, $filtro);
        $numero = new TEntry('numero');
        $serie = new TEntry('serie');
        $dataemissao = new TDate('dataemissao');
        $dataentrada = new TDate('dataentrada');
        $cadnaturezaoperacao_id = new TDBCombo('cadnaturezaoperacao_id', 'goldnotas', 'Cadnaturezaoperacao', 'id', '{id_natureza} - {natureza}');
        
        $filtro = new TCriteria;                     
        $filtro->add(new TFilter('ecliente', '=', "S"), TExpression::OR_OPERATOR);
        $filtro->add(new TFilter('efornecedor', '=', "S"), TExpression::OR_OPERATOR); 
        
        $cadpessoa_id = new TDBCombo('cadpessoa_id', 'goldnotas', 'Cadpessoa', 'id', 'pessoa', null, $filtro);
        $subtotal = new TEntry('subtotal');
        $total = new TEntry('total');
        $frete = new TEntry('frete');
        $seguro = new TEntry('seguro');
        $outras = new TEntry('outras');
        $itens = new TEntry('itens');
        $desconto = new TEntry('desconto');
        $margem_desconto = new TEntry('margem_desconto');
        $icms_base = new TEntry('icms_base');
        $icms_valor = new TEntry('icms_valor');
        $icmsst_base = new TEntry('icmsst_base');
        $icmsst_valor = new TEntry('icmsst_valor');
        $ipi_base = new TEntry('ipi_base');
        $ipi_valor = new TEntry('ipi_valor');
        $pis_base = new TEntry('pis_base');
        $pis_valor = new TEntry('pis_valor');
        $cofins_base = new TEntry('cofins_base');
        $cofins_valor = new TEntry('cofins_valor');
        $totalnf = new TEntry('totalnf');
        $transportador_cadpessoa_id = new TDBCombo('transportador_cadpessoa_id', 'goldnotas', 'Cadpessoa', 'id', 'pessoa');
        $frete_conta = new TCombo('frete_conta');
        $placa = new TEntry('placa');
        $placa_uf = new TEntry('placa_uf');
        $vol_qtde = new TEntry('vol_qtde');
        $vol_especie = new TEntry('vol_especie');
        $vol_marca = new TEntry('vol_marca');
        $vol_numero = new TEntry('vol_numero');
        $peso_liquido = new TEntry('peso_liquido');
        $peso_bruto = new TEntry('peso_bruto');
        $obs = new TText('obs');
        $nomeconsumidor = new TEntry('nomeconsumidor');
        $cpfcnpjconsumidor = new TEntry('cpfcnpjconsumidor');
        $total_produtos = new TEntry('total_produtos');
        $total_servicos = new TEntry('total_servicos');
        $desconto_produtos = new TEntry('desconto_produtos');
        $desconto_servicos = new TEntry('desconto_servicos');
        $margem_desconto_produtos = new TEntry('margem_desconto_produtos');
        $margem_desconto_servicos = new TEntry('margem_desconto_servicos');

        $idmovimento->setValue($movimentoid);
        $subtotal->setEditable(False);
        $total_produtos->setEditable(False);
        $total_servicos->setEditable(False);
        $total->setEditable(False);
        $totalnf->setEditable(False);
        $desconto->setEditable(False);
        $margem_desconto->setEditable(False);
        $icms_base->setEditable(False);
        $icms_valor->setEditable(False);
        $icmsst_base->setEditable(False);
        $icmsst_valor->setEditable(False);
        $ipi_base->setEditable(False);
        $ipi_valor->setEditable(False);
        $pis_valor->setEditable(False);
        $pis_base->setEditable(False);
        $cofins_base->setEditable(False);
        $cofins_valor->setEditable(False);
        
        $dataemissao->setMask('dd/mm/yyyy');
        $dataemissao->setDatabaseMask('yyyy-mm-dd');
        
        $dataentrada->setMask('dd/mm/yyyy');
        $dataentrada->setDatabaseMask('yyyy-mm-dd');                
        
        $itens = array();
        $itens['0'] = 'Contratação do Frete por conta do Remetente (CIF)';
        $itens['1'] = 'Contratação do Frete por conta do Destinatário (FOB)';
        $itens['2'] = 'Contratação do Frete por conta de Terceiros';
        $itens['3'] = 'Transporte Próprio por conta do Remetente';
        $itens['4'] = 'Transporte Próprio por conta do Destinatário';
        $itens['9'] = 'Sem Ocorrência de Transporte';
        
        $frete_conta->addItems($itens);
        

        // add the fields
        $row = $this->form->addFields( [ new TLabel('Tipo de Operação') , $cadtipooperacao_id ] ,
                                       [ new TLabel('Número') , $numero ],
                                       [ new TLabel('Série') , $serie ],
                                       [ new TLabel('Dt. Emissão') , $dataemissao ],
                                       [ new TLabel('Dt. Entrada') , $dataentrada ]);
        $row->layout = ['col-sm-4','col-sm-1','col-sm-1','col-sm-2','col-sm-2'];  
        $row = $this->form->addFields( [ new TLabel('Pessoa') , $cadpessoa_id ],
                                       [ new TLabel('Vendedor') , $vendedor_cadpessoa_id ],        
                                       [ new TLabel('Condição de Pagamento') , $cadcondpgto_id ] );
        $row->layout = ['col-sm-4','col-sm-3','col-sm-3'];        
                                                             
        $this->form->addFields( [ $id ], [$idmovimento],[ $cadempresa_id ],[ $cadalmoxarifado_id ] );        
        
        /*
        $row = $this->form->addFields( [ new TLabel('Vendedor') , $vendedor_cadpessoa_id ],
                                       [ new TLabel('Natureza da Operação') , $cadnaturezaoperacao_id ] );
        $row->layout = ['col-sm-5',
                        'col-sm-5'];
        */
                        
        $subform = new BootstrapFormBuilder;
        $subform->setFieldSizes('100%');
        $subform->setProperty('style', 'border:none');
        
        $subform->appendPage( 'Itens' );
 
        // place where the products page will be inserted
        $details_area = new TElement('div');
        $details_area->id = 'Movimentoitem_area';            
        //$this->form->addContent( [TElement::tag('h4', 'Imagens')] );
        $subform->addContent( [$details_area] );

        // Load SaleDetailForm into details_area
        AdiantiCoreApplication::loadPage('MovimentoitemList', 'onSearch', ['register_state'=>'false','idmovimento' => $movimentoid]);                 
                
        
        $subform->appendPage( 'Valores' );        
        
        $row = $subform->addFields( [ new TLabel('Total Produtos') , $total_produtos ],
                                    [ new TLabel('Total Servicos') , $total_servicos ],                                    
                                    [ new TLabel('Subtotal') ,  $subtotal ],
                                    [ new TLabel('Desconto') ,  $desconto ],        
                                    [ new TLabel('Total') , $total ] );
        $row->layout = ['col-sm-2',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2'];
                        

        $row = $subform->addFields( [ new TLabel('Desconto Produtos') , $desconto_produtos ],
                                    [ new TLabel('Margem Desconto Produtos') , $margem_desconto_produtos ],        
                                    [ new TLabel('Desconto Servicos') , $desconto_servicos ],                                    
                                    [ new TLabel('Margem Desconto Servicos') , $margem_desconto_servicos ],
                                    [ new TLabel('Margem Total Desconto') , $margem_desconto ]);                        
        $row->layout = ['col-sm-2',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2'];
                                    
        $row = $subform->addFields( [ new TLabel('Frete') , $frete ],
                                    [ new TLabel('Seguro') , $seguro ],
                                    [ new TLabel('Outras') ,  $outras ] );
        $row->layout = ['col-sm-2',
                        'col-sm-2',
                        'col-sm-2'];                                    
        //$subform->addFields( [ new TLabel('Itens') ], [ $itens ] );       
        $row = $subform->addFields( [ new TLabel('Icms Base') ,  $icms_base ],
                                    [ new TLabel('Icms Valor') ,  $icms_valor ],
                                    [ new TLabel('Icms ST Base') ,  $icmsst_base ],
                                    [ new TLabel('Icms ST Valor') ,  $icmsst_valor ] );
        $row->layout = ['col-sm-2',
                        'col-sm-2',
                        'col-sm-2',                        
                        'col-sm-2'];
        $row = $subform->addFields( [ new TLabel('Pis Base'), $pis_base ],
                             [ new TLabel('Pis Valor'), $pis_valor ],
                             [ new TLabel('Cofins Base'), $cofins_base ],
                             [ new TLabel('Cofins Valor'), $cofins_valor ] );                        
        $row->layout = ['col-sm-2',
                        'col-sm-2',
                        'col-sm-2',                        
                        'col-sm-2'];                        
                                                            
        $row = $subform->addFields( [ new TLabel('Ipi Base') , $ipi_base ],
                                    [ new TLabel('Ipi Valor') , $ipi_valor ],
                                    [ new TLabel('Total NF'), $totalnf ] );
        $row->layout = ['col-sm-2',
                        'col-sm-2',                       
                        'col-sm-2'];                                    
         
        $subform->appendPage( 'Transporte' ); 
                                    
        $row = $subform->addFields( [ new TLabel('Transportador') , $transportador_cadpessoa_id ], 
                                    [ new TLabel('Frete Conta') , $frete_conta ] );
        $row->layout = ['col-sm-6',                       
                        'col-sm-4'];
                                                            
        $row = $subform->addFields( [ new TLabel('Placa') , $placa ],
                                    [ new TLabel('Placa Uf') , $placa_uf ],
                                    [ new TLabel('Quantidade Vol.') , $vol_qtde ],
                                    [ new TLabel('Espécie Vol.') , $vol_especie ],
                                    [ new TLabel('Marca Vol.') , $vol_marca ] );
        $row->layout = ['col-sm-2',
                        'col-sm-2',
                        'col-sm-2',
                        'col-sm-2',                        
                        'col-sm-2'];
                                                            
        $row = $subform->addFields( [ new TLabel('Número Vol.') , $vol_numero ],
                                    [ new TLabel('Peso Líquido') , $peso_liquido ],
                                    [ new TLabel('Peso Bruto') , $peso_bruto ] );
        $row->layout = ['col-sm-2',
                        'col-sm-2',                      
                        'col-sm-2'];
        $subform->appendPage( 'Observações / Consumidor' );                                                    
        $subform->addFields( [ new TLabel('Observações') , $obs ] );

        $labelfiscal = new TLabel('Consumidor', '#7D78B6', 12, 'b');
        $labelfiscal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelfiscal->setSize('100%');
        $subform->addContent( [$labelfiscal] ); 

        $row = $subform->addFields( [ new TLabel('Nome') , $nomeconsumidor ],
                             [ new TLabel('CPF/CNPJ') , $cpfcnpjconsumidor ] );
        $row->layout = ['col-sm-2',                      
                        'col-sm-2'];
       



        // set sizes
        $id->setSize('100%');
        $cadempresa_id->setSize('100%');
        $cadalmoxarifado_id->setSize('100%');
        $cadtipooperacao_id->setSize('100%');
        $cadcondpgto_id->setSize('100%');
        $numero->setSize('100%');
        $serie->setSize('100%');
        $dataemissao->setSize('100%');
        $dataentrada->setSize('100%');
        $cadnaturezaoperacao_id->setSize('100%');
        $cadpessoa_id->setSize('100%');
        $subtotal->setSize('100%');
        $total->setSize('100%');
        $frete->setSize('100%');
        $seguro->setSize('100%');
        $outras->setSize('100%');
        //$itens->setSize('100%');
        $desconto->setSize('100%');
        $margem_desconto->setSize('100%');
        $icms_base->setSize('100%');
        $icms_valor->setSize('100%');
        $icmsst_base->setSize('100%');
        $icmsst_valor->setSize('100%');
        $ipi_base->setSize('100%');
        $ipi_valor->setSize('100%');
        $pis_base->setSize('100%');
        $pis_valor->setSize('100%');
        $cofins_base->setSize('100%');
        $cofins_valor->setSize('100%');
        $totalnf->setSize('100%');
        $transportador_cadpessoa_id->setSize('100%');
        $frete_conta->setSize('100%');
        $placa->setSize('100%');
        $placa_uf->setSize('100%');
        $vol_qtde->setSize('100%');
        $vol_especie->setSize('100%');
        $vol_marca->setSize('100%');
        $vol_numero->setSize('100%');
        $peso_liquido->setSize('100%');
        $peso_bruto->setSize('100%');
        $obs->setSize('100%');
        $nomeconsumidor->setSize('100%');
        $cpfcnpjconsumidor->setSize('100%');
        $total_produtos->setSize('100%');
        $total_servicos->setSize('100%');
        $desconto_produtos->setSize('100%');
        $desconto_servicos->setSize('100%');
        $margem_desconto_produtos->setSize('100%');
        $margem_desconto_servicos->setSize('100%');
        $vendedor_cadpessoa_id->setSize('100%');



        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        $this->form->addContent( [$subform] ); 
        
               
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'fa:save');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addActionLink(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Movimento;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', AdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Movimento($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
