<?php
/**
 * MovcaixacontacorrenteReport Report
 * @author  <your name here>
 */
class MovcaixacontacorrenteReport extends TPage
{
    protected $form; // form
    
    /**
     * Class constructor
     * Creates the page and the registration form
     */
    function __construct()
    {
        parent::__construct();
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Movcaixacontacorrente_report');
        $this->form->setFormTitle('Movcaixacontacorrente Report');
        

        // create the form fields
        $cadcaixacontacorrente_id = new TDBUniqueSearch('cadcaixacontacorrente_id', 'goldnotas', 'Cadcaixacontacorrente', 'id', 'caixacontacorrente');
        $tipo = new TCombo('tipo');
        $datalancamento_inicio = new TDate('datalancamento_inicio');
        $datalancamento_final = new TDate('datalancamento_final');
        $cadempresa_id = new THidden('cadempresa_id');
        $system_user_id = new THidden('system_user_id');
        $output_type = new TRadioGroup('output_type');


        // add the fields
        $this->form->addFields( [ new TLabel('Cadcaixacontacorrente Id') ], [ $cadcaixacontacorrente_id ] );
        $this->form->addFields( [ new TLabel('Tipo') ], [ $tipo ] );
        $this->form->addFields( [ new TLabel('Data Inicial') ], [ $datalancamento_inicio ] );
        $this->form->addFields( [ new TLabel('Data Final') ], [ $datalancamento_final ] );
        $this->form->addFields( [ new TLabel('Cadempresa Id') ], [ $cadempresa_id ] );
        $this->form->addFields( [ new TLabel('System User Id') ], [ $system_user_id ] );
        $this->form->addFields( [ new TLabel('Output') ], [ $output_type ] );

        $output_type->addValidation('Output', new TRequiredValidator);


        // set sizes
        $cadcaixacontacorrente_id->setSize('100%');
        $tipo->setSize('100%');
        $datalancamento_inicio->setSize('100%');
        $datalancamento_final->setSize('100%');
        $cadempresa_id->setSize('100%');
        $system_user_id->setSize('100%');
        $output_type->setSize('100%');


        
        $output_type->addItems(array('html'=>'HTML', 'pdf'=>'PDF', 'rtf'=>'RTF', 'xls' => 'XLS'));
        $output_type->setLayout('horizontal');
        $output_type->setUseButton();
        $output_type->setValue('pdf');
        $output_type->setSize(70);
        
        // add the action button
        $btn = $this->form->addAction(_t('Generate'), new TAction(array($this, 'onGenerate')), 'fa:cog');
        $btn->class = 'btn btn-sm btn-primary';
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        
        parent::add($container);
    }
    
    /**
     * Generate the report
     */
    function onGenerate()
    {
        try
        {
            // open a transaction with database 'goldnotas'
            TTransaction::open('goldnotas');
            
            // get the form data into an active record
            $data = $this->form->getData();
            
            $this->form->validate();
            
            $repository = new TRepository('Movcaixacontacorrente');
            $criteria   = new TCriteria;
            
            if ($data->cadcaixacontacorrente_id)
            {
                $criteria->add(new TFilter('cadcaixacontacorrente_id', '=', "{$data->cadcaixacontacorrente_id}"));
            }
            if ($data->tipo)
            {
                $criteria->add(new TFilter('tipo', 'like', "%{$data->tipo}%"));
            }
            if ($data->datalancamento_inicio)
            {
                $criteria->add(new TFilter('datalancamento_inicio', '>=', "{$data->datalancamento_inicio}"));
            }
            if ($data->datalancamento_final)
            {
                $criteria->add(new TFilter('datalancamento_final', '<=', "{$data->datalancamento_final}"));
            }
            if ($data->cadempresa_id)
            {
                $criteria->add(new TFilter('cadempresa_id', '=', "{$data->cadempresa_id}"));
            }
            if ($data->system_user_id)
            {
                $criteria->add(new TFilter('system_user_id', '=', "{$data->system_user_id}"));
            }

           
            $objects = $repository->load($criteria, FALSE);
            $format  = $data->output_type;
            
            if ($objects)
            {
                $widths = array(90,120,200,300,130,130,130);
                
                switch ($format)
                {
                    case 'html':
                        $tr = new TTableWriterHTML($widths);
                        break;
                    case 'pdf':
                        $tr = new TTableWriterPDF($widths);
                        break;
                    case 'xls':
                        $tr = new TTableWriterXLS($widths);
                        break;
                    case 'rtf':
                        $tr = new TTableWriterRTF($widths);
                        break;
                }
                
                // create the document styles
                $tr->addStyle('title', 'Arial', '8', 'B',   '#000000', '#ffffff', 'T');
                $tr->addStyle('datap', 'Arial', '8', '',    '#000000', '#ffffff', '');
                $tr->addStyle('datai', 'Arial', '8', '',    '#000000', '#ffffff', '');
                $tr->addStyle('header', 'Arial', '16', '',   '#000000', '#ffffff', '');
                $tr->addStyle('footer', 'Arial', '10', 'B',  '#000000', '#ffffff', '');
                $tr->addStyle('linetop', 'Arial', '10', '',  '#000000', '#ffffff', 'T');                 
                // add a header row
                $tr->setHeaderCallback( function($tr) 
                {                                   
                    $tr->addRow();
                    $tr->addCell('Movimento Caixa / Conta Banco', 'left', 'header', 7);                                  
                    // add titles row
                    $tr->addRow();
                    $tr->addCell('Código', 'right', 'title');
                    $tr->addCell('Data', 'left', 'title');                    
                    $tr->addCell('Caixa / C. Banco', 'left', 'title');                
                    $tr->addCell('Histórico', 'left', 'title');
                    $tr->addCell('Crédito', 'left', 'title');
                    $tr->addCell('Débito', 'left', 'title');
                    $tr->addCell('Sub-Total', 'left', 'title');                    
                }
                );
                 
                $tr->setFooterCallback( function($tr) 
                {
                    //$tr->addRow();
                    //$tr->addCell('Sis7ec Sistemas', 'right', 'linetop', 7);
                    $tr->getNativeWriter()->SetY(-20);
                    $tr->getNativeWriter()->cell(0,20,'Sis7ec Sistemas');                    
                }
                );                
                
                // controls the background filling
                $colour= FALSE;                
                // data rows
                $subtotal = 0;                
                
                $tr->addRow();
                $tr->addCell('Saldo Anterior ', 'right', 'linetop', 6);
                $tr->addCell(HMoneyFormat::reais($subtotal), 'right', 'linetop');                                                
                foreach ($objects as $object)
                {
                    $style = $colour ? 'datap' : 'datai';
                    $tr->addRow();
                    $tr->addCell($object->id, 'right', $style);
                    $tr->addCell(HDateFormat::date2br($object->datalancamento), 'left', $style);
                    $tr->addCell($object->nome_caixacontacorrente, 'left', $style);                    
                    $tr->addCell($object->historico, 'left', $style);
                    if ($object->tipo == 'C') {
                        $tr->addCell(HMoneyFormat::reais($object->valor), 'right', $style);
                        $tr->addCell('', 'right', $style);
                    } 
                    else {
                        $tr->addCell('', 'right', $style);
                        $tr->addCell(HMoneyFormat::reais($object->valor), 'right', $style);                             
                    }   
                    $subtotal = $subtotal + $object->valor;   
                    $tr->addCell(HMoneyFormat::reais($subtotal), 'right', $style);                                  
                    $colour = !$colour;
                }
                $tr->addRow();
                $tr->addCell('Total', 'right', 'linetop', 6);   
                $tr->addCell(HMoneyFormat::reais($subtotal), 'right', 'linetop');             
                // footer row
                /*
                $tr->addRow();
                $tr->addCell(date('Y-m-d h:i:s'), 'center', 'footer', 8);
                */
                // stores the file
                if (!file_exists("app/output/Movcaixacontacorrente.{$format}") OR is_writable("app/output/Movcaixacontacorrente.{$format}"))
                {
                    $tr->save("app/output/Movcaixacontacorrente.{$format}");
                }
                else
                {
                    throw new Exception(_t('Permission denied') . ': ' . "app/output/Movcaixacontacorrente.{$format}");
                }
                
                // open the report file
                parent::openFile("app/output/Movcaixacontacorrente.{$format}");
                
                // shows the success message
                new TMessage('info', 'Report generated. Please, enable popups.');
            }
            else
            {
                new TMessage('error', 'No records found');
            }
    
            // fill the form with the active record data
            $this->form->setData($data);
            
            // close the transaction
            TTransaction::close();
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            
            // undo all pending operations
            TTransaction::rollback();
        }
    }
}
