/<?php
/**
 * Cadpessoa Active Record
 * @author  <your-name-here>
 */
class Cadpessoa extends TRecord
{
    const TABLENAME = 'cadpessoa';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadpessoa_cadcontratoplgs;
    private $cadpessoa_cadimagems;
    private $cadpessoa_cadplgs;
    private $cadcidade;
    private $cadregiao;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('pessoa');
        parent::addAttribute('fantasia');
        parent::addAttribute('tipopessoa');
        parent::addAttribute('dtcadastro');
        parent::addAttribute('bloqueado');
        parent::addAttribute('ecliente');
        parent::addAttribute('efornecedor');
        parent::addAttribute('efuncionario');
        parent::addAttribute('etransportador');
        parent::addAttribute('econtador');
        parent::addAttribute('econvenio');
        parent::addAttribute('evendedor');
        parent::addAttribute('cpfcnpj');
        parent::addAttribute('rginscricaoestadual');
        parent::addAttribute('inscricaomunicipal');
        parent::addAttribute('issqnretido');
        parent::addAttribute('rpr');
        parent::addAttribute('cnae');
        parent::addAttribute('crt');
        parent::addAttribute('tipocliente');
        parent::addAttribute('telefone1');
        parent::addAttribute('telefone2');
        parent::addAttribute('telefone3');
        parent::addAttribute('telefone4');
        parent::addAttribute('contato');
        parent::addAttribute('email');
        parent::addAttribute('limitecredito');
        parent::addAttribute('atrazomaximo');
        parent::addAttribute('dtconsultaspc');
        parent::addAttribute('dtregistrospc');
        parent::addAttribute('dtreaberturaspc');
        parent::addAttribute('estadocivil');
        parent::addAttribute('naturalidade');
        parent::addAttribute('dtnascimento');
        parent::addAttribute('sexo');
        parent::addAttribute('empresatrabalho');
        parent::addAttribute('telefonetrabalho');
        parent::addAttribute('cargofuncaotrabalho');
        parent::addAttribute('dtadmissaotrabalho');
        parent::addAttribute('salariotrabalho');
        parent::addAttribute('rendafamiliar');
        parent::addAttribute('nomeconjugue');
        parent::addAttribute('telefoneconjugue');
        parent::addAttribute('nomepai');
        parent::addAttribute('nomemae');
        parent::addAttribute('vendedor_cadpessoa_id');
        parent::addAttribute('convenio_cadpessoa_id');
        parent::addAttribute('cadregiao_id');
        parent::addAttribute('endprinc_logradouro');
        parent::addAttribute('endprinc_numero');
        parent::addAttribute('endprinc_bairro');
        parent::addAttribute('endprinc_complemento');
        parent::addAttribute('endprinc_cadcidade_id');
        parent::addAttribute('observacoesvenda');
        parent::addAttribute('observacoesdiversas');
        parent::addAttribute('dtadmissaofuncionario');
        parent::addAttribute('dtdemissaofuncionario');
        parent::addAttribute('produtocomissao');
        parent::addAttribute('servicocomissao');
        parent::addAttribute('ativo');
        parent::addAttribute('endprinc_cep');
        parent::addAttribute('contribuinteicms');
        parent::addAttribute('atrasomaximo');
        parent::addAttribute('dtadmissaotrabalho');
        parent::addAttribute('cnh');
        parent::addAttribute('dtvencimentocnh');
        parent::addAttribute('numeroregistrocooperativa');
    }

    
    /**
     * Method addCadpessoaCadcontratoplg
     * Add a CadpessoaCadcontratoplg to the Cadpessoa
     * @param $object Instance of CadpessoaCadcontratoplg
     */
    public function addCadpessoaCadcontratoplg(CadpessoaCadcontratoplg $object)
    {
        $this->cadpessoa_cadcontratoplgs[] = $object;
    }
    
    /**
     * Method getCadpessoaCadcontratoplgs
     * Return the Cadpessoa' CadpessoaCadcontratoplg's
     * @return Collection of CadpessoaCadcontratoplg
     */
    public function getCadpessoaCadcontratoplgs()
    {
        return $this->cadpessoa_cadcontratoplgs;
    }
    
    /**
     * Method addCadpessoaCadimagem
     * Add a CadpessoaCadimagem to the Cadpessoa
     * @param $object Instance of CadpessoaCadimagem
     */
    public function addCadpessoaCadimagem(CadpessoaCadimagem $object)
    {
        $this->cadpessoa_cadimagems[] = $object;
    }
    
    /**
     * Method getCadpessoaCadimagems
     * Return the Cadpessoa' CadpessoaCadimagem's
     * @return Collection of CadpessoaCadimagem
     */
    public function getCadpessoaCadimagems()
    {
        return $this->cadpessoa_cadimagems;
    }
    
    /**
     * Method addCadpessoaCadplg
     * Add a CadpessoaCadplg to the Cadpessoa
     * @param $object Instance of CadpessoaCadplg
     */
    public function addCadpessoaCadplg(CadpessoaCadplg $object)
    {
        $this->cadpessoa_cadplgs[] = $object;
    }
    
    /**
     * Method getCadpessoaCadplgs
     * Return the Cadpessoa' CadpessoaCadplg's
     * @return Collection of CadpessoaCadplg
     */
    public function getCadpessoaCadplgs()
    {
        return $this->cadpessoa_cadplgs;
    }
    
    /**
     * Method set_cadcidade
     * Sample of usage: $cadpessoa->cadcidade = $object;
     * @param $object Instance of Cadcidade
     */
    public function set_cadcidade(Cadcidade $object)
    {
        $this->cadcidade = $object;
        $this->cadcidade_id = $object->id;
    }
    
    /**
     * Method get_cadcidade
     * Sample of usage: $cadpessoa->cadcidade->attribute;
     * @returns Cadcidade instance
     */
    public function get_cadcidade()
    {
        // loads the associated object
        if (empty($this->cadcidade))
            $this->cadcidade = new Cadcidade($this->cadcidade_id);
    
        // returns the associated object
        return $this->cadcidade;
    }
    
    
    /**
     * Method set_cadregiao
     * Sample of usage: $cadpessoa->cadregiao = $object;
     * @param $object Instance of Cadregiao
     */
    public function set_cadregiao(Cadregiao $object)
    {
        $this->cadregiao = $object;
        $this->cadregiao_id = $object->id;
    }
    
    /**
     * Method get_cadregiao
     * Sample of usage: $cadpessoa->cadregiao->attribute;
     * @returns Cadregiao instance
     */
    public function get_cadregiao()
    {
        // loads the associated object
        if (empty($this->cadregiao))
            $this->cadregiao = new Cadregiao($this->cadregiao_id);
    
        // returns the associated object
        return $this->cadregiao;
    }
    

    /**
     * Reset aggregates
     */
    public function clearParts()
    {
        $this->cadpessoa_cadcontratoplgs = array();
        $this->cadpessoa_cadimagems = array();
        $this->cadpessoa_cadplgs = array();
    }

    /**
     * Load the object and its aggregates
     * @param $id object ID
     */
    public function load($id)
    {
    
        // load the related CadpessoaCadcontratoplg objects
        $repository = new TRepository('CadpessoaCadcontratoplg');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadpessoa_id', '=', $id));
        $this->cadpessoa_cadcontratoplgs = $repository->load($criteria);
    
        // load the related CadpessoaCadimagem objects
        $repository = new TRepository('CadpessoaCadimagem');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadpessoa_id', '=', $id));
        $this->cadpessoa_cadimagems = $repository->load($criteria);
    
        // load the related CadpessoaCadplg objects
        $repository = new TRepository('CadpessoaCadplg');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadpessoa_id', '=', $id));
        $this->cadpessoa_cadplgs = $repository->load($criteria);
    
        // load the object itself
        return parent::load($id);
    }

    /**
     * Store the object and its aggregates
     */
    public function store()
    {
        // store the object itself
        parent::store();
    
        // delete the related CadpessoaCadcontratoplg objects
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadpessoa_id', '=', $this->id));
        $repository = new TRepository('CadpessoaCadcontratoplg');
        $repository->delete($criteria);
        // store the related CadpessoaCadcontratoplg objects
        if ($this->cadpessoa_cadcontratoplgs)
        {
            foreach ($this->cadpessoa_cadcontratoplgs as $cadpessoa_cadcontratoplg)
            {
                //unset($cadpessoa_cadcontratoplg->id);
                $cadpessoa_cadcontratoplg->cadpessoa_id = $this->id;
                $cadpessoa_cadcontratoplg->store();
            }
        }
        // delete the related CadpessoaCadimagem objects
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadpessoa_id', '=', $this->id));
        $repository = new TRepository('CadpessoaCadimagem');
        $repository->delete($criteria);
        // store the related CadpessoaCadimagem objects
        if ($this->cadpessoa_cadimagems)
        {
            foreach ($this->cadpessoa_cadimagems as $cadpessoa_cadimagem)
            {
                //unset($cadpessoa_cadimagem->id);
                $cadpessoa_cadimagem->cadpessoa_id = $this->id;
                $cadpessoa_cadimagem->store();
            }
        }
        // delete the related CadpessoaCadplg objects
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadpessoa_id', '=', $this->id));
        $repository = new TRepository('CadpessoaCadplg');
        $repository->delete($criteria);
        // store the related CadpessoaCadplg objects
        if ($this->cadpessoa_cadplgs)
        {
            foreach ($this->cadpessoa_cadplgs as $cadpessoa_cadplg)
            {
                //unset($cadpessoa_cadplg->id);
                $cadpessoa_cadplg->cadpessoa_id = $this->id;
                $cadpessoa_cadplg->store();
            }
        }
    }

    /**
     * Delete the object and its aggregates
     * @param $id object ID
     */
    public function delete($id = NULL)
    {
        $id = isset($id) ? $id : $this->id;
        // delete the related CadpessoaCadcontratoplg objects
        $repository = new TRepository('CadpessoaCadcontratoplg');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadpessoa_id', '=', $id));
        $repository->delete($criteria);
        
        // delete the related CadpessoaCadimagem objects
        $repository = new TRepository('CadpessoaCadimagem');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadpessoa_id', '=', $id));
        $repository->delete($criteria);
        
        // delete the related CadpessoaCadplg objects
        $repository = new TRepository('CadpessoaCadplg');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadpessoa_id', '=', $id));
        $repository->delete($criteria);
        
    
        // delete the object itself
        parent::delete($id);
    }


}
