<?php
/**
 * Movcaixa Active Record
 * @author  <your-name-here>
 */
class Movcaixa extends TRecord
{
    const TABLENAME = 'movcaixa';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcaixa;
    private $cadcaixaorigem;
    private $movplanocontas;
    private $system_user;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cadcaixa_id');
        parent::addAttribute('tipo');
        parent::addAttribute('historico');
        parent::addAttribute('valor');
        parent::addAttribute('datalancamento');
        parent::addAttribute('cadcaixaorigem_id');
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('system_user_id');
    }

    
    /**
     * Method set_cadcaixa
     * Sample of usage: $movcaixa->cadcaixa = $object;
     * @param $object Instance of Cadcaixa
     */
    public function set_cadcaixa(Cadcaixa $object)
    {
        $this->cadcaixa = $object;
        $this->cadcaixa_id = $object->id;
    }
    
    /**
     * Method get_cadcaixa
     * Sample of usage: $movcaixa->cadcaixa->attribute;
     * @returns Cadcaixa instance
     */
    public function get_cadcaixa()
    {
        // loads the associated object
        if (empty($this->cadcaixa))
            $this->cadcaixa = new Cadcaixa($this->cadcaixa_id);
    
        // returns the associated object
        return $this->cadcaixa;
    }
        
    public function get_nome_caixa()
    {
        // loads the associated object
        if (empty($this->cadcaixaorigem))
            $this->cadcaixa = new Cadcaixa($this->cadcaixa_id);
    
        // returns the associated object
        return $this->cadcaixa->id . ' - ' . $this->cadcaixa->caixa;
    }        
    
    /**
     * Method set_cadcaixaorigem
     * Sample of usage: $movcaixa->cadcaixaorigem = $object;
     * @param $object Instance of Cadcaixaorigem
     */
    public function set_cadcaixaorigem(Cadcaixaorigem $object)
    {
        $this->cadcaixaorigem = $object;
        $this->cadcaixaorigem_id = $object->id;
    }
    
    /**
     * Method get_cadcaixaorigem
     * Sample of usage: $movcaixa->cadcaixaorigem->attribute;
     * @returns Cadcaixaorigem instance
     */
    public function get_cadcaixaorigem()
    {
        // loads the associated object
        if (empty($this->cadcaixaorigem))
            $this->cadcaixaorigem = new Cadcaixaorigem($this->cadcaixaorigem_id);
    
        // returns the associated object
        return $this->cadcaixaorigem;
    }
    
    /**
     * Method addMovplanoconta
     * Add a Movplanoconta to the Movcaixa
     * @param $object Instance of Movplanoconta
     */
    public function addMovplanoconta(Movplanoconta $object)
    {
        $this->movplanocontas[] = $object;
    }
    
    /**
     * Method getMovplanocontas
     * Return the Movcaixa' Movplanoconta's
     * @return Collection of Movplanoconta
     */
    public function getMovplanocontas()
    {
        return $this->movplanocontas;
    }
    
    /**
     * Method set_system_user
     * Sample of usage: $movcaixa->system_user = $object;
     * @param $object Instance of SystemUser
     */
    public function set_system_user(SystemUser $object)
    {
        $this->system_user = $object;
        $this->system_user_id = $object->id;
    }
    
    /**
     * Method get_system_user
     * Sample of usage: $movcaixa->system_user->attribute;
     * @returns SystemUser instance
     */
    public function get_system_user()
    {
        // loads the associated object
        if (empty($this->system_user))
            $this->system_user = new SystemUser($this->system_user_id);
    
        // returns the associated object
        return $this->system_user;
    }

    public function get_login_systemuser()
    {
        // loads the associated object
        if (empty($this->system_user))
            $this->system_user = new SystemUser($this->system_user_id);
    
        // returns the associated object
        return $this->system_user->login;
    }     

    /**
     * Reset aggregates
     */
    public function clearParts()
    {
        $this->movplanocontas = array();
    }

    /**
     * Load the object and its aggregates
     * @param $id object ID
     */
    public function load($id)
    {
    
        // load the related Movplanoconta objects
        $repository = new TRepository('Movplanoconta');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movcaixa_id', '=', $id));
        $this->movplanocontas = $repository->load($criteria);
    
        // load the object itself
        return parent::load($id);
    }

    /**
     * Store the object and its aggregates
     */
    public function store()
    {
        // store the object itself
        parent::store();
    
        // delete the related Movplanoconta objects
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movcaixa_id', '=', $this->id));
        $repository = new TRepository('Movplanoconta');
        $repository->delete($criteria);
        // store the related Movplanoconta objects
        if ($this->movplanocontas)
        {
            foreach ($this->movplanocontas as $movplanoconta)
            {
                unset($movplanoconta->id);
                $movplanoconta->movcaixa_id = $this->id;
                $movplanoconta->store();
            }
        }
    }

    /**
     * Delete the object and its aggregates
     * @param $id object ID
     */
    public function delete($id = NULL)
    {
        $id = isset($id) ? $id : $this->id;
        // delete the related Movplanoconta objects
        $repository = new TRepository('Movplanoconta');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movcaixa_id', '=', $id));
        $repository->delete($criteria);
        
    
        // delete the object itself
        parent::delete($id);
    }


}
