<?php
/**
 * Movcontacorrente Active Record
 * @author  <your-name-here>
 */
class Movcontacorrente extends TRecord
{
    const TABLENAME = 'movcontacorrente';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcontacorrenteorigem;
    private $cadcontacorrente;
    private $movplanocontas;
    private $system_user;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cadcontacorrente_id');
        parent::addAttribute('tipo');
        parent::addAttribute('historico');
        parent::addAttribute('valor');
        parent::addAttribute('compensado');
        parent::addAttribute('datalancamento');
        parent::addAttribute('datacompensado');
        parent::addAttribute('cadcontacorrenteorigem_id');
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('system_user_id');
    }

    
    /**
     * Method set_cadcontacorrenteorigem
     * Sample of usage: $movcontacorrente->cadcontacorrenteorigem = $object;
     * @param $object Instance of Cadcontacorrenteorigem
     */
    public function set_cadcontacorrenteorigem(Cadcontacorrenteorigem $object)
    {
        $this->cadcontacorrenteorigem = $object;
        $this->cadcontacorrenteorigem_id = $object->id;
    }
    
    /**
     * Method get_cadcontacorrenteorigem
     * Sample of usage: $movcontacorrente->cadcontacorrenteorigem->attribute;
     * @returns Cadcontacorrenteorigem instance
     */
    public function get_cadcontacorrenteorigem()
    {
        // loads the associated object
        if (empty($this->cadcontacorrenteorigem))
            $this->cadcontacorrenteorigem = new Cadcontacorrenteorigem($this->cadcontacorrenteorigem_id);
    
        // returns the associated object
        return $this->cadcontacorrenteorigem;
    }
    
    
    /**
     * Method set_cadcontacorrente
     * Sample of usage: $movcontacorrente->cadcontacorrente = $object;
     * @param $object Instance of Cadcontacorrente
     */
    public function set_cadcontacorrente(Cadcontacorrente $object)
    {
        $this->cadcontacorrente = $object;
        $this->cadcontacorrente_id = $object->id;
    }
    
    /**
     * Method get_cadcontacorrente
     * Sample of usage: $movcontacorrente->cadcontacorrente->attribute;
     * @returns Cadcontacorrente instance
     */
    public function get_cadcontacorrente()
    {
        // loads the associated object
        if (empty($this->cadcontacorrente))
            $this->cadcontacorrente = new Cadcontacorrente($this->cadcontacorrente_id);
    
        // returns the associated object
        return $this->cadcontacorrente;
    }
    public function get_nome_contacorrente()
    {
        // loads the associated object
        if (empty($this->cadcontacorrente))
            $this->cadcontacorrente = new Cadcontacorrente($this->cadcontacorrente_id);
    
        // returns the associated object
        return $this->cadcontacorrente->id . ' - ' . $this->cadcontacorrente->contacorrente;
    }    
    
    /**
     * Method addMovplanoconta
     * Add a Movplanoconta to the Movcontacorrente
     * @param $object Instance of Movplanoconta
     */
    public function addMovplanoconta(Movplanoconta $object)
    {
        $this->movplanocontas[] = $object;
    }
    
    /**
     * Method getMovplanocontas
     * Return the Movcontacorrente' Movplanoconta's
     * @return Collection of Movplanoconta
     */
    public function getMovplanocontas()
    {
        return $this->movplanocontas;
    }
    
    /**
     * Method set_system_user
     * Sample of usage: $movcontacorrente->system_user = $object;
     * @param $object Instance of SystemUser
     */
    public function set_system_user(SystemUser $object)
    {
        $this->system_user = $object;
        $this->system_user_id = $object->id;
    }
    
    /**
     * Method get_system_user
     * Sample of usage: $movcontacorrente->system_user->attribute;
     * @returns SystemUser instance
     */
    public function get_system_user()
    {
        // loads the associated object
        if (empty($this->system_user))
            $this->system_user = new SystemUser($this->system_user_id);
    
        // returns the associated object
        return $this->system_user;
    }

    public function get_login_systemuser()
    {
        // loads the associated object
        if (empty($this->system_user))
            $this->system_user = new SystemUser($this->system_user_id);
    
        // returns the associated object
        return $this->system_user->login;
    }        

    /**
     * Reset aggregates
     */
    public function clearParts()
    {
        $this->movplanocontas = array();
    }

    /**
     * Load the object and its aggregates
     * @param $id object ID
     */
    public function load($id)
    {
    
        // load the related Movplanoconta objects
        $repository = new TRepository('Movplanoconta');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movcontacorrente_id', '=', $id));
        $this->movplanocontas = $repository->load($criteria);
    
        // load the object itself
        return parent::load($id);
    }

    /**
     * Store the object and its aggregates
     */
    public function store()
    {
        // store the object itself
        parent::store();
    
        // delete the related Movplanoconta objects
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movcontacorrente_id', '=', $this->id));
        $repository = new TRepository('Movplanoconta');
        $repository->delete($criteria);
        // store the related Movplanoconta objects
        if ($this->movplanocontas)
        {
            foreach ($this->movplanocontas as $movplanoconta)
            {
                unset($movplanoconta->id);
                $movplanoconta->movcontacorrente_id = $this->id;
                $movplanoconta->store();
            }
        }
    }

    /**
     * Delete the object and its aggregates
     * @param $id object ID
     */
    public function delete($id = NULL)
    {
        $id = isset($id) ? $id : $this->id;
        // delete the related Movplanoconta objects
        $repository = new TRepository('Movplanoconta');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movcontacorrente_id', '=', $id));
        $repository->delete($criteria);
        
    
        // delete the object itself
        parent::delete($id);
    }


}
