<?php
/**
 * Movimento Active Record
 * @author  <your-name-here>
 */
class Movimento extends TRecord
{
    const TABLENAME = 'movimento';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadalmoxarifado;
    private $cadempresa;
    private $cadpessoa;
    private $cadcondpgto;
    private $movimentoitems;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('cadalmoxarifado_id');
        parent::addAttribute('cadtipooperacao_id');
        parent::addAttribute('cadcaixaccorrenteabertura_id');
        parent::addAttribute('cadcondpgto_id');
        parent::addAttribute('numero');
        parent::addAttribute('serie');
        parent::addAttribute('situacao');
        parent::addAttribute('situacaovenda');
        parent::addAttribute('situacaocompra');
        parent::addAttribute('situacaopedido');
        parent::addAttribute('dataemissao');
        parent::addAttribute('dataentrada');
        parent::addAttribute('datafatura');
        parent::addAttribute('cadnaturezaoperacao_id');
        parent::addAttribute('cadpessoa_id');
        parent::addAttribute('subtotal');
        parent::addAttribute('total');
        parent::addAttribute('frete');
        parent::addAttribute('seguro');
        parent::addAttribute('outras');
        parent::addAttribute('itens');
        parent::addAttribute('desconto');
        parent::addAttribute('margem_desconto');
        parent::addAttribute('icms_base');
        parent::addAttribute('icms_valor');
        parent::addAttribute('icmsst_base');
        parent::addAttribute('icmsst_valor');
        parent::addAttribute('ipi_base');
        parent::addAttribute('ipi_valor');
        parent::addAttribute('pis_base');
        parent::addAttribute('pis_valor');
        parent::addAttribute('cofins_base');
        parent::addAttribute('cofins_valor');
        parent::addAttribute('totalnf');
        parent::addAttribute('transportador_cadpessoa_id');
        parent::addAttribute('frete_conta');
        parent::addAttribute('placa');
        parent::addAttribute('placa_uf');
        parent::addAttribute('vol_qtde');
        parent::addAttribute('vol_especie');
        parent::addAttribute('vol_marca');
        parent::addAttribute('vol_numero');
        parent::addAttribute('peso_liquido');
        parent::addAttribute('peso_bruto');
        parent::addAttribute('obs');
        parent::addAttribute('vfcp');
        parent::addAttribute('vfcpst');
        parent::addAttribute('vfcpstret');
        parent::addAttribute('infcpl');
        parent::addAttribute('nomeconsumidor');
        parent::addAttribute('cpfcnpjconsumidor');
        parent::addAttribute('total_produtos');
        parent::addAttribute('total_servicos');
        parent::addAttribute('desconto_produtos');
        parent::addAttribute('desconto_servicos');
        parent::addAttribute('margem_desconto_produtos');
        parent::addAttribute('margem_desconto_servicos');
        parent::addAttribute('total_dinheiro');
        parent::addAttribute('total_cheque');
        parent::addAttribute('total_cartao');
        parent::addAttribute('total_crediario');
        parent::addAttribute('total_credito');
        parent::addAttribute('vendedor_cadpessoa_id');
    }

    
    /**
     * Method set_cadalmoxarifado
     * Sample of usage: $movimento->cadalmoxarifado = $object;
     * @param $object Instance of Cadalmoxarifado
     */
    public function set_cadalmoxarifado(Cadalmoxarifado $object)
    {
        $this->cadalmoxarifado = $object;
        $this->cadalmoxarifado_id = $object->id;
    }
    
    /**
     * Method get_cadalmoxarifado
     * Sample of usage: $movimento->cadalmoxarifado->attribute;
     * @returns Cadalmoxarifado instance
     */
    public function get_cadalmoxarifado()
    {
        // loads the associated object
        if (empty($this->cadalmoxarifado))
            $this->cadalmoxarifado = new Cadalmoxarifado($this->cadalmoxarifado_id);
    
        // returns the associated object
        return $this->cadalmoxarifado;
    }
    
    
    /**
     * Method set_cadempresa
     * Sample of usage: $movimento->cadempresa = $object;
     * @param $object Instance of Cadempresa
     */
    public function set_cadempresa(Cadempresa $object)
    {
        $this->cadempresa = $object;
        $this->cadempresa_id = $object->id;
    }
    
    /**
     * Method get_cadempresa
     * Sample of usage: $movimento->cadempresa->attribute;
     * @returns Cadempresa instance
     */
    public function get_cadempresa()
    {
        // loads the associated object
        if (empty($this->cadempresa))
            $this->cadempresa = new Cadempresa($this->cadempresa_id);
    
        // returns the associated object
        return $this->cadempresa;
    }
    
    
    /**
     * Method set_cadpessoa
     * Sample of usage: $movimento->cadpessoa = $object;
     * @param $object Instance of Cadpessoa
     */
    public function set_cadpessoa(Cadpessoa $object)
    {
        $this->cadpessoa = $object;
        $this->cadpessoa_id = $object->id;
    }
    
    /**
     * Method get_cadpessoa
     * Sample of usage: $movimento->cadpessoa->attribute;
     * @returns Cadpessoa instance
     */
    public function get_cadpessoa()
    {
        // loads the associated object
        if (empty($this->cadpessoa))
            $this->cadpessoa = new Cadpessoa($this->cadpessoa_id);
    
        // returns the associated object
        return $this->cadpessoa;
    }
    
    
    /**
     * Method set_cadcondpgto
     * Sample of usage: $movimento->cadcondpgto = $object;
     * @param $object Instance of Cadcondpgto
     */
    public function set_cadcondpgto(Cadcondpgto $object)
    {
        $this->cadcondpgto = $object;
        $this->cadcondpgto_id = $object->id;
    }
    
    /**
     * Method get_cadcondpgto
     * Sample of usage: $movimento->cadcondpgto->attribute;
     * @returns Cadcondpgto instance
     */
    public function get_cadcondpgto()
    {
        // loads the associated object
        if (empty($this->cadcondpgto))
            $this->cadcondpgto = new Cadcondpgto($this->cadcondpgto_id);
    
        // returns the associated object
        return $this->cadcondpgto;
    }
    
    
    /**
     * Method addMovimentoitem
     * Add a Movimentoitem to the Movimento
     * @param $object Instance of Movimentoitem
     */
    public function addMovimentoitem(Movimentoitem $object)
    {
        $this->movimentoitems[] = $object;
    }
    
    /**
     * Method getMovimentoitems
     * Return the Movimento' Movimentoitem's
     * @return Collection of Movimentoitem
     */
    public function getMovimentoitems()
    {
        return $this->movimentoitems;
    }

    /**
     * Reset aggregates
     */
    public function clearParts()
    {
        $this->movimentoitems = array();
    }

    /**
     * Load the object and its aggregates
     * @param $id object ID
     */
    public function load($id)
    {
    
        // load the related Movimentoitem objects
        $repository = new TRepository('Movimentoitem');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movimento_id', '=', $id));
        $this->movimentoitems = $repository->load($criteria);
    
        // load the object itself
        return parent::load($id);
    }

    /**
     * Store the object and its aggregates
     */
    public function store()
    {
        // store the object itself
        parent::store();
    
        // delete the related Movimentoitem objects
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movimento_id', '=', $this->id));
        $repository = new TRepository('Movimentoitem');
        $repository->delete($criteria);
        // store the related Movimentoitem objects
        if ($this->movimentoitems)
        {
            foreach ($this->movimentoitems as $movimentoitem)
            {
                unset($movimentoitem->id);
                $movimentoitem->movimento_id = $this->id;
                $movimentoitem->store();
            }
        }
    }

    /**
     * Delete the object and its aggregates
     * @param $id object ID
     */
    public function delete($id = NULL)
    {
        $id = isset($id) ? $id : $this->id;
        // delete the related Movimentoitem objects
        $repository = new TRepository('Movimentoitem');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movimento_id', '=', $id));
        $repository->delete($criteria);
        
    
        // delete the object itself
        parent::delete($id);
    }


}
